/*
本地文件遍历
 */

var util = require("util"),EventEmitter =require("events").EventEmitter;
var fs = require("fs");

function LocalPathIterator(option,subDirs){
    this.subDirs= new Array();
    if(subDirs){
        for(var i=0;i<subDirs.length ;i++){
            this.subDirs.push(subDirs[i]);
        }
    }

    this.option = option;
    this.path="";
    this.abort=false;
}

//添加事件监听机制
util.inherits(LocalPathIterator,EventEmitter);


LocalPathIterator.prototype.setAbort = function (abort = true) {
    this.abort = abort;
}


LocalPathIterator.prototype.start = function(){
    var self = this;

    if(this.subDirs.length === 0){
        this.emit("finished",this);
        return;
    }
    if(self.abort){
        this.emit("finished",this);
        return;
    }
    this.path=this.subDirs.shift();
    fs.readdir(this.path,function(err,files){
        if(self.path[self.path.length-1] === '/'){
            self.path=self.path.substring(0,self.path.length-1);
        }

        //创建文件夹
        var floderInfo = {path:self.path+"/"};
        self.emit("floderFound",self,floderInfo);

        if(err){
            logger.error("readdir error",err);
            self.emit("warning",err,self.path);
            self.start();
            return;
        }
        self.dealFilesInOneFolder(files);

    });
};

LocalPathIterator.prototype.dealFilesInOneFolder = function (files) {
    var self = this;
    var file = files.shift();
    if (!file) {
        //files已经处理完毕，继续执行
        self.start();
        return;
    }
    var path = self.path + "/" + file;
    fs.lstat(path, function (err, stat) {
        if(self.abort){
            this.emit("finished",this);
            return;
        }
        if (err) {
            global.logger.error('Iterator path catch err:', self.path, err);
            self.emit("fileFound", self, {path: path, size: 0});
        }
        else if (stat.isSymbolicLink()) {
            global.logger.warn('ignore symbolicLink ', path);
        }
        else if (stat.isDirectory()) {
            self.subDirs.push(path);
        }
        else {
            var fileInfo = {path: path, size: stat.size};
            self.emit("fileFound", self, fileInfo);
        }
        self.dealFilesInOneFolder(files);
    });
}

exports = module.exports = LocalPathIterator;

