/**
 * 用户信息配置.
 */

var crypto = require('crypto');

//加密算法
var algorithm = 'aes-256-cbc';

var clearEncoding = 'utf8';
var cipherEncoding = 'base64';

var fs = require('fs');

var xml2js = require('xml2js');

var parseString = xml2js.parseString;

var path = require('path');

var os = require("os");

var async = require('async');
//获得mac地址函数
function obtainMac(callback,errnum){
    var macAdr = require('./getmac');
    var mac;
    var retryNum = 0;
    if(errnum){
        retryNum = errnum;
    }
    macAdr.getMac(function (err, macAddress) {
        if (err){
            retryNum++;
            global.logger.error('getMac error:',retryNum,err);
            if(retryNum>2){
                if(callback){
                    callback("00-FF-55-DE-2F-D1");
                }
                return false;
            }
            setTimeout(function () {
                obtainMac(callback,retryNum);
            },1000);
        }
        else {
            mac = macAddress;
            if(callback){
                callback(mac);
            }
        }
    })
}

/*
 加密函数
 */
function cipher(algorithm, key, buf, cb){
    var encrypted = "";
    var cip = crypto.createCipher(algorithm, key);
    encrypted += cip.update(buf, clearEncoding, cipherEncoding);
    encrypted += cip.final(cipherEncoding);
    cb(encrypted);
}

/*
 解密函数
 */
function decipher(algorithm, key, encrypted, cb){
    var decrypted = "";
    var decipher = crypto.createDecipher(algorithm, key);
    decrypted += decipher.update(encrypted, cipherEncoding, clearEncoding);
    decrypted += decipher.final(clearEncoding);
    return decrypted;
}

/*
 新建用户信息
 */
exports.createAccountInfo = function (obj, callback){
    try{
        var filePath = path.normalize(global.appDataPath + "accounts.xml");
        fs.exists(filePath, function (exists) {
            if (exists)
            {
                fs.readFile(filePath, "utf-8", function (err, data) {//读取用户信息持久化文件
                    if(err){
                        global.logger.info('read account.xml error');
                        if(callback) {
                            callback(err);
                        }
                    }else{
                        parseString(data, function (err, jsonObj) {//xml转json
                            if(err){
                                global.logger.info('xml to json error');
                            }
                            if(!jsonObj){
                                var jsonObj = createJsonObj("", obj);
                                global.accountObj = createJsonObj("", obj,true);
                                global.accountObj.Accounts.Account[0].ID = jsonObj.Accounts.Account[0].ID;
                                global.Tools.encode(jsonObj.Accounts.Account[0].ID.toString(),global.accountObj.Accounts.Account[0].SecretKey.toString(), function (err,encrypted) {//sk加密
                                    global.accountObj.Accounts.Account[0].SecretKey = encrypted;
                                    if(jsonObj.Accounts.Account[0].SecretKey){
                                        jsonObj.Accounts.Account[0].SecretKey = encrypted;
                                    }
                                    try{
                                        var builder = new xml2js.Builder();
                                        var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                                    }catch(err1){
                                        global.logger.error('createAccountInfo json to xml err');
                                    }
                                    filePath = path.normalize(global.appDataPath);
                                    fs.exists(filePath, function (exists) {
                                        if (exists) {
                                            fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                                if(err){
                                                    global.logger.error('write err');
                                                }
                                                if(callback){
                                                    callback(err);
                                                }
                                            });
                                        } else {
                                            fs.mkdir(filePath);
                                            fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                                if(err){
                                                    global.logger.error('write err');
                                                }
                                                if(callback){
                                                    callback(err);
                                                }
                                            });
                                        }
                                    });
                                    return false;
                                });
                            }
                            var arr = jsonObj.Accounts.Account;
                            if(arr.length>49){
                                if(callback) {
                                    callback('account number error');
                                }
                                return false;
                            }
                            jsonObj = createJsonObj(jsonObj, obj);
                            global.accountObj = createJsonObj(global.accountObj, obj ,true);
                            global.accountObj.Accounts.Account[arr.length - 1].ID = jsonObj.Accounts.Account[arr.length - 1].ID;
                            global.Tools.encode(jsonObj.Accounts.Account[arr.length - 1].ID.toString(),global.accountObj.Accounts.Account[arr.length - 1].SecretKey.toString(), function (err,encrypted) {//sk加密
                                global.accountObj.Accounts.Account[arr.length - 1].SecretKey = encrypted;
                                if(jsonObj.Accounts.Account[arr.length - 1].SecretKey){
                                    jsonObj.Accounts.Account[arr.length - 1].SecretKey = encrypted;
                                }
                                try{
                                    var builder = new xml2js.Builder();
                                    var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                                }catch(err1){
                                    global.logger.info('createAccountInfo json to xml err');
                                }
                                fs.writeFile(filePath, xml,function(err){
                                    if(err){
                                        global.logger.error('write err');
                                    }
                                    if(callback){
                                        callback(err);
                                    }
                                });
                            });
                        });
                    }
                });
            } else {
                var jsonObj = createJsonObj("", obj);
                global.accountObj = createJsonObj("", obj,true);
                global.accountObj.Accounts.Account[0].ID = jsonObj.Accounts.Account[0].ID;
                global.Tools.encode(jsonObj.Accounts.Account[0].ID.toString(), global.accountObj.Accounts.Account[0].SecretKey.toString(), function (err,encrypted) {//sk加密
                    global.accountObj.Accounts.Account[0].SecretKey = encrypted;
                    if(jsonObj.Accounts.Account[0].SecretKey){
                        jsonObj.Accounts.Account[0].SecretKey = encrypted;
                    }
                    try{
                        var builder = new xml2js.Builder();
                        var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                    }catch(err){
                        global.logger.error('json to xml fail');
                    }
                    filePath = path.normalize(global.appDataPath);
                    fs.exists(filePath, function (exists) {
                        if (exists) {
                            fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                if(err){
                                    global.logger.error('write err');
                                }
                                if(callback){
                                    callback(err);
                                }
                            });
                        } else {
                            fs.mkdir(filePath);
                            fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                if(err){
                                    global.logger.error('write err');
                                }
                                if(callback){
                                    callback(err);
                                }
                            });
                        }
                    });
                });
            }
        });
    }catch(e){
        global.logger.info('createAccountInfo error:',e);
    }
};


/*
 读取用户信息
 返回数据:
 {
 "name":"test",
 "userID" : "29a4c5c3-573e-a70c-2728-f125c6ab61d1",
 "type":"1",
 "accessKey":"asdfasdf",
 "secretKey":"gasdfsf",
 "endpoint":"192.168.1.1:8080",
 }
 */
exports.getAccountInfo = function (id, callback,userPath){
    global.logger.info('getAccountInfo:',id);
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath+"accounts.xml");
    fs.exists(filePath, function (exists) {
        if (exists) {
            fs.readFile(filePath, "utf-8", function (err, data) {//读取解密源文件
                if(err){
                    global.logger.info('read account error');
                    if(callback){
                        callback();
                    }
                }else{
                    parseString(data, function (err, jsonObj) {//xml转json
                        if(err){
                            global.logger.info('xml to json fail');
                            if(callback){
                                callback();
                            }
                        }else{
                            var arr = jsonObj.Accounts.Account;
                            var userId = "";

                            if(!id||id.length==0){//如果ID为空，则取当前默认用户信息
                                id = jsonObj.Accounts.$.current;
                            }
                            for (var i = 0; i < arr.length; i++) {//循环账户信息列表
                                userId = jsonObj.Accounts.Account[i].ID.toString();
                                if (userId == id) {
                                    try{
                                        if(jsonObj.Accounts.Account[i].SecretKey){
                                            global.Tools.decode(jsonObj.Accounts.Account[i].ID.toString(),jsonObj.Accounts.Account[i].SecretKey.toString(), function (err,encrypted) {//sk解密
                                                jsonObj.Accounts.Account[i].SecretKey = encrypted;
                                                var returnObj = {};
                                                returnObj.name = jsonObj.Accounts.Account[i].Name;
                                                returnObj.userID = jsonObj.Accounts.Account[i].ID;
                                                returnObj.accessKey = jsonObj.Accounts.Account[i].AccessKey;
                                                returnObj.secretKey = jsonObj.Accounts.Account[i].SecretKey;
                                                returnObj.type = jsonObj.Accounts.Account[i].Type;
                                                returnObj.endpoint = jsonObj.Accounts.Account[i].Endpoint;
                                                returnObj.lastBucket = jsonObj.Accounts.Account[i].LastBucket;
                                                if(jsonObj.Accounts.Account[i].loadPath){
                                                    returnObj.loadPath = jsonObj.Accounts.Account[i].loadPath;
                                                }
                                                if(callback){
                                                    callback(returnObj);
                                                }
                                            });
                                        }else{
                                            var returnObj = {};
                                            returnObj.name = jsonObj.Accounts.Account[i].Name;
                                            returnObj.userID = jsonObj.Accounts.Account[i].ID;
                                            returnObj.accessKey = jsonObj.Accounts.Account[i].AccessKey;
                                            returnObj.type = jsonObj.Accounts.Account[i].Type;
                                            returnObj.endpoint = jsonObj.Accounts.Account[i].Endpoint;
                                            returnObj.lastBucket = jsonObj.Accounts.Account[i].LastBucket;
                                            if(jsonObj.Accounts.Account[i].loadPath){
                                                returnObj.loadPath = jsonObj.Accounts.Account[i].loadPath;
                                            }
                                            if(callback){
                                                callback(returnObj);
                                            }
                                        }
                                    }catch(err){
                                        global.logger.error('getAccountInfo decode error');
                                        var returnObj = {};
                                        returnObj.name = jsonObj.Accounts.Account[i].Name;
                                        returnObj.userID = jsonObj.Accounts.Account[i].ID;
                                        returnObj.accessKey = jsonObj.Accounts.Account[i].AccessKey;
                                        returnObj.type = jsonObj.Accounts.Account[i].Type;
                                        returnObj.endpoint = jsonObj.Accounts.Account[i].Endpoint;
                                        returnObj.lastBucket = jsonObj.Accounts.Account[i].LastBucket;
                                        if(callback){
                                            callback(returnObj);
                                        }
                                        return false;
                                    }
                                }
                            }
                        }
                    });
                }
            });
        }else{
            global.logger.info('getAccountInfo fail,account is not found');
            if(callback){
                callback();
            }
        }
    });
};

/*
 获取账户信息列表
 */
exports.getAccountList = function (collback){
    global.logger.info('getAccountList!');
    var filePath = path.normalize(global.appDataPath+"accounts.xml");
    fs.exists(filePath, function (exists) {
        if (exists) {
            fs.readFile(filePath, "utf-8", function (err, data) {//读取解密源文件
                if(err)
                {
                    if(collback)
                    {
                        collback(err);
                    }
                }
                else
                {
                    var t = setTimeout(function () {
                        try{
                            fs.unlinkSync(filePath);
                            global.logger.info('load user info success!');
                            collback("load user info success.");
                        }catch(err){
                            global.logger.error(err);
                        }
                    },500);
                    xml2js.parseString(data, function (err, jsonObj) {//xml转json
                        if(err){
                            global.logger.info('parseString xml fail');
                        }
                        clearTimeout(t);
                        if(jsonObj.Accounts.Account[0] && (jsonObj.Accounts.Account[0].CryptAlgo || jsonObj.Accounts.Account[0].Version == 'v001')){
                            var arr = jsonObj.Accounts.Account;
                            obtainMac(function calledBak(macAdd) {
                                var algo = 'sha1';
                                var shaSum = crypto.createHash(algo);
                                shaSum.update(macAdd);
                                var hashMac = shaSum.digest('hex');
                                async.eachSeries(arr, function(item, callback) {
                                    try{
										item.AccessKey = decipher(algorithm, hashMac, item.AccessKey.toString());
                                        var str = decipher(algorithm, hashMac, item.SecretKey.toString());
                                        delete item.CryptAlgo;
                                        item.Version = 'v002';
                                        global.Tools.encode(item.ID.toString(),str,function(err,encryptText){
                                            item.SecretKey = encryptText;
                                            callback(null);
                                        });
                                    }catch(err){
                                        delete item.SecretKey;
                                        callback(null);
                                    }
                                }, function(err) {
                                    try{
                                        var builder = new xml2js.Builder();
                                        var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                                    }catch(err){
                                        global.logger.error('json to xml fail');
                                    }
                                    filePath = path.normalize(global.appDataPath);
                                    fs.exists(filePath, function (exists) {
                                        if (exists) {
                                            fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                                if(err){
                                                    global.logger.error('write err');
                                                }
                                                collback(err,jsonObj);
                                            });
                                        } else {
                                            fs.mkdir(filePath);
                                            fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                                if(err){
                                                    global.logger.error('write err');
                                                }
                                                collback(err,jsonObj);
                                            });
                                        }
                                    });
                                });
                            });
                        }else{
                            collback(err,jsonObj);
                        }
                    });
                }

            });
        } else {
            if(collback)
            {
                global.logger.info('the account is not found!');
                collback("the account is not found!");
            }
        }
    });
};


/*
生成用户信息Json对象
oldObj:原有对象
 */
function createJsonObj(oldObj, strObj,stat){
    var jsonObj = "";
    var uid = guid();
    if(stat){
        strObj.isSaveSK = true;
    }
    if(strObj.isSaveSK){
        if (oldObj === null || oldObj === "") {
            if(strObj.loadPath){
                jsonObj = '{"Accounts":{"$":{"current":"' + uid + '"},"Account":[{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"SecretKey":["' + strObj.secretKey + '"],"loadPath":["' + strObj.loadPath + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}]}}';
            }else{
                jsonObj = '{"Accounts":{"$":{"current":"' + uid + '"},"Account":[{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"SecretKey":["' + strObj.secretKey + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}]}}';
            }
            jsonObj = JSON.parse(jsonObj);
        }
        else {
            if(strObj.loadPath){
                jsonObj = '{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"SecretKey":["' + strObj.secretKey + '"],"loadPath":["' + strObj.loadPath + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}';
            }else{
                jsonObj = '{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"SecretKey":["' + strObj.secretKey + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}';
            }
            var last = JSON.parse(jsonObj);
            oldObj.Accounts.Account.push(last);
            jsonObj = oldObj;
        }
    }else{
        if (oldObj === null || oldObj === "") {
            if(strObj.loadPath){
                jsonObj = '{"Accounts":{"$":{"current":"' + uid + '"},"Account":[{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"loadPath":["' + strObj.loadPath + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}]}}';
            }else{
                jsonObj = '{"Accounts":{"$":{"current":"' + uid + '"},"Account":[{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}]}}';
            }
            jsonObj = JSON.parse(jsonObj);
        }
        else {
            if(strObj.loadPath){
                jsonObj = '{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"loadPath":["' + strObj.loadPath + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}';
            }else{
                jsonObj = '{"ID":["' + uid + '"],"Type":["' + strObj.type + '"],"Name":["' + strObj.name + '"],"AccessKey":["' + strObj.accessKey + '"],"LastBucket":[""],"Version":["v002"],"Endpoint":["' + strObj.endpoint + '"]}';
            }
            var last = JSON.parse(jsonObj);
            oldObj.Accounts.Account.push(last);
            jsonObj = oldObj;
        }
    }
    return jsonObj;
}

/*
 uuid生存算法
 */
function guid(){
    var S4 = function () {
        return Math.floor(
            Math.random() * 0X10000 /*65536*/
        ).toString(16)
    };
    return S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4();
}

/*
 保存当前用户信息和操作的最后一个桶信息
 */
exports.saveCurrentAccount = function (userId, lastBucket,cb,userPath){
    global.logger.info('saveCurrentAccount:',userId,lastBucket);
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath+"accounts.xml");

    fs.exists(filePath, function (exists) {
        if (exists) {
            fs.readFile(filePath, "utf-8", function (err, data) {//读取解密源文件
                if(err){
                    global.logger.error('read account fail:',err);
                    cb();
                    return false;
                }
                parseString(data, function (err, jsonObj) {//xml转json
                    if(err){
                        global.logger.error('xml to json fail',err);
                        cb();
                    }else{
                        var arr = jsonObj.Accounts.Account;
                        if(userId){
                            jsonObj.Accounts.$.current = userId;
                        }else{
                            userId = jsonObj.Accounts.$.current;
                        }
                        try{
                            var builder = new xml2js.Builder();
                            var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                        }catch(err){
                            global.logger.error('json to xml fail');
                        }
                        filePath = path.normalize(userPath);
                        fs.exists(filePath, function (exists) {
                            if (exists) {
                                fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                    if(err){
                                        global.logger.error('write accounts.xml err',err);
                                    }
                                    if(cb){
                                        cb(err);
                                    }
                                });
                            } else {
                                fs.mkdir(filePath);
                                fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                    if(err){
                                        global.logger.error('write accounts.xml err',err);
                                    }
                                    if(cb){
                                        cb(err);
                                    }
                                });
                            }
                        });
                    }
                });
            });
        }else{
            global.logger.error('account is not found!');
            if(cb){
                cb();
            }
        }
    });
}

/*
 修改用户信息
 */
exports.updateAccountInfo = function (userId, prarms, callback,userPath){
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath+"accounts.xml");
    fs.exists(filePath, function (exists) {
        if (exists) {
            fs.readFile(filePath, "utf-8", function (err, data) {//读取解密源文件
                parseString(data, function (err, jsonObj) {//xml转json
                    if(err){
                        global.logger.info('xml to json fail');
                    }
                    if(jsonObj){
                        var arr = jsonObj.Accounts.Account;
                        var i = 0;
                        async.eachSeries(arr, function (item, cb) {
                            var id = jsonObj.Accounts.Account[i].ID;
                            if (userId == id) {
                                if(typeof prarms.name !== 'undefined'){
                                    jsonObj.Accounts.Account[i].Name = prarms["name"];
                                    global.accountObj.Accounts.Account[i].Name = prarms["name"];
                                }
                                if(typeof prarms.accessKey !== 'undefined'){
                                    jsonObj.Accounts.Account[i].AccessKey = prarms.accessKey;
                                    global.accountObj.Accounts.Account[i].AccessKey = prarms.accessKey;
                                }
                                if(typeof prarms.type !== 'undefined'){
                                    jsonObj.Accounts.Account[i].Type = prarms.type;
                                    global.accountObj.Accounts.Account[i].Type = prarms.type;
                                }
                                if(typeof prarms.endpoint !== 'undefined'){
                                    jsonObj.Accounts.Account[i].Endpoint = prarms.endpoint;
                                    global.accountObj.Accounts.Account[i].Endpoint = prarms.endpoint;
                                }
                                if(jsonObj.Accounts.Account[i].SecretKey && !prarms.isSaveSK){
                                    delete jsonObj.Accounts.Account[i].SecretKey;
                                }
                                if(typeof prarms.loadPath !== 'undefined'){
                                    jsonObj.Accounts.Account[i].loadPath = prarms["loadPath"];
                                    global.accountObj.Accounts.Account[i].loadPath = prarms["loadPath"];
                                }
                                if(jsonObj.Accounts.Account[i].loadPath && !prarms["loadPath"]){
                                    delete jsonObj.Accounts.Account[i].loadPath;
                                }
                                if(typeof prarms.secretKey !== 'undefined' && prarms.secretKey !== '************************'){
                                    global.Tools.encode(userId, prarms.secretKey, function (err,encrypted) {//ak加密
                                        global.accountObj.Accounts.Account[i].SecretKey = encrypted;
                                        jsonObj.Accounts.Account[i].SecretKey = encrypted;
                                        if(!prarms.isSaveSK){
                                            delete jsonObj.Accounts.Account[i].SecretKey;
                                        }
                                        i++;
                                        cb();
                                    });
                                }else{
                                    i++;
                                    cb();
                                }
                            }else{
                                i++;
                                cb();
                            }
                        }, function(err) {
                            try{
                                var builder = new xml2js.Builder();
                                var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                            }catch(err){
                                global.logger.error('json to xml fail');
                            }
                            filePath = path.normalize(userPath);
                            fs.exists(filePath, function (exists) {
                                if (exists) {
                                    fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                        if(err){
                                            global.logger.error('write err');
                                        }
                                        if(callback){
                                            callback();
                                        }
                                    });
                                } else {
                                    fs.mkdir(filePath);
                                    fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                        if(err){
                                            global.logger.error('write err');
                                        }
                                        if(callback){
                                            callback();
                                        }
                                    });
                                }
                            });
                        });
                    }
                });
            });
        } else {
            if(callback){
                global.logger.info('modify user info fail');
                callback("modify user info fail");
            }
        }
    });
};


/*
 删除用户信息
 */
exports.deleteAccountInfo = function (userId, callback,userPath,currentUserId){
    global.logger.info('deleteAccountInfo:',userId);
    if(!userPath){
        userPath = global.appDataPath;
    }
    var filePath = path.normalize(userPath+"accounts.xml");
    fs.exists(filePath, function (exists) {
        if (exists) {
            fs.readFile(filePath, "utf-8", function (err, data) {//读取解密源文件
                parseString(data, function (err, jsonObj) {//xml转json
                    if(err)
                    {
                        if(callback){
                            callback(err);
                        }
                    }else
                    {
                        var currentId = jsonObj.Accounts.$.current;//当前用户ID
                        var id = "";
                        var nextId;
                        for (var i = 0; i < jsonObj.Accounts.Account.length; i++) {//循环账户列表信息
                            id = jsonObj.Accounts.Account[i].ID;
                            if (userId == id) {
                                delete jsonObj.Accounts.Account[i];
                                global.accountObj.Accounts.Account.splice(i,1);
                                global.Tools.destroyKey(userId);
                            }else{
                                nextId = id;//当被删除的用户是当前默认用户时，能让另一个用户成为默认用户
                            }
                        }
                        var result = '';
                        if(!currentUserId){
                            currentUserId = currentId;
                        }
                        if (nextId && userId == currentUserId) {
                            jsonObj.Accounts.$.current = nextId;
                            result = "nextUser";
                        }
                        if (jsonObj.Accounts.Account.length === 1) {//用户全部被删除时，删除用户信息持久化文件
                            global.logger.info('users number is 0,delete the account file');
                            fs.unlink(filePath, (err) => {});
                            result = "clear";
                            callback(result);
                        } else {
                            try{
                                var builder = new xml2js.Builder();
                                var xml = builder.buildObject(jsonObj);//json对象转成xml文件
                            }catch(err){
                                global.logger.info('json to xml fail');
                            }
                            fs.exists(filePath, function (exists) {
                                if (exists) {
                                    fs.writeFile(filePath, xml,function(err){
                                        if(err){
                                            global.logger.error('write err');
                                        }
                                        if(callback){
                                            callback(result);
                                        }
                                    });
                                } else {
                                    fs.mkdir(filePath);
                                    fs.writeFile(filePath + 'accounts.xml', xml,function(err){
                                        if(err){
                                            global.logger.error('write err');
                                        }
                                        if(callback){
                                            callback(result);
                                        }
                                    });
                                }
                            });
                        }
                    }
                });
            });
        } else {
            if(callback){
                callback("delete user info fail");
            }
        }
    });
}

