/**
 * MOS 客户端新版本升级功能
 */
(function(win){
    if(require == undefined){
        win.mosUpdate=function(){};
        return;
    }
    var  gui=require("nw.gui");
    var pkg = require('../package.json');
    var updater = require('./updater.js');
    var upd = new updater(pkg);
    var fs=require('fs');
    var copyPath, execPath;
    var dialogContent;
    var refshTime;
	var temp = false;

    win.upd = upd;
    if(gui.App.argv.length == 2) {
        // ------------- Step 5 -------------
        copyPath = gui.App.argv[0];
        execPath = gui.App.argv[1];
        logger.info(copyPath+'-------'+execPath);


        // Replace old app, Run updated app from original location and close temp instance


        setTimeout(function(){
            upd.install(copyPath, function(err) {
                if(!err) {
                    // ------------- Step 6 -------------
                    gui.Window.get().hide();
                    var del = require('./node_modules/del');
                    var path = require('path');
                    var timeout = setTimeout(function () {//延迟3秒执行
                        upd.run(execPath,[],{});
                        logger.info(copyPath+'---step 6----'+execPath);
                        gui.App.quit();
                    },3000);

                    //如果是DT版本，则删除language目录
                    if(UCDVersion==='DT'){
                        var delPath = path.normalize(copyPath+'/language');
                        del(delPath, {force: true})
                        .then(()=>{
                            upd.run(execPath,[],{});
                            clearTimeout(timeout);
                            logger.info(copyPath+'---step 6----'+execPath);
                            gui.App.quit();
                        });
                    }
                }
                else{
                    logger.error(err);
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    mui.overlay('on', {"static": true,keyboard:false});
                    $('.mui-model').showErrorMessage({
                        message:languageJson.newVersionInstallFail,
                        ok:function(){
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                        }
                    });
                }

            });
        },500);
    }
    else{


    }

    win.unpack=function(filename,manifest){
        upd.unpack(filename, function(error, newAppPath) {
            if (!error) {
                $(".mui-model .mui-model-title").html(languageJson.installUpdate);
                // ------------- Step 4 -------------
                dialogContent.parent().parent().parent().parent().parent().find('.cancel').click();
                showOverlay();
                $('.mui-model').showMessage({
                    type:'info',
                    message: languageJson.startInstallAndRestart+'</br><span style="font-size: 12px;">'+languageJson.obs_browser_upgrade_msg+'</span>',
                    ok: function () {
                        upd['newAppPath']=newAppPath;
                        gui.Window.get().close();
                        return false;
                    },
                    cancel: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        $('#checkUpdate').removeClass('update-version-disabled');
                        $('#checkUpdate').addClass('mui-icon-checkVersion');
                        return false;
                    },
                    title: languageJson.updating
                });
            }
            else{
                global.logger.error("unpack failed.", error)
                dialogContent.html(languageJson.decompressionFailReason);
                dialogContent.parent().parent().find('td').eq(0).html('<img src="images/dialog_error.png"/>');
                dialogContent.parent().parent().parent().parent().parent().find('.cancel').removeClass('mui-hide');
            }
            temp = false;
        }, manifest);
    };

    win.download=function(manifest){
        dialogContent=$("#dProgress").parent();
        var dPer=dialogContent.find('.mui-progress-per');
        dialogContent.parent().parent().parent().parent().parent().find('.cancel').addClass('mui-hide');
        dialogContent.parent().parent().parent().parent().parent().find('hr').addClass('mui-hide');
        upd.download(function(error, filename,etag) {
                if (!error&&temp) {
                    // ------------- Step 3 -------------
                    if(etag){
                        dialogContent.html(languageJson.downOverToDecompression);
                        dialogContent.parent().parent().parent().parent().parent().find("img").attr("src","icons/mask-loading.gif");
                        var body = fs.createReadStream(filename);
                        var AWS = require('./node_modules/hws-sdk');
                        AWS.util.crypto.sha256(body, 'hex',function(err,data){
                            if(data === etag){
                                dialogContent.html(languageJson.checkTrueToDecompression);
								global.logger.info('download update file success:',filename,manifest);
                                win.unpack(filename,manifest);
                            }
                            else{
                                dialogContent.html(languageJson.checkFalseToUpdate);
                                dialogContent.parent().parent().find('td').eq(0).html('<img src="images/dialog_error.png"/>');
                                dialogContent.parent().parent().parent().parent().parent().find('.ok').removeClass('mui-hide');
                                dialogContent.parent().parent().parent().parent().parent().find('.cancel').removeClass('mui-hide');
                            }
                        });
                    }
                    else{
                        dialogContent.html(languageJson.downOverToDecompression);
                        dialogContent.parent().parent().parent().parent().parent().find("img").attr("src","icons/mask-loading.gif");
                        global.logger.info('download update file success:',filename,manifest);
                        win.unpack(filename,manifest);
                    }

                }else{
                    dialogContent.html(languageJson.downFailReason);
                    dialogContent.parent().parent().find('td').eq(0).html('<img src="images/dialog_error.png"/>');
                    dialogContent.parent().parent().parent().parent().parent().find('.cancel').removeClass('mui-hide');
                }
            },
            manifest,
            function(e){
                // 下载进度 如：67%
                e=e+'%';
                dPer.css({width:e});
            }
        );
    };
    win.mosUpdate=function(btnClicked){
        //可配置的升级服务器地址
        if(updateServer){
            upd.manifest.manifestUrl = updateServer;
        }
        logger.info('upd.manifest.manifestUrl===',upd.manifest.manifestUrl);
        // ------------- Step 1-------------
        var loading = false;
        if(btnClicked){
            loading=loadingShow();
        }
        temp = true;
        upd.checkNewVersion(function(error, newVersionExists, manifest) {
            logger.info("check version result:",error, newVersionExists, manifest);
            var versionShow = false;
            var LastUpdateDate = false;
            var LastUpdateInfo = "";
            if(manifest) {
                versionShow = manifest.newVersion ? manifest.newVersion : manifest.version;
                LastUpdateDate = manifest.LastUpdateDate;
                if(language === 'zh'){
                    LastUpdateInfo = manifest.LastUpdateInfoZh;
                }else {
                    LastUpdateInfo = manifest.LastUpdateInfoEn;
                }

            }

            if(loading){
                loading.close();
            }
            if (!error && newVersionExists) {
                // ------------- Step 2 -------------
                if('try' === btnClicked){
                    setTimeout(function(){
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        mui.overlay('on', {"static": true,keyboard:false});
                        $('.mui-model').showMessage({
                            type:"info",
                            message:'<div id="dProgress" class="mui-progress1"><div id="progressDiv" class="mui-progress-per"></div><div id="progressVal" class="mui-progress-val">0%</div></div>',
                            title:languageJson.downUpdateFile+versionShow,
                            ok:function(model){
                                setTimeout(function(){
                                    win.mosUpdate('try');
                                },200);
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                            },
                            cancel: function () {
                                //取消更新什么都不做
                                //还原页面升级按钮
                                temp = false;
                                $("#updateVersion").removeClass("mui-disabled");
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                            },
                            okHide:true
                        });
                        win.download(manifest);
                    },200);
                }
                else{
                    setTimeout(function(){
                        $('#checkUpdate').addClass('update-version-disabled');
                        $('#checkUpdate').removeClass('mui-icon-checkVersion');
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        var msg = languageJson.isUpdateNow;
                        if(versionShow && LastUpdateDate){
                            msg = msg +"</br>"
                                + languageJson.targetVersion + versionShow +"</br>"
                                + languageJson.dateOfLastUpdate + LastUpdateDate;
                        }
                        if(LastUpdateInfo){
                            msg = msg +"</br>" + languageJson.obs_browser_upgradeTip_label + LastUpdateInfo + "</br>";
                        }
                        if ($(".mui-model.mui-model-mini").hasClass('shown')) {
                            return false;
                        }
                        showOverlay();
                        $('.mui-model').showMessage({
                            type:"info",
                            message:msg,
                            title:languageJson.versionUpdate,
                            ok:function(){
                                // 有任务提示去结束任务再升级
                                var unfinishedStr = $("#runingTaskCount").text();
                                var count = parseInt(unfinishedStr.replace(/[^\d\.-]/g, ""));
                                if(count > 0){
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    setTimeout(function () {
                                        $('.mui-model').showMessage(
                                            {
                                                type: "warning",
                                                message: languageJson.isUpdateHasRunning,
                                                ok: function () {
                                                    $('#checkUpdate').removeClass('update-version-disabled');
                                                    $('#checkUpdate').addClass('mui-icon-checkVersion');
                                                    return false;
                                                },
                                                title: languageJson.warning
                                            }
                                        );
                                    }, 200);
                                }else{
                                    setTimeout(function(){
                                        $('.mui-model').showMessage({
                                            message:'<div id="dProgress" class="mui-progress1"><div id="progressDiv" class="mui-progress-per"></div><div id="progressVal" class="mui-progress-val">0%</div></div>',
                                            title:languageJson.downUpdateFile+versionShow,
                                            ok:function(model){
                                                setTimeout(function(){
                                                    win.mosUpdate('try');
                                                },200);
                                                if ($("#mui-overlay").size() > 0) {
                                                    mui.overlay('off');
                                                }
                                            },
                                            cancel: function () {
                                                //取消更新什么都不做
                                                //还原页面升级按钮
                                                temp = false;
                                                $("#updateVersion").removeClass("mui-disabled");
                                                if ($("#mui-overlay").size() > 0) {
                                                    mui.overlay('off');
                                                }
                                            },
                                            okHide:true,
                                            noClose:true
                                        });
                                        win.download(manifest);
                                    },10);
                                }
                            },
                            cancel: function () {
                                $('#checkUpdate').removeClass('update-version-disabled');
                                $('#checkUpdate').addClass('mui-icon-checkVersion');
                                //取消更新什么都不做
                                //还原页面升级按钮
                                $("#updateVersion").removeClass("mui-disabled");
                                $("#updateVersion").text(languageJson.updateVersion);
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                            }

                        });
                    },2000);
                }
            }
            else if(error && btnClicked){
                setTimeout(function () {
                    var msg=languageJson.checkVersionFail;
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    mui.overlay('on', {"static": true,keyboard:false});
                    $('.mui-model').showMessage({
                        type:"warning",
                        message:msg,
                        isFocus:true,
                        title:languageJson.warning,
                        ok:function(){
                            setTimeout(function(){
                                mosUpdate(btnClicked);
                            },10);
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                        },
                        cancel: function () {
                            //还原页面升级按钮
                            $("#updateVersion").removeClass("mui-disabled");
                            $("#updateVersion").text(languageJson.updateVersion);
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                        }
                    });
                },200);
            }
            else if('Y' === isAutoUpdate  && !btnClicked){
                    //如果是手动点击升级检查，显示提示窗口
                   //启动自动检查更新时，不显示提示框
            }
            else if(btnClicked){
                setTimeout(function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    mui.overlay('on', {"static": true,keyboard:false});
                    $('.mui-model').showMessage({
                        type:"info",
                        message:languageJson.upToDateVersion,
                        title:languageJson.hint,
                        ok:function(){
                            $("#updateVersion").removeClass("mui-disabled");
                            $("#updateVersion").text(languageJson.updateVersion);
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                        }
                    });
                },200);
            }
        });
        upd.on('progress',function(per){
            if(!refshTime){
                refshTime = new Date().getTime();
                per = per+"%";
                $("#progressDiv").css({width:per});
                $("#progressVal").html(per);
            }else if(new Date().getTime()-refshTime>50){
                per = per+"%";
                $("#progressDiv").css({width:per});
                $("#progressVal").html(per);
                refshTime = new Date().getTime();
            }
        });
    };
})(window);

