var IndexAction = require('./js/sdk/indexAction.js');
var BucketAndObjectAction = require('./js/sdk/bucketAndObjectAction.js');
var BucketAttributeAction = require('./js/sdk/bucketAttributeAction.js');
var accountService = require('./js/encryption/accountService.js');
var TaskControlAction = require('./js/sdk/taskControlAction.js');
var invokeTool = require("./js/obsUtils.js").invokeTool;
var ObjectPolicy =require("./js/sdk/bucket_policy/ObjectPolicy.js");
var accessConnector = require("./js/access/iam/IAMConnector.js");
var obsConfig = require('./js/obsConfig.js');
var Const = require('./js/common/constants.js');
var fs = require('fs');
var async = require('./node_modules/async');
var os = require('os');
var AESTools = require('./js/AESTools');
var TaskManager = require("./js/TaskManager");
var exec = require('child_process').exec;
var pkg = require('../package.json');
var obsError = require('./js/common/ObsError.js');
var i18n_learnMore = require('./js/i18n_learnMore.js');
var commonUtils = require('./js/common/CommonUtils.js');
var gui = require("nw.gui");
var AWS = require('./node_modules/hws-sdk');
//碎片数量
var multipartNum;
//任务完成标识
var isTaskDone = false;
//基本信息配置接口对象
var indexAction = new IndexAction();
//桶和对象操作接口对象
var bucketAndObjectAction;
//桶属性接口对象
var bucketAttributeAction;
//任务管理接口对象
var taskControlAction;

//AWS.S3
var s3;
//任务管理器
var taskManager;
//上一次访问的桶
var lastBucket;
//桶名
var bucketName;
//错误信息配置
var errorConfig = {};
//对象列表分页信息
var pageContext = {};
//碎片管理分页信息
var pageMultipartContext = {};
//对象列表默认页码
pageContext.nowPage = 1;
//碎片管理默认页码
pageMultipartContext.nowPage = 1;
//对象列表默认显示方式
var objectShowWay = "list";
//当前登陆用户ID
var currentUserId;
//当前登陆用户名
global.currentUserName;
//domainID
var ownerId;
//domainName
var ownerName;
//是否启用Https 'Y' or 'N'
var isHttps = 'Y';
//是否启用MD5校验 'Y' or 'N'
global.isMD5check = 'N';
//是否启用证书校验 'Y' or 'N'
var isSSL = 'N';
//是否自动检查升级 'Y' or 'N'
var isAutoUpdate = "N";
//多段上传配置
var uploadConfig = new obsConfig.UploadConfig();
//多段下载配置
var downloadConfig = new obsConfig.DownloadConfig();
//当前语言
var language;
//当前语言配置文件
var languageJson=zh;
//域名信息
var domainName;
//当前选择任务列表
var selected="uploadTaskDiv";
var selectedTable = false;
//当前选择任务状态
var nowstat="";
//单次允许上传对象数量
var uploadFileNumber=500;
//用户类型
var userType ;
//IP端口
var endpoint ;
//默认region
var defaultRegion ;
//签名版本
var signatureVersion ;
//是否登陆成功
var isLoaded = false;
//升级服务器地址
var updateServer;
//是否显示清理垃圾错误信息
var isShowDelRubErrMsg = true;
//是否显示下载文件错误信息
var isShowDownErrMsg = true;
//操作系统类型
var winType = "";
//碎片显示时间
var rubbishDays = 0;
//任务队列
var taskArr = [];
//是否刷新对象列表
var isRefreshObj = false;
//上次刷新对象列表时间
var lastRefresh = false;
//外部桶
var ExtBucket = new Array();
// 收藏路径
var favouritePath = new Array();
//文件夹列表
var folderList = [];
//排序方式
var objSort = true;
//桶创建时间排序
var bucketCreatedSort = true;
//桶名称排序
var bucketNameSort = true;
//桶区域排序
var bucketRegionSort = true;
//代理信息
var proxy = {};
//是否登陆UDS成功
var isLoaderUser = false;
//服务端加密标志
global.serverEncryption = false;
//服务端加密KMS秘钥ID
global.serverEncryptionKeyId = "";
//数据库路径
global.mongodbPath;
//是否开启服务端加密功能
var isShowServerEncryption = false;
//数据加密传输
global.isChunk = false;
//当前桶存储类型
var currBucketStorage = false;

var checkRecoverInterval = false;

//密码占位符
var pwdPlaceHolder="************";

//加密模块初始化
global.Tools = new AESTools(lanpath);
//数据库密码
global.newMongoPwd = false;

//account对象列表
global.accountObj = {};

//临时账户信息
var tempAccount = false;

//每页对象列表数量
global.objPerPageSize = 100;
//任务列表显示数量
global.taskShowSize = 100;

//通过fs.createReadStream打开的句柄数
global.filesNum = 0 ;

global.langData = {};

//域名信息
global.domainName;
//当前账号的domainId和名称
global.curOnwerId = "";
global.curDisplayName = "";
// 当前桶是否支持文件接口
global.curFileInterface = "Disabled";
// 支持多AZ的区域
global.supportMultiAzRegions1 = ["southchina"];
global.supportMultiAzRegions = ["cn-east-2", "cn-north-4", "cn-southwest-2"];
// 输入框路径
global.inputPath = "";

$(function(){
    window.ondragover = function(e) {
        e.stopPropagation();
        e.preventDefault();
        return false
    };
    window.ondrop = function(e) {
        e.stopPropagation();
        e.preventDefault();
        return false
    };
    window.ondragenter = function(e) {
        e.stopPropagation();
        e.preventDefault();
        return false
    };
    selectedTable = $("#"+selected+" table");

    //弹出页面关闭按钮统一处理方法
    $(".mui-page-close1").on('click',function(){
        var href = $(this).attr('data-href');
        if(href){
            $("#"+href).click();
        }else{
            $(this).parent().removeClass('shown');
        }
        return false;
    });

    //对象列表和任务列表切换
    $('.mui-left .item .head').on('click',function(){
        $("#objDiv").toggleClass('current');
        $("#objPanel").toggleClass('current');
        $("#taskDiv").toggleClass('current');
        $("#taskPanel").toggleClass('current');
        if($("#taskPanel").hasClass('mui-active')){
            reloadTasks(true);
        }
        return false;
    });

    //切换桶 左边
    $('.bucketLeftDiv .bucketList .item').delegate('.bucket-item','click',function(){
        $(this).parent().find('.current').removeClass('current');
        $(this).parent().find('li').find('span').removeClass('show-span-active');
        $(this).addClass('current');
        $(this).find('span').addClass('show-span-active');
        var bucketName =$(this).attr('data-href').trim();
        var path = "obs://" + bucketName + "/";
        global.inputPath = path;
        $("#pathInput").val(path);
        $("#pathInputCollect").removeClass("mui-hide");
        $("#downloadFileName").val("");
        $('#curBucketName').html(bucketName);
        $('#curBucketName').attr('isExt',$(this).find("span").hasClass("mui-icon-ext-bucket"));
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#objectNum").html('');
        $("#storageSize").html('');
        $('#objLists tr').each(function(i,item){
            $(item).remove();
        });
        objectOrBucketRetrun(bucketName);//切换到对象列表
    });

    //切换桶 table
    $('#bucketLists tbody').delegate('.list-objs-1','click',function(){

        $("#lsBuckets").find('.current').removeClass('current');
        $("#lsBuckets").find('li').find('span').removeClass('show-span-active');
        var bucketName =$(this).attr('data-href').trim();
        $("#lsBuckets").find('li').each(function () {
            if($(this).attr('data-href').trim() == bucketName){
                $(this).addClass('current');
                $(this).find('span').addClass('show-span-active');
            }
        });
        $("#downloadFileName").val("");
        $('#curBucketName').html(bucketName);
        $('#curBucketName').attr('isExt',$(this).hasClass("mui-icon-extBucket"));
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;
        $('#objLists-table-section').addClass('mui-hide');
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#objectNum").html('');
        $("#storageSize").html('');
        $('#objLists tr').each(function(i,item){
            $(item).remove();
        });
        objectOrBucketRetrun(bucketName);//切换到对象列表
    });
    //切换任务列表
    $('.taskLeftDiv .taskTypes').on('click',function(){
        if(!$(this).hasClass('current')){
            $(this).parent().find('.current').removeClass('current');
            $(this).addClass('current');
            taskChecked = false;
            taskCheckedNum = -1;
            selected = $(this).find('span').attr('data-href');
            selectedTable = $("#"+selected+" table");
            $('#'+selected+' tbody').html('');//清空列表

            $("#uploadTaskDiv").addClass('mui-hide');
            $("#downloadTaskDiv").addClass('mui-hide');
            $("#deleteTaskDiv").addClass('mui-hide');
            $("#recoverTaskDiv").addClass('mui-hide');
            $("#uploadTaskDiv tbody").html('');
            $("#downloadTaskDiv tbody").html('');
            $("#deleteTaskDiv tbody").html('');
            $("#recoverTaskDiv tbody").html('');
            $("#"+selected).removeClass('mui-hide');
            reloadTasks(true);
        }
    });
    //桶属性界面展示功能
    $('.mui-icon-more').on('mouseup',function(e){
        var haveFolder = false;
        $(".selected-tr-active").each(function () {
            if($(this).find('[name="fileType"]').text() === languageJson.folder){
                haveFolder = true;
                return false;
            }
        });
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var show = $('#bucketHandle').hasClass('mui-active');
        if(show) {
            $('#bucketHandle').removeClass('mui-active')
        } else {
            hideOtherPop();
            handleExtbucket();//外部桶桶属性按钮隐藏
            $('#bucketHandle').addClass('mui-active').css({
                left: $(this).offset().left,
                top: $(this).offset().top - 29
            });
        }
        if (window.isPartnerCloud) {
            $('.btnCDN').addClass("mui-disabled-task");
            $('.btnConfigPolicy').addClass("mui-disabled-task");
        } else {
            $('.btnCDN').removeClass("mui-disabled-task");
            $('.btnConfigPolicy').removeClass("mui-disabled-task");
        }
        return false;
    });
    //对象界面展示功能
    $('#ObjectMorebtn').on('mouseup',function(e){
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        //恢复置灰
        if($("#recoverBtn").hasClass("mui-disabled")){
            $('#restoredInMore').addClass("mui-disabled-task");
            if (UCDVersion === "HEC" || UCDVersion === "HK") {
                $("#restoredInMore").parent().attr('title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
            }else {
                $("#restoredInMore").parent().attr('title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
            }
        }else{
            $('#restoredInMore').removeClass("mui-disabled-task");
            $("#restoredInMore").parent().attr('title', "");
        }
        if($("#PolicyBtn").hasClass("mui-disabled")){
            $('#PolicyBtnInMore').addClass("mui-disabled-task");
            $("#PolicyBtnInMore").parent().attr('title',languageJson.obs_objectPolicy_onlySelOne_tip);
        }else{
            $('#PolicyBtnInMore').removeClass("mui-disabled-task");
            $("#PolicyBtnInMore").parent().attr('title',"");
        }
        var show = $('#objectMore').hasClass('mui-active');
        if(show) {
            $('#objectMore').removeClass('mui-active')
        } else {
            hideOtherPop();
            $('#objectMore').addClass('mui-active').css({
                left: $(this).offset().left,
                top: $(this).offset().top - 29
            });
        }
        return false;
    });
    //用户管理界面展示功能
    $('.btnUserInfo').on('mouseup',function(){
        var userInfoShow = $('.more-user-btns').hasClass('mui-active');
        if(userInfoShow) {
            $('.more-user-btns').removeClass('mui-active');
            $('.btn-account').removeClass('btn-account-unfold');
        } else {
            hideOtherPop();
            hideTaskPop();
            $("#userSearch").focus();
            $('.more-user-btns').addClass('mui-active');
            $('.btn-account').addClass('btn-account-unfold');
        }
        return false;
    });
    //帮助页面、桶属性页面关闭功能实现
    $('#bucketProSure,#helpSure,#helpDtSure').on('click',function(){
        $("#bucketPropertiesTab tbody tr").each(function () {
            $(this).find('td').eq('1').find('span').html('');
        });
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    //前缀查询输入回车按钮时执行查询功能
    $("#prefixSearch").on('keyup', function (event) {
        var keyCode = event.keyCode;
        if(keyCode === 13) {
            $(".btnSearch").click();
        }
    });

    //创建桶
    $('.bucket-create').on('click',function(){
		if(global.cloudType===1){
            $("#createBucketPage").find("div").eq(1).find("div").eq(0).find("span").eq(3).hide();
        }else{
			 $("#createBucketPage").find("div").eq(1).find("div").eq(0).find("span").eq(3).show();
		}
        $(".mui-page-full.shown").removeClass('shown');
        $('#btnExBucket').removeAttr('disabled');
        $("#createBucketPage").css('z-index', '1000');
        showOverlay();
        if (userType === '1') {
            $("#bucketRegionDiv").addClass('mui-hide');
            $("#bucketRegionInputDiv").removeClass('mui-hide');
        } else{
            $("#bucketRegionDiv").removeClass('mui-hide');
            $("#bucketRegionInputDiv").addClass('mui-hide');
        }
        $("#createBucketPage").addClass('shown');
        divDragFunc('createBucketPageDrag','createBucketPage');
        // 看当前选择的区域是否支持多AZ
        showMultiAzTipByRegion();
        tabFocus('bucketName');
        return false;
    });

    //新建文件夹界面展示
    $('.mui-icon-newFolder').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#createFolderPage").addClass('shown');
        divDragFunc('createFolderPageDrag','createFolderPage');
        $('.more-btns').removeClass('mui-active');
        tabFocus('floderName');
        return false;
    });

    // 搜索路径
    $(".bucketPathLeftDiv .btnBucketSearch").on('click',function(){
        var searchStr = $("#bucketPathSearch").val().trim();
        searchStr = searchStr.toLowerCase(); // 忽略大小写查询
        $("#lsBucketPaths").children().show();
        var pathLs = $("#lsBucketPaths").children();
        var queryNothing = true;
        for (var i = 0; i < pathLs.length; i++) {
            var pathName = $(pathLs[i]).attr("data-href");
            if (!pathName) {
                continue;
            } else if (pathName.indexOf(searchStr) == -1) {
                $(pathLs[i]).hide();
            } else {
                queryNothing = false;
            }
        }
        if (queryNothing) {
            $("#leftQueryNothingPath").show();
            $("#leftNoPathData").hide();
        } else {
            $("#leftNoPathData").hide();
            $("#leftQueryNothingPath").hide();
        }
        return true;
    });

    // 如果路径超过100条提示上限
    function showPathBoundTip() {
        var btnText = $('#addFavouritePath').text().trim();
        var num = btnText.substring(btnText.indexOf("(")+1, btnText.indexOf("/"));
        if(parseInt(num) > 99){
            if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
                showOverlay();
            }
            $('.mui-model').showMessage({
                type:'warning',
                message: languageJson.obs_term_collectPath_upperLimit_msg,
                ok: function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        return true;
    }
    
    // 添加收藏路径
    $('#addFavouritePath').on('click',function(){
        if(showPathBoundTip()){
            showOverlay();
            $("#createPathPage").addClass('shown');
            divDragFunc('createPathPageDrag','createPathPage');
            $('.more-btns').removeClass('mui-active');
            tabFocus('pathName');
            return false;
        }
    });

    $('#btnCreatePath').on('click',function(){
        var path = $("#pathName").val().trim();
        var index = path.lastIndexOf("/");
        // 检查路径是否合规
        bucketAndObjectAction.pathNameCharacter(path,languageJson, function (errMsg,pathName,errKey) {
            if(errMsg){
                if(errKey === "pathNameBeyondBound"){
                    $('.mui-model').showErrorMessage({
                        message: languageJson.obs_term_collectPath_valid_00003,
                        obsError: obsError("pathNameBeyondBound")
                    });
                    return false;
                }
                $("#pathName").val(pathName);
                $('.mui-model').showMessage({
                    type:'warning',
                    message: errMsg,
                    ok: function () {
                        $("#pathName").focus();
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                //检查路径是否存在
                var isFav = isFavouritePath(pathName, favouritePath, currentUserId);
                if(isFav){
                    $('.mui-model').showMessage({
                        type:'warning',
                        message: languageJson.obs_term_collectPath_alreadyExists_msg,
                        ok: function () {
                            $("#createPathPage").css('z-index', '1000');
                            return false;
                        },
                        title: languageJson.warning
                    });
                    showOverlay();
                }else{
                    addFavouritePath(pathName);
                    $("#createPathPage").removeClass('shown');
                    $('#pathName').val('');
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    updateCurrentPageFavourIcon(pathName, false);
                }
            }
        });

    });

    //关闭收藏路径页面
    $("#btnCancelCreatePath").on('click', function () {
        $("#createPathPage").removeClass('shown');
        $('#pathName').val('');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //关于界面展示
    $('#about').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#help").addClass('shown');
        var platform = process.platform;
        platform = /^win/.test(platform) ? 'win' : /^darwin/.test(platform) ? 'mac' : 'linux' + (process.arch == 'ia32' ? '32' : '64');
        if (platform === "win") {
            if(process.arch.indexOf("64") >= 0){
                platform = "( Windows x64 )";
            }else{
                platform = "( Windows x32 )";
            }
        }else{
            platform = "( Mac )";
        }
        $("#nwVersion").html(platform)
        //CTC显示ctc网址，隐藏hec网址，隐藏copyright
        if(_.isEqual(UCDVersion,"CTC")){
            $("#ctccloudsWeb").removeClass('mui-hide');
            $("#hwcloudsWeb").addClass('mui-hide');
            $("#versionOwer").html(languageJson.copyright_CTC);
        }
        //国际站显示国际站网址，隐藏hec网址
        if(_.isEqual(UCDVersion,"HK")){
            $("#hkcloudsWeb").removeClass('mui-hide');
            $("#hwcloudsWeb").addClass('mui-hide');
        }
        //CMCC隐藏copyright，有的时候再更换显示
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#versionOwer").addClass('mui-hide');
        }
        //HCS只显示版本
        if(_.isEqual(UCDVersion,"HCS") || _.isEqual(UCDVersion,"SBB")){
            $("#versionOwer").addClass('mui-hide');
            $("#websiteTr").addClass('mui-hide');
            $("#versionWarning").addClass('mui-hide');
        }
        divDragFunc('helpDrag','help');
        $('.more-btns').removeClass('mui-active');
        return false;
    });

    //海外版本关于界面展示
    $('#aboutDt').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#helpDt").addClass('shown');
        divDragFunc('helpDtDrag','helpDt');
        $('.more-btns').removeClass('mui-active');
        return false;
    });
    //系统配置界面展示
    $('#btnSetting').on('mouseup',function(){
        var moreHelpShow = $('.more-help-btns').hasClass('mui-active');
        if(moreHelpShow) {
            $('.more-help-btns').removeClass('mui-active');
        } else {
            hideOtherPop();
            hideTaskPop();
            $('.more-help-btns').addClass('mui-active');
        }
        if(_.isEqual(UCDVersion,"CTC")){
            $("#btnUserSurvey").hide();
            $("#userExperienceDiv").hide();
        }
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#btnUserSurvey").hide();
        }
        if(_.isEqual(UCDVersion,"HCS") || _.isEqual(UCDVersion,"SBB")){
            $("#btnUserSurvey").hide();
            $("#checkUpdate").hide();
            $("#isAutoUpdate").parent().hide();
            $("#userExperienceDiv").hide();
        }
        return false;
    });

    //调整几个浮动界面位置。
    $(window).on('mouseup',function(){
        if(!$("#userSearch").is(":focus")&&!$("#userSearch").val()){
            hideOtherPop();
        }
    });
    $("#userSearch").on('keyup', function (ev) {//控制输入时清除按钮的显示隐藏
        var value = $(this).val();
        if (value.length > 0) {
            $("#clearAccountInput").removeClass("mui-hide");
        } else {
            $("#clearAccountInput").addClass("mui-hide");
        }
        if(ev.keyCode === 13){
            $(".searchAccount").click();
        }
    });
    $("#clearAccountInput").on("click",function () {//清除搜索值
        $("#userSearch").val("");
        $(".NoAccount").addClass('mui-hide');
        $("#clearAccountInput").addClass("mui-hide");
        $("#userList").find("ul").children().show()
    });
    $(".searchAccount").on("click",function () {//搜索
        $("#userList").find("ul").children().show();
        var queryNothing = true;
        var keyVal = $("#userSearch").val().trim().toLowerCase();
        var userList = $("#userList").find("ul").children();
        for (var i = 0; i < userList.length; i++) {
            var accountName = $(userList[i]).find("a.user").attr("data-href").toLowerCase();
            if (!accountName) {
                continue;
            } else if (accountName.indexOf(keyVal) == -1) {
                $(userList[i]).hide();
            } else {
                queryNothing = false;
            }
        }
        if (queryNothing) {
            $(".NoAccount").removeClass("mui-hide");
        } else {
            $(".NoAccount").addClass("mui-hide");
        }
    });
    function hideTaskPop() {
        $("#taskPanel").removeClass('mui-active');
        $("#taskDivHead").removeClass('triangle-up');
        $("#taskOverlay").addClass('mui-hide');
    }
    $("#userSearch").on('focus', function () {
        $(".userSearchLi").addClass('dtColor');
    });
    $("#userSearch").on('blur', function () {
        $(".userSearchLi").removeClass('dtColor');
    });

    function hideOtherPop() {
        $('.more-btns,.more-user-btns,.more-help-btns,.task-status-check').removeClass('mui-active').removeClass('mui-active-object');
        $('.btn-account').removeClass('btn-account-unfold');
        $('.help-tips').removeClass('active');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.task-status-check').css('top','-1440px');
    }

    //鼠标移入note图标后显示提示信息界面
    $('.mui-icon-note1').on('mouseover',function(e){
        var hf = $(this).attr('data-href');
        if(hf && $(hf).size() === 1){
            $('.help-tips').html($(hf).html());
        }
        $('.help-tips').addClass('active');
        var bodyW = $('body').width();
        var bodyH = $('body').height();
        var tipsW = $('.help-tips').width();
        var tipsH = $('.help-tips').height();
        var pageX = e.pageX;
        var pageY = e.pageY;
        if(bodyW-pageX<tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:bodyH-tipsH-20});
        }else if(bodyW-pageX<tipsW&&bodyH-pageY>tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:(pageY+15)});
        }else if(bodyW-pageX>tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:pageX,top:bodyH-tipsH-20});
        }else{
            $('.help-tips').css({left:pageX,top:(pageY+15)});
        }
        $('.more-user-btns').removeClass('mui-active');
        $('.task-status-check').removeClass('mui-active').css('top','-1440px');
        return false;
    });
    $('.mui-icon-note').on('mouseover',function(e){
        var hf = $(this).attr('data-href');
        if(hf && $(hf).size() === 1){
            $('.help-tips').html($(hf).html());
        }
        $('.help-tips').addClass('active');
        var bodyW = $('body').width();
        var bodyH = $('body').height();
        var tipsW = $('.help-tips').width();
        var tipsH = $('.help-tips').height();
        var pageX = e.pageX;
        var pageY = e.pageY;
        if(bodyW-pageX<tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:bodyH-tipsH-20});
        }else if(bodyW-pageX<tipsW&&bodyH-pageY>tipsH+20){
            $('.help-tips').css({left:bodyW-tipsW-10,top:(pageY+15)});
        }else if(bodyW-pageX>tipsW&&bodyH-pageY<tipsH+20){
            $('.help-tips').css({left:pageX,top:bodyH-tipsH-20});
        }else{
            $('.help-tips').css({left:pageX,top:(pageY+15)});
        }
        $('.more-user-btns').removeClass('mui-active');
        $('.task-status-check').removeClass('mui-active').css('top','-1440px');
        return false;
    });

    //鼠标移出note图标后显示提示信息界面
    $('.mui-icon-note').on('mouseout',function(e){
        $('.help-tips').removeClass('active');
    });
    $('.mui-icon-note1').on('mouseout',function(e){
        $('.help-tips').removeClass('active');
    });

    var move2task = function(){
        var m= $('.move');
        m.css({opacity:1});
        setTimeout(function(){
            m.css({left:'120px',bottom:'5px'});
        },100);
        setTimeout(function(){
            m.css({opacity:0});
        },900);
    };
    $('.move-task').on('mouseup',function(e){
        var m= $('.move');
        m.css({left: (e.pageX-10)+'px',bottom: (window.innerHeight - e.pageY-15)+'px'});
        setTimeout(move2task,900);
    });

    //外部桶碎片管理
    $("#bucketLists tbody").delegate('.mui-icon-handel-multipart','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('.btnListMultipart').click();
        },10);
    });
    //碎片管理界面展示
    $(".btnListMultipart").on('click', function () {
        if(_.isEqual(UCDVersion,"CTC")){
            $("#multipartKnowMore").hide();
        }
        if(isHasSelectBucket()){//判断是否选择桶
            return false;
        }
        var bucket = $('#curBucketName').html();
        //请求桶，报错则提示，点击OK刷新，请求正常则显示碎片管理界面
        bucketAttributeAction.headBucket(bucket, function (err, results) {
            if (err) {
                showOverlay();
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        $("#all-refresh-div").click();
                        return false;
                    }
                });
            } else {
                $(".mui-page-full.shown").removeClass('shown');
                $("#multipartPage").addClass('shown');
                divDragFunc('multipartPageDrag','multipartPage');
                $("#multipartTab tbody").html("");
                pageMultipartContext.nowPage = 1;
                var data = {};
                data.pageMultipartContext = pageMultipartContext;
                data.arr = [];
                data.rubbishDays = rubbishDays;
                var loading = loadingShow();
                $("#multipartPage").css('z-index', '90');

                //获取桶碎片信息
                bucketAndObjectAction.listMultipartUploads($('#curBucketName').html(),'','','','', function (err,data) {
                    if(err){
                        $("#deleteMultipart").addClass('mui-hide');//获取不到时隐藏清除碎片按钮
                    };
                    loading.close();
                    $("#multipartPage").css('z-index', '1000');
                    showOverlay();
                    listMultiparUploadsUI(err,data,$('#curBucketName').html());
                },data);
                return false;
            }
        });
    });

    //碎片下拉刷新
    $("#multipartDiv").scroll(function(){
        var viewH =$(this).height();//可见高度
        var contentH =$(this).get(0).scrollHeight;//内容高度
        var scrollTop =$(this).scrollTop();//滚动高度

        if(contentH - viewH ===  scrollTop) {
            if(pageMultipartContext.refresh){
                var data = {};
                data.pageMultipartContext = pageMultipartContext;
                data.arr = [];
                data.rubbishDays = rubbishDays;
                pageMultipartContext.refresh = false;
                bucketAndObjectAction.listMultipartUploads($('#curBucketName').html(),'',pageMultipartContext.NextKeyMarker,pageMultipartContext.NextUploadIdMarker,pageMultipartContext.nowPage, function (err,data) {
                    listMultiparUploadsUI(err,data,$('#curBucketName').html());
                },data);
            }
        }
    });

    //删除单个碎片功能
    $("#multipartTab tbody").delegate('.mui-icon-account-clear', 'click', function () {
        var curBucket = $('#curBucketName').html();
        var id = $(this).attr("data-id");
        var key = $(this).attr("data-key");
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.isDeleteMultipart,
            isFocus: true,
            ok: function () {
                //删除选择的碎片
                bucketAndObjectAction.abortMultipartUpload(curBucket, id, key,false,function (err,data){
                    if(err){
                        logger.error(err);
                        $("#multipartTab tbody").html('');
                        pageMultipartContext.nowPage = 1;
                        var data = {};
                        data.pageMultipartContext = pageMultipartContext;
                        data.arr = [];
                        data.rubbishDays = rubbishDays;
                        $("#deleteMultipart").addClass('mui-hide');
                        bucketAndObjectAction.listMultipartUploads(curBucket,'','','','', function (err,data) {
                            listMultiparUploadsUI(err,data,curBucket);
                        },data);
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message)
                            });
                        }
                    }else{
                        $('.mui-model').showMessage({
                            type:"info",
                            message:CommonUtils.format(languageJson.obs_term_bucketFragment_delFragmentSuccess_msg, CommonUtils.encodeForHTML(CommonUtils.substr32(key))),
                            ok:function(){
                                if ($("#mui-overlay").size() > 0) {
                                    mui.overlay('off');
                                }
                                return false;
                            },
                            title:languageJson.hintInfo
                        });
                        $("#multipartTab tbody").html('');
                        pageMultipartContext.nowPage = 1;
                        $("#deleteMultipart").addClass('mui-hide');
                        var data = {};
                        data.pageMultipartContext = pageMultipartContext;
                        data.arr = [];
                        data.rubbishDays = rubbishDays;
                        $("#deleteMultipart").addClass('mui-hide');

                        //删除完成后刷新碎片管理界面
                        bucketAndObjectAction.listMultipartUploads(curBucket,'','','','', function (err,data) {
                            listMultiparUploadsUI(err,data,curBucket);
                        },data);
                        showOverlay();
                    }
                });
            },
            cancel: function () {
                return false;
            },
            title: languageJson.obs_term_bucketFragment_delFragment_wintitle
        });
    });

    //清理所有碎片功能
    $("#deleteMultipart").on('click', function () {
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.isDeleteAllMultipart,
            isFocus: true,
            ok: function () {
                isShowDelRubErrMsg = true;
                pageMultipartContext.nowPage = 1;
                $("#multipartPage").css('z-index', '90');
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                var option = {};
                option.timeout = 300000;
                var loading = loadingShow();

                //调用删除所有碎片接口
                bucketAndObjectAction.deleteAllMultipartUploads($('#curBucketName').html(), '', '', '', function (err,data) {
                    $("#multipartPage").css('z-index', '1000');
                    loading.close();
                    if(err){
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: languageJson.deleteAllMultipartErr + ' ' + ( obsError(err.code,err.message) ? obsError(err.code).description : errorConfig[err.code] ),
                                ok: function () {
                                    return false;
                                }
                            });
                        }
                    } else {
                        $('.mui-model').showMessage({
                            type: "info",
                            message: languageJson.obs_term_bucketFragment_delAllFragmentSuccess_msg,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.hintInfo
                        });
                        pageMultipartContext.nowPage = 1;
                        $("#multipartTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
                        $("#deleteMultipart").addClass('mui-hide');
                    }
                    showOverlay();
                },'',rubbishDays);
            },
            cancel: function () {
                return false;
            },
            title: languageJson.warning
        });
    });

    //选择某一行碎片
    $("#multipartTab tbody").delegate('tr', 'click', function () {
        $("#multipartTab tbody tr td span").removeClass('show-span-active');
        var self = this;
        $(self).parent().children().removeClass("selected-tr-active");
        $(self).addClass("selected-tr-active");
        $(self).find('td').find('.mui-ellipsis-multipart').toggleClass('show-span-active');
    });

    //刷新碎片管理界面
    $("#refreshMultipart").on('click', function () {
        pageMultipartContext.nowPage = 1;
        $("#multipartTab tbody").html("");
        $("#deleteMultipart").addClass('mui-hide');
        var data = {};
        data.pageMultipartContext = pageMultipartContext;
        data.arr = [];
        data.rubbishDays = rubbishDays;
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        $("#multipartPage").css('z-index', '90');
        bucketAndObjectAction.listMultipartUploads($('#curBucketName').html(),'','','','', function (err,data) {
            loading.close();
            $("#multipartPage").css('z-index', '1000');
            showOverlay();
            listMultiparUploadsUI(err,data,$('#curBucketName').html());
        },data);
    });


    //关闭碎片列表
    $("#cancelMultipart").on('click', function () {
        $("#multipartPage").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //刷新桶
    $('.btnRefresh').on('click', function () {
        var bucket = $('#curBucketName').html();
        if (window.require) {
            var loading = loadingShow();
            bucketAndObjectAction.listBucket(function (err, data) {
                listBucketUI(err, data,loading,bucket)
            });
        }
        return false;
    });

    $("#all-refresh-div").on('click', function () {
        if (window.require) {
            var loading = loadingShow();
            bucketAndObjectAction.listBucket(function (err, data) {
                if($("#objectArea").hasClass('mui-hide')){//界面停留在桶列表，则只刷新桶
                    listBucketUI(err, data,loading);
                }else{
                    var bucketName = $('#curBucketName').text().trim();
                    var curPath = getCurrPath();
                    if(bucketName===curPath){
                        curPath = '';
                    }
                    // 如果是搜索过的对象列表，只刷新搜索的列表
                    if ($("#isSearch").val()) {
                        var prefix = $("#prefixSearch").val();
                        prefix = curPath + prefix;
                        bucketAndObjectAction.listObject(bucketName, 'true', prefix, function (err, data) {
                            listObjectUI(err, data, bucketName);
                            loading.close();
                        },pageContext['page'+pageContext.nowPage]);
                    } else {
                        bucketAndObjectAction.listObject(bucketName, 'true', curPath, function (err, data) {
                            listObjectUI(err, data, bucketName);
                            loading.close();
                        },pageContext['page'+pageContext.nowPage]);
                    }
                }
            });
        }
        return false;
    });

    //打开账户列表管理界面
    $("#userList").delegate('li a.manager','click',function(){
        $("#clearAccountInput").click();
        hideOtherPop();
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#accountList").addClass('shown');
        //HCS局点隐藏下面的链接
        if(_.isEqual(UCDVersion,"HCS") || _.isEqual(UCDVersion,"SBB")){
            $("#HCS").parent().addClass('mui-hide');
        }
        if(_.isEqual(UCDVersion,"YLM")){
            $("#aboutAKSK").addClass('mui-hide');
        }
        divDragFunc('accountListDrag','accountList');
    });

    //编辑账户信息
    $('#accountList').delegate('.mui-icon-account-edit','click',function(){
        var self=this;
        var accId = $(self).attr('data-id');
        $("#createAccount .mui-page-full-title").html(languageJson.editAccount);
        $("#createAccount").find("h5").first().addClass("mui-hide");
        //获取需要编辑的账户信息
        accountService.getAccountInfo(accId, function (result) {
            var href= $(self).attr('data-href');
            $("#accountList").css('z-index','90');
            $("#createAccountTab").removeClass('mui-hide');
            $("#"+href).addClass('shown');
            if(!result){
                $('.mui-model').showErrorMessage({
                    type:'error',
                    message: languageJson.getConfigInfoErr,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.errorMessage
                });
                return false;
            }
            $("#name").val(result.name);
            $("#accessKey").val(result.accessKey);
            $("#selType").val(result.type);
            $("#selType").selectmenu('refresh', true);
            if(result.type.toString().trim()==='1'){
                $("#endpointDiv").addClass('mui-hide');
            }else{
                $("#endpointDiv").removeClass('mui-hide');
                $("#endpoint").val(result.endpoint);
            }
            if(result.secretKey){
                $("#secretKey").val(result.secretKey);
                $("#secretKey").next().val(pwdPlaceHolder);
                $("#isSaveSK").get(0).checked = true;
            }else{
                $("#isSaveSK").get(0).checked = false;
            }
            $("#userId").val(result.userID);
            if(result.loadPath && result.loadPath[0] !== "undefined"){
                $("#loadingPath").val(result.loadPath);
            }else{
                $("#loadingPath").val("");
            }
        });
        divDragFunc('createAccountDrag','createAccount');
        return false;
    });



    $("input[type='number']").bind('input propertychange', function() {
        var self = this;
        var max = new Number($(self).attr('max'));
        var min = new Number($(self).attr('min'));
        var val = new Number($(self).val());
        $(self).val(val);
        if(val >= max) {
            $(self).val(max)
        }
    });

    /*
     限制number只能输入数字
     */
    $("input[type='number']").on('keypress', function (event) {
        var keyCode = event.keyCode;
        if (keyCode <= 47 || keyCode >= 58) {
            return false;
        }
    });
    /*
     限制number不能小于最小值
     */
    $("input[type='number']").on('blur', function (event) {
        if($(this).val() == '') {
            if($(this).attr('min')) {
                $(this).val($(this).attr('min'));
            } else {
                $(this).val('');
            }
        }else {
            if($(this).attr('min') && +$(this).val() < +$(this).attr('min')) {
                $(this).val($(this).attr('min'));
            }
        }
    });
    /*
     限制前缀查询不能输入/
     */

    //删除账户信息
    $('#accountList').delegate('.mui-icon-account-del', 'click', function () {
        var self = this;
        var accId = $(self).attr('data-id');
        var formHtml = '';
        formHtml += languageJson.isDeleteAccount;
        $('.mui-model').showMessage({
            type: "warning",
            message: formHtml,
            isFocus: true,
            ok: function (model) {
                accountService.deleteAccountInfo(accId, function (result) {
                    if(result==='clear'){
                        $('.btnUserInfo').addClass('userNoLogin');//删除账户,置灰图标
                        allButtonChange('1');
                        clearBucketLists();
                    }
                    getAccountListInfo(function (Id) {
                        if(result==='nextUser'){
                            currentUserId = Id;
                            isLoaderUser = true;
                            $("#objLists tbody").find('tr').each(function () {//清空对象列表（列表方式）
                                $(this).remove();
                            });
                            $("#lsBuckets").html('');
                            $("#isSearch").val("");
                            $("#prefixSearch").val('');
                            $("#clearPrefixSearchInput").addClass("mui-hide");
                            $("#objectNum").html('');
                            $("#storageSize").html('');
                            $("#downloadFileName").val("");
                            selectedTable.find('tbody').html('');
                            $('#taskNum').html(0);
                            $("#path").html('');
                            $("#taskNumberShowDiv").removeClass('taskNumShow');
                            clearBucketLists();
                        }
                    });
                },'',currentUserId);
                return false;
            },
            cancel: function () {
                return false;
            },
            title: languageJson.deleteAccount
        });
    });

    //是否开启https功能判断
    $("#isHttps").on("click",function(){
        if($("#isHttps").is(":checked")) {
            if(isHttps==="N"&&userType!=='1'){
                $('.mui-model').showMessage({
                    type:"warning",
                    message:languageJson.isSureUseHttps,
                    ok:function(model){
                        return false;
                    },
                    title:languageJson.warning
                });
            }
            $("#isSSL").attr("disabled",false);
            $("#isSSL").next().removeClass("ti-text-muted");
            $("#serverEncryption").attr("disabled",false);
            $("#serverEncryption").next().removeClass("ti-text-muted");
        }else{
            $("#serverEncryption").removeAttr('checked');
            $("#serverEncryption").next().addClass("ti-text-muted");
            $("#serverEncryption").attr("disabled",true);
            $("#isSSL").removeAttr('checked');
            $("#isSSL").next().addClass("ti-text-muted");
            $("#isSSL").attr("disabled",true);
            if(isHttps==="Y"){
                $('.mui-model').showMessage({
                    type:"warning",
                    message:userType==='2'?languageJson.isSureUseHttp1:languageJson.isSureUseHttp,
                    ok:function(model){
                        return false;
                    },
                    title:languageJson.warning
                });
            }
        }
    });
    //关闭账户列表
    $("#saveAccount,#cancelAccount").on('click', function () {
        $("#accountList").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        setTimeout(function () {
            if(isLoaderUser){
                isLoaderUser = false;
                getAccountListInfo(function (Id) {
                    var trs = $("#accountTab tbody").find('tr').length;
                    if(taskControlAction){
                        taskControlAction.abortAllTasks(function () {
                            if(taskManager){
                                taskControlAction.closeInterval();
                            }
                            if(trs===2){
                                loaderUser(Id,true,tempAccount);
                                tempAccount = false;
                            }else{
                                loaderUser(Id);
                            }
                        });
                    }else{
                        if(trs===2){
                            loaderUser(Id,true,tempAccount);
                            tempAccount = false;
                        }else{
                            loaderUser(Id);
                        }
                    }
                });
            }
        },50);
    });
    $('#btnAddAccount').on('click',function(){
        $("#createAccount .mui-page-full-title").html(languageJson.addAccount);
        $("#createAccount").find("h5").first().removeClass("mui-hide");
        var trs = $("#accountTab tbody").find('tr').length;
        if(trs===1){
            //标注关闭用户管理界面后是否重新登陆用户
            isLoaderUser = true;
        }
        $("#selType").val('1');
        $("#selType").selectmenu('refresh', true);
        $("#endpointDiv").addClass('mui-hide');
        if(trs>50){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.notMoreThan50Account,
                ok:function(){
                    return false;
                },
                title:languageJson.warning
            });
            return false;
        }
        var self=this;
        var href= $(self).attr('data-href');
        $("#accountList").css('z-index','90');
        $("#createAccountTab").removeClass('mui-hide');
        $("#"+href).addClass('shown');
        divDragFunc('createAccountDrag','createAccount');
        tabFocus("name");
        return false;
    });

    $("#selType").on('change', function () {
        if ('1' === $(this).val()) {
            $("#endpointDiv").addClass('mui-hide');
        } else {
            $("#endpointDiv").removeClass('mui-hide');
        }
    });


    /*
     新增/修改用户信息
     */
    $('#saveAccountBtn').on('click', function () {
        var name = $("#name").val();
        var accessKey = $("#accessKey").val();
        var selType = $("#selType").val();
        var secretKey=$("#secretKey").next().val();
        if (secretKey === pwdPlaceHolder) {
            secretKey = $("#secretKey").val();
        }
        var loadPath = $("#loadingPath").val().trim();
        var userId = $("#userId").val();
        var endpoint = $("#endpoint").val();
        var jsonObj = {};
        endpoint = endpoint.replace(/\s/g, "");
        name = name.replace(/\\/g, "/");
        accessKey = accessKey.replace(/\\/g, "/");
        secretKey = secretKey.replace(/\\/g, "/");
        endpoint = endpoint.trim();
        endpoint = endpoint.replace(/\\/g, "/");
        jsonObj.name = name;
        jsonObj.accessKey = accessKey.trim();
        jsonObj.secretKey = secretKey.trim();
        jsonObj.type = selType;
        if(loadPath.indexOf("/")>-1){
            if (loadPath.split("/")[0].length<3){
                $('.mui-model').showMessage({
                    type:'warning',
                    message: languageJson.obs_browser_path_valid,
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                jsonObj.loadPath = loadPath;
            }
        }else if (loadPath.length > 0){
            if(loadPath.length < 3){
                $('.mui-model').showMessage({
                    type:'warning',
                    message: languageJson.obs_browser_path_valid,
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                jsonObj.loadPath = loadPath;
            }
        }
        endpoint = endpoint.replace(/[:]{2,}/g,":");
        if (selType === "2") {
            jsonObj.endpoint = endpoint;
        }else{
            jsonObj.endpoint = domainName;
        }
        indexAction.saveOrModifyAccountCheck(jsonObj,languageJson, userId, function(err){
            if(err){
                $('.mui-model').showMessage({
                    type:"warning",
                    message:err,
                    ok:function(model){
                        return false;
                    },
                    title:languageJson.warning
                });
            }else{
                if(!$("#isSaveSK").is(":checked")){
                    jsonObj.isSaveSK = false;
                }else{
                    jsonObj.isSaveSK = true;
                }
                jsonObj.name = name.trim();
                var trs = $("#accountTab tbody").find('tr').length;
                if(trs==1&& !jsonObj.isSaveSK){
                    tempAccount = jsonObj;
                }
                indexAction.createOrModifyUser(accountService,userId, jsonObj, function (err) {
                    if(err){
                        global.logger.info('create account error');
                    }else{
                        if(userId==currentUserId){
                            global.currentUserName = name.trim();
                        }
                    }
                    $('#createAccount input').each(function () {
                        $(this).val('');
                    });
                    $("#accountList").css('z-index','1000');
                    $("#createAccount").removeClass('shown');
                    $("#createAccountTab").addClass('mui-hide');
                    var self = $('#saveAccountBtn');
                    var edit = $(self).attr('data-edit');
                    if('true' === edit){
                        currentUserId = userId;
                    }
                    getAccountListInfo(function(e){
                        var href = $(self).attr('data-href');
                        var init = $(self).attr('data-init');
                        if ('true' === init) {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            loaderUser('',true,jsonObj);
                            $(self).removeAttr('data-init');
                        }else if ('true' === edit) {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            loaderUser(userId,true,jsonObj);
                            $(self).removeAttr('data-edit');
                        }
                        $("#isSaveSK").get(0).checked = true;
                    },true);
                });
                return false;
            }
        });

    });

    

    //进入子目录
    $("#objLists tbody").delegate('.folder .list-objs-1','click',function(event){
        if(event.ctrlKey || event.shiftKey){
            return true;
        }
        $(".mui-dropdown-menu").removeClass('mui-open');
        var self=this;
        checked = false;
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;

        var bucketName = $('#curBucketName').html();

        var parentPath = getCurrPath();
        var folderName =JSON.parse($(self).parent().parent().find('.hiddenObjData').text()).name;//取第五列的数据
        folderName = folderName.substring(parentPath.length,folderName.length-1);//去掉folderName最后的/
        var currPath = parentPath+folderName+'/';
        global.inputPath = "obs://"+bucketName+"/"+currPath;
        $("#pathInput").val(global.inputPath);
        showFavouriteIcon(bucketName+"/"+currPath);
        $("#pathInputCollect").removeClass("mui-hide");
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        var loading = loadingShow();
        bucketAndObjectAction.listObject(bucketName,'true',currPath, function (err,data) {
            loading.close();
            if(!err && data && (data.Contents.length > 0 || data.CommonPrefixes.length > 0 )){
                var htmStrObj = {
                    currPath: encoderForHtml($(self).parent().parent().find('.hiddenObjData').text()),
                    folderName: encoderForHtml(folderName)
                }
                var htmStr = '<a class="mui-ellipsis-1" data-value="'+ htmStrObj.currPath +'" folderName="'+ htmStrObj.folderName +'">'+ htmStrObj.folderName +'<span style="display:none">'+ htmStrObj.currPath +'</span></a>';
                var divPath = $("#path");
                if($("#path a").length> Const("NAVI_COUNT")){
                    $("#path a").each(function () {

                    });
                }
                divPath.append(htmStr);
                var arr = $("#path").children();
                var leng = arr.length;
                if(arr.length>Const("NAVI_COUNT"))
                {
                    for(var i=0;i<arr.length-Const("NAVI_COUNT");i++) {
                        $(arr[i]).addClass('mui-hide');
                    }
                    $(arr[leng - Const("NAVI_COUNT")]).addClass('content');
                }
            } else {
                $("#all-refresh-div").click();
                loading.close();
                return;
            }
            listObjectUI(err,data,bucketName);
            loading.close();
        });
        return false;
    });

    //回退按钮
    $("#all-back-div").on('click',function(){
        var index = $("#path").children().length - 2;
        if(index == -1) {
            //返回桶列表
            $("#bread-path-box-bucket").click();
            $("#pathInput").val("obs://");
            global.inputPath = "obs://";
            // 隐藏输入框右侧的收藏图标
            $("#pathInputCollect").addClass("mui-hide");
        } else if(index == -2) {
            global.logger.info("Reach root, disable back")
        } else {
            $($("#path").children()[index]).click();
            var currPath = getCurrPath();
            var bName = $('#curBucketName').html();
            var path = "obs://" + bName + "/" + currPath;
            $("#pathInput").val(path);
            global.inputPath = path;
            $("#pathInputCollect").removeClass("mui-hide");
            showFavouriteIcon(path.replace("obs://", ""));
        }
    });

    //上一页
    $('#objLists-previous').on('click',function(){
        if(pageContext.upRefresh){
            pageContext.upRefresh = false;
            pageContext.nowPage = pageContext.nowPage-1;
            listMoreObjects(pageContext);
        }
        $(this).blur();
    });
    //下一页
    $('#objLists-next').on('click',function(){
        if(pageContext.refresh){
            pageContext.refresh = false;
            pageContext.upRefresh = false;
            pageContext.nowPage = pageContext.nowPage+1;
            listMoreObjects(pageContext);
        }
        $(this).blur();
    });
    function listMoreObjects(pageContext) {
        var marker = pageContext["page"+pageContext.nowPage];
        var bucketName = $('#curBucketName').html();
        var isSearch = $('#isSearch').val();
        var path = getCurrPath();
        var prefixPath = isSearch ? path + $("#prefixSearch").val() : path;
        var loading = loadingShow();
        bucketAndObjectAction.listObject(bucketName, 'true', prefixPath, function (err, data) {
            setTimeout(function () {
                var isLastPage = false;
                if(!data.IsTruncated) {//如果没有下一页，则将数据追加在当前页的后面
                    isLastPage = true;
                }
                listObjectUI(err, data, bucketName, false, isLastPage);
                loading.close();
                $("#listObjBodyDiv").scrollTop(10);
            }, 1500)
        }, marker);
    }

    //在线帮助
    $('#hwcloudsWeb').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        if(language==='zh'){
            gui.Shell.openExternal($(this).attr('href'));
        }else{
            gui.Shell.openExternal($(this).attr('data-href'));
        }
        return false;
    });
    //在线帮助
    $('#hkcloudsWeb').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        if(language==='zh'){
            gui.Shell.openExternal($(this).attr('href'));
        }else{
            gui.Shell.openExternal($(this).attr('data-href'));
        }
        return false;
    });

    //在线帮助
    $('#dtloudsWeb').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        if(language==='zh'){
            gui.Shell.openExternal($(this).attr('href'));
        }else{
            gui.Shell.openExternal($(this).attr('data-href'));
        }
        return false;
    });

    //隐私政策
    $('.privacyPlicy').on('click', function (e) {
        $(".mui-dropdown-menu").removeClass('mui-open');
        var gui = require('nw.gui');
        gui.Shell.openExternal($(this).attr('href'));
        return false;
    });

    //点击路径
    $("#path").delegate('a','click',function() {
        var self = this;
        if($(self).index() === $("#path").find('a').length - 1){
            return;
        }
        var bucketName = $('#curBucketName').text().trim();
        var curPath = JSON.parse($(self).children().text()).name || '';
        var isNext = false;
        //删除后面的节点
        $(self).parent().find('a').each(function () {
            $(this).removeClass('mui-hide').removeClass('content');
            if (!isNext && JSON.parse($(this).children().text()).name === curPath) {
                isNext = true;
            }
            else if (isNext) {
                $(this).remove();
            }
        });
        curPath = curPath.replace("obs://", "");
        var inputPath = "";
        if(bucketName===curPath){
            curPath = '';
            inputPath = "obs://" + bucketName + "/";
        }else{
            inputPath = "obs://" + bucketName + "/" + curPath;
        }
        $("#pathInputCollect").removeClass("mui-hide");
        showFavouriteIcon(inputPath.replace("obs://", ""));
        global.inputPath = inputPath;
        $("#pathInput").val(inputPath);
        var arr = $("#path").children();
        var leng = arr.length;
        if(arr.length>Const("NAVI_COUNT"))
        {
            for(var i=0;i<arr.length-Const("NAVI_COUNT");i++) {
                $(arr[i]).addClass('mui-hide');
            }
            $(arr[leng-Const("NAVI_COUNT")]).addClass('content');
        }
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        var loading = loadingShow();
        pageContext = {};//重置分页对象
        pageContext.nowPage = 1;
        bucketAndObjectAction.listObject(bucketName,'true',curPath, function (err,data) {
            listObjectUI(err, data,bucketName);
            loading.close();
        });
        return false;
    });

    //显示上传文件面板
    $("#uploadFiles").on('click',function(){
        if (pkg.objectColdline == true) {//是否支持温冷
            var bucket = $('#curBucketName').html();
            bucketAttributeAction.headBucket(bucket, function (err, results) {
                if (err) {
                    global.logger.warn("upload file headbucket err",err)
                } else {
                    showOverlay();
                    var selectIndex = 0;
                    if (results) {
                        var inputs = $("#uploadObjectStorageType").parent().find("input");
                        for (var index in inputs) {
                            if (inputs[index].value == results.StorageType) {
                                selectIndex = index;
                            }
                        }
                        var appElement = document.getElementById("uploadObjectStorageType");
                        var $scope = angular.element(appElement).scope();
                        $scope.object.selected.value = $scope.object.storageTypeList[selectIndex].key;
                        $scope.object.description = $scope.object.storageTypeList[selectIndex].desc;
                        $scope.file.selected.value = $scope.file.Status[1].key;
                        $scope.file.description = $scope.file.Status[1].desc;
                        $scope.$apply();
                    }
                }
            });
        }
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#uploadFileDialog").addClass('shown');
        $("#UploadFileBtn").addClass("mui-disabled");
        $("#isMove").get(0).checked = false;
        $("#showMovePath").addClass("mui-hide");
        $("#UploadFileBtn").attr('title',languageJson.obs_term_uploadObject_addFile_tip);
        $('#uploadBody').prop('scrollTop','0');
        divDragFunc('uploadFileDrag','uploadFileDialog');
        $(".mui-dropdown-menu").removeClass('mui-open');
        return false;
    });

    //点击【+ 选择文件】显示选择文件对话框
    $('#uploadFileDialog .choiceFileBtn').on('click',function () {
        var uploadFileLength = $('#uploadFileDialog .upoadFileListTitle .fileNum span').text();
        if(uploadFileLength>=uploadFileNumber){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.obs_task_uploadObject_limit_msg,
                ok:function(){},
                title:languageJson.warning
            });
            return false;
        }else{
            $('#uploadFileDialog .choiceFileInput').trigger('click');
        }
    });

    //choiceFileInput改变获取选择的文件并添加到待上传文件列表
    $('#uploadFileDialog .choiceFileInput').on('change', function () {
        var uploadFileLength = $('#uploadFileDialog .upoadFileListTitle .fileNum span').text();
        //统计
        var totalUploadFileSize = 0;
        //要上传的文件对象
        var uploadFileObjectArray = [];
        var files = $(this).get(0).files;
        for (var i = 0; i < files.length; ++i) {
            if(i<uploadFileNumber-uploadFileLength){
                var fileName = files[i].name;
                var filePath = files[i].path;
                filePath = filePath.replace(/\\/g, "/");
                var fileSize = files[i].size;

                //排除重复的对象
                var exist = false;
                var lis = $('#uploadFileDialog ul.fileLists li.file');
                $.each(lis, function(index, item) {
                    var path = $(item).data('path');
                    if(path == filePath) {
                        exist = true;
                        return;
                    }
                });
                if(!exist) {
                    totalUploadFileSize += fileSize;
                    filePath = filePath.replace(/\\/g, "/");
                    uploadFileObjectArray.push({
                        name : fileName,
                        path : filePath,
                        size : indexAction.getFileSize(fileSize),
                        originalSize : fileSize,
                        delete : global.langData.obs_browser_removeFile
                    });
                }
            }
        }
        if(uploadFileObjectArray.length > 0) {
            $("#UploadFileBtn").removeClass("mui-disabled");
            $("#UploadFileBtn").attr('title',"");
            $('#uploadFileDialog ul.fileLists').append(renderSync("listUploadObjectsItemTemplate", uploadFileObjectArray));
            setTimeout(function(){
                //文件数
                $('#uploadFileDialog .upoadFileListTitle .fileNum span').text($('#uploadFileDialog ul.fileLists li').length);
                //文件总大小
                $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(indexAction.getFileSize(culTotalUploadFileSize()));
            },500);
        }
    });

    //删除上传列表中的文件
    $("#uploadFileDialog ul.fileLists").delegate('.fileDelete','click',function(){
        $(this).parent().remove();
        //文件数
        $('#uploadFileDialog .upoadFileListTitle .fileNum span').text($('#uploadFileDialog ul.fileLists li').length);
        //清空隐藏input值
        $('#uploadFileDialog .choiceFileInput').val("");
        if($("#uploadFileDialog ul.fileLists>li").length ===0){
            $("#UploadFileBtn").addClass("mui-disabled");
            $("#UploadFileBtn").attr('title',languageJson.obs_term_uploadObject_addFile_tip);

        }
        //文件总大小
        $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(indexAction.getFileSize(culTotalUploadFileSize()));
    });
    //上传文件名title显示
    $(function () {
        $(".fileLists").delegate(".fileName","mouseenter", function () {
            if (this.offsetWidth < this.scrollWidth) {
                var text = $(this).text().trim();
                $(this).attr('title', text);
            } else {
                $(this).removeAttr('title');
            }
        });
        $("#CDNTab").delegate(".CDNTitle","mouseenter", function () {
            if (this.offsetWidth < this.scrollWidth) {
                var text = $(this).text().trim();
                $(this).attr('title', text);
            } else {
                $(this).removeAttr('title');
            }
        });
    })
    // 计算要上传文件的总大小
    var culTotalUploadFileSize = function() {
        var totalSize = 0;
        var lis = $('#uploadFileDialog ul.fileLists li');
        $.each(lis, function(index, item) {
            var size = $(item).data('originalsize');
            totalSize += parseInt(size);
        });
        return totalSize;
    }

    //上传文件确定按钮
    $('#UploadFileBtn').on('click',function(){
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        var movePath = "";
        if($("#isMove").is(":checked")){
            movePath = $("#movePathName").val();
        }
        //清除路径选择值
        $("#movePathName").val("");
        //清楚隐藏路径选择input值
        $("#choiceMovePath").val("");
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $(".mui-page-full.shown").removeClass('shown');
        var lis = $('#uploadFileDialog ul.fileLists li');
        if (lis.length === 0) {
            var htmlStr = languageJson.obs_term_uploadObject_addFile_tip;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var bucketName = $('#curBucketName').html();
        if(!bucketName){
            var htmlStr = languageJson.selectBucket;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var parentPath = getCurrPath();
        if(taskManager){
            taskManager.abortAll=false;
            taskManager.setPauseAll(false);
        }
        indexAction.loadSetting(function (configObj) {
            if(configObj) {
                global.isMD5check = configObj.isMD5check;
            }
        })
        //获取选择的存储类型
        var storageType = $('#uploadObjectStorageType').html();
        var compare = false;
        if($("#compareUpload").html() === global.langData.enable){
            compare = true;
        }
        storageType = CommonUtils.translateStorageClass(storageType);
        var filelis = $('#uploadFileDialog ul.fileLists li.file');
        $.each(filelis, function(index, item) {
            var fileName = $(item).data('name');
            var filePath = $(item).data('path');
            taskControlAction.uploadFile(bucketName, parentPath + fileName, filePath, storageType,movePath,fileName,compare);
        });
        var folderlis = $('#uploadFileDialog ul.fileLists li.folder');
        $.each(folderlis, function(index, item) {
            var path = $(item).data('path');
            path = path.replace(/\\/g, "/");
            if(!path.endsWith('/')) {
                path = path + '/';
            }
            taskControlAction.uploadPath(bucketName, parentPath, path, storageType,movePath,compare);
        });
        showCreateTasksAnimation();//加载新增任务动画效果
        taskControlAction.checkDBData();
        $('#uploadFileDialog ul.fileLists li').remove();
        //清除隐藏input的值
        $('#uploadFileDialog .choiceFileInput').val("");
        $('#uploadFileDialog #choiceFolderInput').val("");
        //文件数
        $('#uploadFileDialog .upoadFileListTitle .fileNum span').text(0);
        //文件总大小
        $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(0);
        return false;
    });

    //上传文件取消按钮
    $('#cancelUploadFile').on('click',function(){
        //清除上传列表里面的文件
        $('#uploadFileDialog ul.fileLists li').remove();
        //清除路径选择值
        $("#movePathName").val("");
        //清楚隐藏路径选择input值
        $("#choiceMovePath").val("");
        //清除隐藏input的值
        $('#uploadFileDialog .choiceFileInput').val("");
        $('#uploadFileDialog #choiceFolderInput').val("");
        //文件数
        $('#uploadFileDialog .upoadFileListTitle .fileNum span').text(0);
        //文件总大小
        $('#uploadFileDialog .upoadFileListTitle .fileSize span').text(0);
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    //显示上传文件夹dialog
    $("#uploadFolders").on('click',function(){
        if (pkg.objectColdline == true) {//是否支持温冷
            var bucket = $('#curBucketName').html();
            bucketAttributeAction.headBucket(bucket, function (err, results) {
                if (err) {
                    global.logger.warn("upload folder headbucket err ",err);
                } else {
                    showOverlay();
                    var selectIndex = 0;
                    if (results) {
                        var inputs = $("#uploadFolderObjectStorageType").parent().find("input");
                        for (var index in inputs) {
                            if (inputs[index].value == results.StorageType) {
                                selectIndex = index;
                            }
                        }
                        var appElement = document.getElementById("uploadFolderObjectStorageType");
                        var $scope = angular.element(appElement).scope();
                        $scope.object.selected.value = $scope.object.storageTypeList[selectIndex].key;
                        $scope.object.description = $scope.object.storageTypeList[selectIndex].desc;
                        $scope.$apply();
                    }
                }
            });
        }
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#uploadFolderDialog").addClass('shown');
        $("#isMoveFloder").get(0).checked = false;
        $("#showMoveFloder").addClass("mui-hide");
        divDragFunc('uploadFolderDrag','uploadFolderDialog');
        $("#uploadFolderBtn").addClass("mui-disabled");
        $("#uploadFolderBtn").attr("title",languageJson.obs_term_uploadObject_addFolder_tip);
        $(".mui-dropdown-menu").removeClass('mui-open');
        return false;
    });
    //选择db路径
    $('#chosedbPath').on('click',function () {
        $('#chosedbPathInput').trigger('click');
    });
    $('#chosedbPath1').on('click',function () {
        $('#chosedbPathInput1').trigger('click');
    });
    //input显示选择的路径
    $('#chosedbPathInput').on('change', function () {
        var path = $('#chosedbPathInput').val();
        path = path.replace(/\\/g, "/");
        if(path){
            $('#dbPath').val(path);
        }

    });
    $('#chosedbPathInput1').on('change', function () {
        var path = $('#chosedbPathInput1').val();
        path = path.replace(/\\/g, "/");
        if(path){
            $('#dbPath1').val(path);
        }
    });
    //选择上传文件后移动按钮
    $('#movePath').on('click',function () {
        $('#choiceMovePath').trigger('click');
    });
    //选择上传文件夹后移动按钮
    $('#moveFloder').on('click',function () {
        $('#choiceMoveFloder').trigger('click');
    });
    //选择的移动路径显示
    //input显示选择的路径
    $('#choiceMovePath').on('change', function () {
        var path = $('#choiceMovePath').val();
        path = path.replace(/\\/g, "/");
        $('#movePathName').val(path);
    });
    $('#choiceMoveFloder').on('change', function () {
        var path = $('#choiceMoveFloder').val();
        path = path.replace(/\\/g, "/");
        $('#moveFloderName').val(path);
    });
    //点击上传文件夹添加按钮
    $('#addFolder').on('click',function () {
        var uploadFileLength = $('#uploadFileDialog .upoadFileListTitle .fileNum span').text();
        if(uploadFileLength>=uploadFileNumber){
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.obs_task_uploadObject_limit_msg,
                ok:function(){},
                title:languageJson.warning
            });
            return false;
        }else{
            $('#choiceFolderInput').trigger('click');
        }
    });

    //input显示上传文件夹名称
    $('#choiceFolderInput').on('change', function () {
        var FolderPath = $('#choiceFolderInput').val();
        var index = FolderPath.lastIndexOf('\\');
        var FolderName = FolderPath.substring(index+1)
        if(!FolderName){
            FolderName = FolderPath.substring(0,index-1) + "$"
        }
        var lis = $('#uploadFileDialog ul.fileLists li.folder');
        var exist = false;
        if(lis.length>0){
            $.each(lis, function(index, item) {
                var path = $(item).data('path');
                if(path == FolderPath) {
                    exist = true;
                    return;
                }
            });
        }
        if(!exist && FolderPath){
            $("#UploadFileBtn").removeClass("mui-disabled");
            $("#UploadFileBtn").attr('title',"");
            var uploadFolder = {
                name:FolderName,
                path : FolderPath,
                delete : global.langData.obs_browser_removeFile
            }
            $('#uploadFileDialog ul.fileLists').append(renderSync("listUploadFoldersItemTemplate", uploadFolder));
            setTimeout(function(){
                //文件数
                $('#uploadFileDialog .upoadFileListTitle .fileNum span').text($('#uploadFileDialog ul.fileLists li').length);
            },500);
        }
        $('#uploadFileDialog #choiceFolderInput').val("");
    });

    //上传文件夹确定按钮
    $('#uploadFolderBtn').on('click',function(){
        var self = this ;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var movePath = "";
        if($("#isMoveFloder").is(":checked")){
            movePath = $("#moveFloderName").val();
        }
        $("#moveFloderName").val("");
        $("#choiceMoveFloder").val("");
        $(".mui-page-full.shown").removeClass('shown');
        var parentPath = getCurrPath();
        var path = $('#choiceFolderInput').val();
        path = path.replace(/\\/g, "/");
        if (path === '') {
            var htmlStr = languageJson.obs_term_uploadObject_addFolder_tip;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var bucket = $('#curBucketName').html();
        if (bucket) {
            isRefreshObj = true;
            if(taskManager){
                taskManager.pauseAll = false;
                taskManager.abortAll = false;
            }
            if(!path.endsWith('/')) {
                path = path + '/';
            }
            //获取选择的存储类型
            var storageType = CommonUtils.translateStorageClass($('#uploadFolderObjectStorageType').html());
            taskControlAction.uploadPath(bucket, parentPath, path, storageType,movePath);
            showCreateTasksAnimation();//加载新增任务动画效果
        } else {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.selectBucket,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        $('#choiceFolderInput').val('');
        $('#FolderName').val('');
        taskControlAction.checkDBData();
    });

    //上传文件夹取消按钮
    $('#cancelUploadFolder').on('click',function(){
        $('#choiceFolderInput').val('');
        $('#FolderName').val('');
        $("#moveFloderName").val("");
        $("#choiceMoveFloder").val("");
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $("#listObjBodyDiv").on('click',function(){
        $("#objLists tr.selected-tr-active>td:nth-child(2)").find('span').removeClass('show-span-active');
        $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#copybtn,#movebtn,#ObjectMorebtn").addClass('mui-disabled');
        cancleCheckbox();
        $("#downloadbtn,#copybtn,#movebtn").attr('data-title',languageJson.selectFileOrFolder);
        $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
        if (UCDVersion === "HEC" || UCDVersion === "HK") {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
        }else {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
        }
        $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
        $("#downloadFileName").val('');
    });

    $("#taskConcole").on('click',function(){
        $("#"+selected+" table tbody .selected-tr-active").each(function(){
            var id = $(this).attr('id');
            var task = taskManager.runningMap[id];
            if(task){
                task.active = false;
            }
        });
        $("#taskConcole tr.selected-tr-active>td").each(function () {
            $(this).find('span').removeClass('show-span-active');
        });
        $("#taskConcole tr.selected-tr-active").removeClass('selected-tr-active');
    });

    $("#objLists tbody").delegate('.mui-icon-handel-download','click',function(event){
        $(this).parent().parent().click();
        cancleCheckbox();
        setTimeout(function () {
            $('#downloadbtn').click();
        },50);
    });

    $("#objLists tbody").delegate('.mui-icon-handel-del','click',function(){
        if($(this).hasClass('mui-disabled')){
            return;
        }
        $(this).parent().parent().click();
        setTimeout(function () {
            $('#btnDeleteObjects').click();
        },50);
    });

    function removeFavouritePath(path) {
        bucketAndObjectAction.deleteFavouritePath(path, favouritePath, currentUserId, function (data) {
            indexAction.writeFavouritePath(data);
            setTimeout(function () {
                $('.mui-model').showMessage({
                    message: CommonUtils.format(languageJson.obs_term_collectPath_canceled_msg, CommonUtils.encodeForHTML(path)),
                    ok: function () {
                        var bName = $("#curBucketName").html();
                        loadFavouritePathList(bName);
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        $("#overlay").addClass('mui-hide');
                        return false;
                    },
                    title: languageJson.info
                });
            },100);
        });
    }

    // 如果点击的是左侧路径列表的删除或是增加路径，对应当前page的路径收藏图标随之改变
    function updateCurrentPageFavourIcon(pathName, isDelete) {
        var path = addEndSlash(pathName);
        var inputPath  = getInputFavouritePath();
        inputPath = inputPath.replace("obs://", "");
        // 删除或增加的是该页面路径
        if(inputPath === path){
            if(isDelete){
                $("#pathInputCollect").attr("title", languageJson.common_term_collect_button);
                $("#pathInputCollect").removeClass("uncollectInputPath");
            }else {
                $("#pathInputCollect").attr("title", languageJson.common_term_cancelCollect_button);
                $("#pathInputCollect").addClass("uncollectInputPath");
            }

        }
        var bName = $("#curBucketName").html();
        $("#objLists tr").each(function(){
            var folderName = '';
            if($(this).children('td').eq(1).children('span').children('i').hasClass("mui-icon-object-folder"))
            {
                folderName = JSON.parse($(this).find('.hiddenObjData').text()).name;
                var path2 = bName + "/" + folderName;
                if(path2 === path){
                    if(isDelete){
                        $(this).find('.mui-icon-handel-favorite').removeClass("mui-icon-handel-unfavorite");
                        $(this).find('.mui-icon-handel-favorite').attr("title", languageJson.common_term_collect_button);
                    }else {
                        $(this).find('.mui-icon-handel-favorite').addClass("mui-icon-handel-unfavorite");
                        $(this).find('.mui-icon-handel-favorite').attr("title", languageJson.common_term_cancelCollect_button);
                    }
                    return false;
                }
            }

        });
    }
    
    // 删除收藏路径
    $("#lsBucketPaths").delegate('.path-delete','click',function(){
        var path = $(this).prev().text().trim();
        updateCurrentPageFavourIcon(path, true);
        removeFavouritePath(path);
    });

    // 路径名称过长显示tip
    $("#lsBucketPaths").delegate('.mui-icon-favourite-path','mouseenter',function(){
        if (this.offsetWidth < this.scrollWidth) {
            var text = $(this).text().trim();
            $(this).attr('title', text);
        } else {
            $(this).removeAttr('title');
        }
    });

    // 点击收藏路径
    $("#lsBucketPaths").delegate('.mui-icon-favourite-path','click',function(){
        var path = $(this).text().trim();
        global.inputPath = path;
        path = path.replace("obs://", "");
        var bucket = path.split("/").shift();
        $('#curBucketName').html(bucket);
        var str = {
            name: bucket
        };
        var htmStr = renderSync("head-navi-item", {
            currPath: JSON.stringify(str),
            folderName: bucket
        });
        $(".mui-body .mui-content .path").html(htmStr);
        var prefix = path.slice(bucket.length+1);
        // 更新路径输入栏右侧的图标显示
        $("#pathInputCollect").removeClass("mui-hide");
        $("#pathInputCollect").attr("title", languageJson.common_term_cancelCollect_button);
        $("#pathInputCollect").addClass("uncollectInputPath");
        var loading =loadingShow();
        bucketAndObjectAction.listObject(bucket,"true",prefix,function(err,data){
            if(err){
                global.logger.info(err)
                if(err.message && err.message.indexOf("prefix") > -1 && err.message.indexOf("too") > -1) {
                    global.logger.error("searchPrefixTooLong!", err);
                    err.code = "searchPrefixTooLong";
                }
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function () {
                            return false;
                        }
                    });
                }
            }else{
                if ($("#objectArea").hasClass('mui-hide')) {//如果在桶列表需要切换
                    $("#objectArea").removeClass('mui-hide');//桶列表和对象列表切换
                    $("#bucketArea").addClass('mui-hide');
                    $("#objectBtnDiv").removeClass('mui-hide');
                    $("#bucketBtnDiv").addClass('mui-hide');
                    $("#prefixSearch").val("");
                    $("#all-back-div").addClass('all-back-btn');//修改后退按钮样式
                    $("#all-back-div").removeClass('all-back-btn-disabled');
                    $(".mui-font-color-gray").removeClass('mui-hide');//显示下方属性栏
                    $("#prefixSearch").attr('placeholder', languageJson.prefixSearchInfo);
                }
                if(data&&(data.Contents.length >0||data.CommonPrefixes.length>0)){//能够搜索到文件或文件夹
                    var prefix = data.Prefix;
                    var arr1 = prefix.split("/");
                    var ObjectName = arr1.pop();
                    if(ObjectName.length>0){
                        $("#isSearch").val(ObjectName);
                    }
                    var str = {
                        name: bucket
                    };
                    var htmStr = renderSync("head-navi-item", {
                        currPath: JSON.stringify(str),
                        folderName: bucket
                    });
                    $(".mui-body .mui-content .path").html(htmStr);
                    var length = 0;
                    for(var i=0;i<arr1.length;i++){
                        length+=arr1[i].length+1;
                        var str = {
                            name: prefix.slice(0,length)
                        }
                        var htmStr = renderSync("head-navi-item", {
                            currPath: JSON.stringify(str),
                            folderName: arr1[i]
                        });
                        $(".mui-body .mui-content .path").append(htmStr);
                    }
                }
                listObjectUI(err, data, bucket);
            }
            loading.close();
        });
    });
    function addFavouritePath(pathName) {
        var path = addEndSlash(pathName);
        setTimeout(function () {
            var temp = true;
            if(favouritePath && favouritePath.length!==0){//外部桶持久化文件存在
                for(var i in favouritePath){
                    if(favouritePath[i].id === currentUserId){
                        favouritePath[i].pathArr.push(path);
                        temp = false;
                        break;
                    }
                }
                if(temp){
                    var obj = {};
                    obj.id = currentUserId;
                    obj.pathArr = [path];
                    favouritePath.push(obj);
                }
            }else{
                favouritePath = [];
                var obj = {};
                obj.id = currentUserId;
                obj.pathArr = [path];
                favouritePath.push(obj);
            }
            indexAction.writeFavouritePath(favouritePath);
            $('.mui-model').showMessage({
                type:"info",
                message:CommonUtils.format(languageJson.obs_term_collectPath_added_msg, CommonUtils.encodeForHTML(path)),
                ok:function(){
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                },
                title:languageJson.info
            });
            var lsHtml = '<li data-href="' + path +'"';
            lsHtml += 'class="bucket-item ext">';
            lsHtml += '<div style="overflow: hidden;white-space: nowrap;text-overflow: ellipsis;" class="mui-icon-favourite-path mui-ellipsis-tips tooltips">'+encoderForHtml(path) + '</div><div class="path-delete"></div></li>';
            $("#lsBucketPaths").append(lsHtml);
            loadFavouritePathList("");
            updateFavouritePathCount();
        },50);
    }

    // 收藏路径
    $("#objLists tbody").delegate('.mui-icon-handel-favorite','click',function(){

        var self = this;
        var bName = $("#curBucketName").html();
        var parentPath = getCurrPath();
        var folderName =JSON.parse($(this).parent().parent().find('.hiddenObjData').text()).name;//取第五列的数据
        folderName = folderName.substring(parentPath.length,folderName.length-1);//去掉folderName最后的/
        var currPath = parentPath+folderName+'/';
        var path = bName + "/" +currPath;
        // 更改收藏的图标
        $(self).toggleClass("mui-icon-handel-unfavorite");
        if($(self).hasClass("mui-icon-handel-unfavorite")){
            if(!showPathBoundTip()){
                $(self).removeClass("mui-icon-handel-unfavorite");
                return;
            }
            $(self).attr("title", languageJson.common_term_cancelCollect_button);
            addFavouritePath(path);
        }else {
            $(self).attr("title", languageJson.common_term_collect_button);
            removeFavouritePath(path);
        }

    });

    // 路径输入框后侧的收藏点击
    $('#pathInputCollect').on('click', function () {
        var path = getInputFavouritePath();
        path = path.replace("obs://", "");
        $(this).toggleClass("uncollectInputPath");
        if($(this).hasClass("uncollectInputPath")){
            if(!showPathBoundTip()){
                $(this).removeClass("uncollectInputPath");
                return;
            }
            $(this).attr("title", languageJson.common_term_cancelCollect_button);
            addFavouritePath(path);
        }else {
            $(this).attr("title", languageJson.common_term_collect_button);
            removeFavouritePath(path);
        }
    });
    
    function getInputFavouritePath() {
        var path = "";
        $("#path a").each(function(){
            var folderName = $(this).attr("folderName");
            path += folderName + "/";
        });
        return path;
    }

    //显示下载文件框
    $('#downloadbtn').on('click', function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var name = $("#downloadFileName").val();
        $("#downloadDialog").nwsaveas = name;
        if (!name) {
            var htmlStr = languageJson.checkDownObject;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        var selectdObjects = $("#objLists tr.selected-tr-active");
        var isAllFloder = true;
        for(var i = 0;i < selectdObjects.length; i++){
            if($(selectdObjects[i]).attr("data-type") === "file"){
                isAllFloder = false;
                break;
            }
        }
        if(isAllFloder && pkg.recoverAndDownload){
            $(".mui-page-full.shown").removeClass('shown');
            $("#recoverFloderPage").addClass('shown');
            $("#recoverAndDowload").get(0).checked = false;
            $("#recoverTime,#recoverSpeed").addClass("mui-hide");
            mui.overlay('on', {"static": true, keyboard: false});
            divDragFunc('recoverFloderPageDrag','recoverFloderPage');
        }else{
            $('#downloadDialog').trigger('click');
        }
        return false;
    });

    $("body").on("dragstart",function(){
        return false;
    });

    //下载文件
    $('#downloadDialog').on('change', function (e) {
        var bucket = $('#curBucketName').html();
        var prefixSearch = $('#prefixSearch').val();
        var parentPath = getCurrPath();
        var path = $(this).val();
        path = path.replace(/\\/g, "/");
        $(this).val("");
        cancleCheckbox();
        taskControlAction.pathCheck(path, function (exist) {
            if (exist) {
                //被选中的列表
                var lis = $("#objLists tr.selected-tr-active>td:last-child");
                $("#objLists tr.selected-tr-active>td:nth-child(2)").find('span').removeClass('show-span-active');
                $("#downloadbtn,#btnDeleteObjects,#recoverBtn").addClass('mui-disabled');
                $("#downloadbtn").attr('data-title',languageJson.selectFileOrFolder);
                if (global.UCDVersion === "HEC" || UCDVersion === "HK") {
                    $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
                }else {
                    $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
                }
                $("#objLists tr.selected-tr-active").removeClass('selected-tr-active');
                if (bucket && lis && path) {
                    isShowDownErrMsg = true;
                    if(taskManager){
                        taskManager.setPauseAll(false);
                        taskManager.abortAll=false;
                    }

                    /**
                     * 与forEach相似，但不是并行执行。而是一个个按顺序执行。
                     */
                        //控制错误信息只弹出一次
                    var showMsgTemp = true;
                    //控制任务加载动画只执行一次
                    var showCreateTasks = true;
                    async.forEachSeries(lis, function(li,callback) {
                        var obj=JSON.parse($(li).text());
                        var name = obj.name;
                        if(name.charAt(name.length-1)==='/'){
                            if(showCreateTasks){
                                showCreateTasksAnimation();//加载新增任务动画效果
                                $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
                                showCreateTasks = false;
                            }
                            taskControlAction.downloadPath(bucket,parentPath,name,'',path,0, function (err) {
                                if(err){
                                    //下载失败，则创建一个失败的下载任务
                                    if(err&&showMsgTemp) {
                                        showMsgTemp = false;
                                        //超时信息错误码特殊处理
                                        var errCode = err.code === 'NetworkingError' ? "someObjectDownErr" : err.code;
                                        //为了避免加载任务动画效果和错误信息同时出现，错误信息延迟2秒显示
                                        setTimeout(function () {
                                            $('.mui-model').showErrorMessage({
                                                message: languageJson[errCode],
                                                obsError: obsError(errCode,err.message)
                                            });
                                        },2000)

                                    }
                                }
                            });
                        }else{
                            var localPath = (path+'/'+name).trim();//针对有空格的文件去空格
                            if(fs.existsSync(localPath)){
                                showOverlay();
                                $(".mui-page-full.shown").removeClass('shown');
                                $("#renameNotice").removeClass('mui-hide');
                                $("#renameNotice").addClass('shown');
                                divDragFunc('renameNoticeDrag','renameNotice');
                                var self = name;
                                var thisPath = parentPath;
                                //均保存
                                $('#rename').on('click',function () {
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#renameNotice").addClass('mui-hide');
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    var j = 0;
                                    for(var i=1;i<1000;i++){
                                        j++;
                                        var newname = self.substring(0,self.lastIndexOf('.'))+'('+j+')'+self.substring(self.lastIndexOf('.'));
                                        if(!fs.existsSync(path+'/'+newname)){
                                            break;
                                        }
                                    }
                                    if(showCreateTasks){
                                        showCreateTasksAnimation();//加载新增任务动画效果
                                        $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
                                        showCreateTasks = false;
                                    }
                                    taskControlAction.downloadFile(bucket,thisPath+self,path+'/'+newname,obj.dataSize,obj.etag);
                                    self = "";
                                    thisPath = "";
                                });
                                //覆盖
                                $('#cover').on('click',function () {
                                    $("#renameNotice").removeClass('shown');
                                    $("#renameNotice").addClass('mui-hide');
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    fs.unlink(path+'/'+self,function (err) {//先删除原有的，避免无法写入进去
                                        if(err){
                                            global.logger.info("unlink error ====",err);
                                        }
                                        if(showCreateTasks){
                                            showCreateTasksAnimation();//加载新增任务动画效果
                                            $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
                                            showCreateTasks = false;
                                        }
                                        taskControlAction.downloadFile(bucket,thisPath+self,path+'/'+self,obj.dataSize,obj.etag);
                                        self = "";
                                        thisPath = "";
                                        return false;
                                    });
                                });
                                $('#cancelDownload').on('click',function(){
                                    $("#renameNotice").removeClass('shown');
                                    $("#renameNotice").addClass('mui-hide');
                                    if ($("#mui-overlay").size() > 0) {
                                        mui.overlay('off');
                                    }
                                    return false;
                                });
                            }else{
                                if(showCreateTasks){
                                    showCreateTasksAnimation();//加载新增任务动画效果
                                    $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
                                    showCreateTasks = false;
                                }
                                taskControlAction.downloadFile(bucket,parentPath+name,path+'/'+name,obj.dataSize,obj.etag);
                            }
                        }
                        callback();
                    }, function(err) {
                        if(err){
                            logger.error('err: ' + err);
                        }
                    });
                } else {
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: languageJson.selectObjcet,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                }
            } else {
                $('.mui-model').showMessage({
                    type: "info",
                    message: languageJson.pathNotExist,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.hint
                });
            }
        });
        taskControlAction.checkDBData();
    });

    //按住ctrl键多选对象(列表显示)
    $("#objLists tbody").delegate('tr','click',function(event){
        $("#objLists tr.selected-tr-active>td:nth-child(2)").find('span').removeClass('show-span-active');
        $("#objLists tr.selected-tr-active td").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#downloadbtn,#btnDeleteObjects").addClass('mui-disabled');
        disabledBtn($("#copybtn,#movebtn,#ObjectMorebtn"));
        if($(".ObjectChecked").length<2){
            disabledBtn($("#PolicyBtn"))
        }
        if (global.UCDVersion === "HEC" || UCDVersion === "HK") {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
        }else {
            $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
        }
        $("#downloadbtn").attr('data-title',languageJson.obs_task_downloadUnavailable_tip);
        var self=this;
        if(event.ctrlKey&&event.button===0)
        {//ctrl+鼠标左键事件
            checked = true;
            checkedNum = $(self).index();
            if($("#objLists .selected-tr-active").length ===1&&$(".ObjectChecked").length ===0){//如果点击ctrl时已经有一个选中但没有勾选checkbox则都先取消选中
                $(self).parent().children().removeClass('selected-tr-active');
            }
            $(self).toggleClass('selected-tr-active');
            $(self).find(".objectCheckbox").toggleClass("ObjectChecked");
            if($(self).find(".objectCheckbox").is(":checked")){
                $(self).find(".objectCheckbox").get(0).checked = false;
            }else {
                $(self).find(".objectCheckbox").get(0).checked = true;
            }
            $("#downloadbtn,#btnDeleteObjects").toggleClass('mui-disabled');
            if($("#objLists .selected-tr-active").length < 1) {
                //在对象列表中.selected-tr-active的个数选中数量，只统计对象列表中选中的tr元素
                $("#downloadbtn,#btnDeleteObjects,#PolicyBtn").addClass('mui-disabled');
                $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            }
            if($("#objLists .selected-tr-active").length > 1){
                $("#PolicyBtn").addClass('mui-disabled');
                $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            }
            if (global.UCDVersion === "HEC" || UCDVersion === "HK") {
                $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
            }else {
                $("#recoverBtn").attr('data-title', languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
            }
            $("#downloadbtn").attr('data-title',languageJson.obs_task_downloadUnavailable_tip);
        }else if($(self).parent().children().find(".ObjectChecked").length>0&&event.button===0&&!event.shiftKey){
            //有checkbox选中且不按住shift点击时时由checkbox控制
            disabledBtn($("#downloadbtn,#btnDeleteObjects"))
        }else if(event.shiftKey&&event.button===0){//shift+鼠标左键事件
            $(self).parent().children().removeClass('selected-tr-active');
            $(".objectCheckbox").each(function () {
                $(this).get(0).checked = false;
                $(this).removeClass('ObjectChecked');
            })

            $("#downloadFileName").val("");
            if(checked)
            {
                var currCheck = $(self).index();
                var preCheck = checkedNum;
                if(currCheck<preCheck)
                {//大小排序
                    var temp = currCheck+preCheck;
                    currCheck = temp - currCheck;
                    preCheck = temp - preCheck;
                }
                var ul_arr = $("#objLists tbody tr");

                for(var i = preCheck;i<currCheck+1;i++)
                {
                    $(ul_arr[i]).addClass('selected-tr-active');
                    $(ul_arr[i]).find(".objectCheckbox").get(0).checked = true;
                    $(ul_arr[i]).find(".objectCheckbox").addClass("ObjectChecked");
                    disabledBtn($("#downloadbtn,#btnDeleteObjects"))
                }
            } else {
                checked = true;
                checkedNum = $(self).index();
                $(self).addClass('selected-tr-active');
                disabledBtn($("#downloadbtn,#btnDeleteObjects"))
            }
            if($("#objLists .selected-tr-active").length > 1){
                $("#PolicyBtn").addClass('mui-disabled');
                $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            }
        }else{
            checked = true;
            checkedNum = $(self).index();
            $(self).parent().children().removeClass('selected-tr-active');
            $("#downloadFileName").val("");
            $(self).addClass('selected-tr-active');
            disabledBtn($("#downloadbtn,#btnDeleteObjects"));
        }
        var fileNames = "";
        $("#objLists tr.selected-tr-active").each(function () {
            if($(this).children('td').eq(0).children('span').children('i').hasClass("mui-icon-object-folder"))
            {
                fileNames = fileNames + JSON.parse($(this).find('.hiddenObjData').text()).name + "|";
            }else
            {
                fileNames = fileNames + JSON.parse($(this).find('.hiddenObjData').text()).name + "|";
            }
        });
        if(pkg.objectColdline || currBucketStorage == 'Coldline'){
            if($("#objLists tr.selected-tr-active").length == 1 && $("#objLists tr.selected-tr-active").attr("data-type") == "file") {
                //冷对象时判断对象是否已经恢复
                var objectStorage = getChoseObjType();
                if (objectStorage === 'Coldline' || objectStorage === "GLACIER"){
                    var restoreState = $("#objLists tr.selected-tr-active").find('.restore_stat').text();
                    if(restoreState){//如果有恢复状态数据才根据页面判断
                        if (_.isEqual($("#objLists tr.selected-tr-active").find('.restore_stat').text(), languageJson.obs_term_restored_lable)){//先根据页面判断该对象是否为未恢复对象
                            disabledBtn($("#downloadbtn"));
                        }else{//先根据页面判断该对象是否为未恢复对象
                            $("#downloadbtn").addClass('mui-disabled');
                        }
                    }
                    var path = getCurrPath();
                    checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);
                }else{
                    disabledBtn($("#downloadbtn"));
                }
                var path = getCurrPath();
                checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);
            } else if($("#objLists tr.selected-tr-active").length == 0){
                $("#recoverBtn").addClass('mui-disabled');
            } else {
                var objData = $("#objLists tr.selected-tr-active>.hiddenObjData");
                //冷对象数量及文件夹数量
                var glacierNum = 0;
                for(var i = 0; i < objData.length; i++) {
                    var json = JSON.parse($(objData[i]).text());
                    if (json.StorageClass != 'STANDARD_IA'&& json.StorageClass != 'STANDARD') {
                        glacierNum++;
                    }
                }
                //如果只有冷对象时，显示恢复按钮
                if (glacierNum == objData.length) {
                    disabledBtn($("#recoverBtn"));
                }else {
                    $("#recoverBtn").addClass('mui-disabled');
                }
                var restoreState = $("#objLists tr.selected-tr-active").find('.restore_stat');
                var NoRestoreObjNum = 0;
                var RestoringObjNum = 0;
                for(var j = 0; j < restoreState.length; j++) {
                    if(_.isEqual($(restoreState[j]).text(), languageJson.obs_term_notRestored_lable)){
                        NoRestoreObjNum++;
                        break;
                    }
                    if(_.isEqual($(restoreState[j]).text(), languageJson.obs_term_restoring_lable)){
                        RestoringObjNum++;
                        break;
                    }
                }
                //如果有未恢复对象，置灰下载按钮
                if(NoRestoreObjNum > 0 || RestoringObjNum>0){
                    $("#downloadbtn").addClass('mui-disabled');
                }else{
                    disabledBtn($("#downloadbtn"));
                }
            }
        }

        $("#objLists tr.selected-tr-active>td:nth-child(2)").find('span').addClass('show-span-active');
        $("#objLists tr.selected-tr-active td").find('.mui-ellipsis-prototype').addClass('show-span-active');
        $("#objLists tr.selected-tr-active>td:nth-child(2)").find('span').width($("#objLists tr.selected-tr-active>td:nth-child(2)").width() - 10);
        $("#downloadFileName").val(fileNames);

        // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
        if (window.isPartnerCloud) {
            $("#PolicyBtn").addClass('mui-disabled');
        } else {
            $("#PolicyBtn").removeClass('mui-disabled');
        }
        return false;
    });

    $('.mui-icon-task-statusCheck').on('click',function(){
        $('.task-status-check').addClass('mui-active').css({top:$(this).get(0).offsetTop+$(this).get(0).offsetHeight,left:$(this).get(0).offsetLeft,width:$(this).get(0).offsetWidth});
        return false;
    });

    //根据任务状态筛选任务
    $('.task-status-check li a').on('click', function () {
        var href = $(this).attr('data-href');
        var test = $(this).html();
        $('.mui-icon-task-statusCheck').html(test);

        nowstat=href;//当前选择任务状态
        if(nowstat==='FAILED'){
            $("#taskTabHead thead").find('th').eq('5').addClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('6').addClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('7').removeClass('mui-hide');
        }else{
            $("#taskTabHead thead").find('th').eq('5').removeClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('6').removeClass('mui-hide');
            $("#taskTabHead thead").find('th').eq('7').addClass('mui-hide');
        }
        $('.task-status-check').css('top','-1440px');
        reloadTasks(true);
    });

    //多选任务
    $("#taskConcole .body tbody").delegate('tr', 'click', function () {

        $("#"+selected+" table tbody tr.selected-tr-active>td").find('.mui-ellipsis-4').removeClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-failedTask').removeClass('show-span-active');
        for(var i in taskManager.runningMap){
            taskManager.runningMap[i].active = false;
        }
        var self=this;
        if(event.ctrlKey&&event.button===0)
        {//ctrl+鼠标左键事件
            taskChecked = true;
            taskCheckedNum = $(self).index();
            $(self).toggleClass('selected-tr-active');
        }else if(event.shiftKey&&event.button===0){//shift+鼠标左键事件
            $(self).parent().children().removeClass('selected-tr-active');
            if(taskChecked)
            {
                var currCheck = $(self).index();
                var preCheck = taskCheckedNum;
                if(currCheck<preCheck)
                {//大小排序
                    var temp = currCheck+preCheck;
                    currCheck = temp - currCheck;
                    preCheck = temp - preCheck;
                }
                var ul_arr = $("#"+selected+" tbody tr");
                for(var i = preCheck;i<currCheck+1;i++)
                {
                    $(ul_arr[i]).addClass('selected-tr-active');
                }
            }else
            {
                taskChecked = true;
                taskCheckedNum = $(self).index();
                $(self).addClass('selected-tr-active');
            }
        }else{
            taskChecked = true;
            taskCheckedNum = $(self).index();
            $(self).parent().children().removeClass('selected-tr-active');
            $(self).addClass('selected-tr-active');
        }
        $("#"+selected+" table tbody tr.selected-tr-active>td").find('.mui-ellipsis-4').addClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-prototype').addClass('show-span-active');
        $("#"+selected+" table tbody tr.selected-tr-active td").find('.mui-ellipsis-failedTask').addClass('show-span-active');
        $("#"+selected+" table tbody .selected-tr-active").each(function(){
            var id = $(this).attr('id');
            var task = taskManager.runningMap[id];
            if(task){
                task.active = true;
            }
        });
        return false;
    });

    //切换用户
    $("#userList").delegate('li a.user',"click", function () {
        var self = this;
        $("#clearAccountInput").click();
        hideOtherPop();
        var id = $(self).attr('data-id');
        /**
         * $('.mui-header .controls a.btnTaskManage').hasClass('running') 加入这个判断的原因是hasRunning判断有时间间隔，当上传文件一点击完成就立马切换用户，会出现任务还没开始运行，就不会提示用户执行中的任务会被暂停
         * 为了方便快捷，影响小所以通过判断界面上右上角那个执行任务的图标来做辅助判断，因为只要有即将启动的任务这个图标就会改变成running状态，这个不会出现延迟
         */
        if(hasRunning() || $('.mui-header .controls a.btnTaskManage').hasClass('running')){
            var msg = languageJson.changeAccountWithTask;
            hasMovingTask(function(err, data){
                if(data > 0){
                    msg = languageJson.obs_switchUser_check_move_task_confirm;
                }
                $('.mui-model').showMessage({
                    type: "warning",
                    message: msg,
                    ok: function () {
                        isLoaded = false;
                        $('.btnUserInfo').addClass('userNoLogin');
                        var href = $(self).attr('data-href');
                        var showName = encoderForHtml(href).length>20?encoderForHtml(href).substring(0,20)+"...":encoderForHtml(href);
                        var str = '<span title="'+ encoderForHtml(href) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                        $(".btnUserInfo").html(str);
                        if(taskControlAction){
                            taskControlAction.pauseAllTasks(function(){
                                if(taskManager){
                                    taskControlAction.closeInterval();
                                }
                                taskControlAction.updateIteratorsObject(false);
                                changeUserUI(id);
                            });
                        }else{
                            changeUserUI(id);
                        }
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                    },
                    cancel: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                showOverlay();
            })

        }else{
            if(taskControlAction){
                taskControlAction.updateIteratorsObject(false);
            }
            isLoaded = false;
            $('.btnUserInfo').addClass('userNoLogin');
            var id = $(self).attr('data-id');
            var href = $(self).attr('data-href');
            var showName = encoderForHtml(href).length>20?encoderForHtml(href).substring(0,20)+"...":encoderForHtml(href);
            var str = '<span title="'+ encoderForHtml(href) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
            $(".btnUserInfo").html(str);
            if(taskControlAction){
                taskControlAction.pauseAllTasks(function(){
                    if(taskManager){
                        taskControlAction.closeInterval();
                    }
                    changeUserUI(id);
                });
            }else{
                changeUserUI(id);
            }
        }
    });

    // 类生产区域输入框失去焦点，判断该region是否支持开启多AZ
    $("#regionStr").blur(function(){
        var region = $("#regionStr").val();
        var appElement = document.getElementById("createBucketPage");
        var $scope = angular.element(appElement).scope();
        var storageType = $("#chosedStorageType").text();
        if( _.contains(global.supportMultiAzRegions, region)){
            $scope.isCurrentRegionSupportMultiAz = true;
        }else {
            $scope.isCurrentRegionSupportMultiAz = false;
        }
        if($.trim(storageType) === "Coldline"){
            $scope.bucket.multiAz.selectedId = '1az';
            $scope.bucket.multiAz.options[1].disable = true;
            $scope.bucket.multiAz.az_coldnotsupport_tip = languageJson.obs_term_AZ_archiveNotSupport_tip;
        }else {
            $scope.bucket.multiAz.options[1].disable = false;
            $scope.bucket.multiAz.az_coldnotsupport_tip = "";
        }
        $scope.$apply();
    });
    function showMultiAzTipByRegion() {
        $("#regionSelect").selectmenu('refresh', true);
        var region = $("#regionSelect").val();
        // var region = $("#choosedRegionStr").html();
        var appElement = document.getElementById("createBucketPage");
        var $scope = angular.element(appElement).scope();
        var storageType = $("#chosedStorageType").text();
        if( _.contains(global.supportMultiAzRegions, region)){
            $scope.isCurrentRegionSupportMultiAz = true;
        }else {
            $scope.isCurrentRegionSupportMultiAz = false;
        }
        if($.trim(storageType) === "Coldline"){
            $scope.bucket.multiAz.selectedId = '1az';
            $scope.bucket.multiAz.options[1].disable = true;
            $scope.bucket.multiAz.az_coldnotsupport_tip = languageJson.obs_term_AZ_archiveNotSupport_tip;
        }else {
            $scope.bucket.multiAz.options[1].disable = false;
            $scope.bucket.multiAz.az_coldnotsupport_tip = "";
        }
        $scope.$apply();
    }
    // 现网区域输入框的点击事件，判断该region是否支持开启多AZ
    $('#regionSelect').selectmenu().selectmenu( "menuWidget" ).on("click", function () {
        $("#choosedRegionStr").html($("#regionSelect").val());
        showMultiAzTipByRegion();
    });
    //创建桶
    $("#btnCreateBucket").on('click',function(e){
        $("#language").selectmenu('refresh', true);
        var bName=$('#bucketName').val();
        var region = '';
        if(userType==='1'){
            if(!$("#regionSelect").hasClass('mui-hide')){
                region = $("#regionSelect").val();
            }else{
                region = $("#regionStr1").html();
            }
        }else{
            region = $("#regionStr").val();
            if(region && region.length > 1024) {
                $('.mui-model').showMessage({
                    type:'warning',
                    message: languageJson.obs_term_characterLimit_info.format(languageJson.obs_term_region_column, 1024),
                    ok: function () {
                        return;
                    },
                    title: languageJson.warning
                });
                return;
            }
        }
        var str = bucketAndObjectAction.bucketNameCheck(bName,languageJson);
        var bNameIsExist = false;
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        $("#createBucketPage").css('z-index', '90');
        bucketAndObjectAction.listBucket(function(err,data){
            if(err){
                logger.error(err);
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message)
                    });
                }
                loading.close();
                $("#createBucketPage").css('z-index', '1000');
                showOverlay();
            }else{
                for (var index in data.Buckets) {
                    var bucketName = data.Buckets[index].Name;
                    if(bucketName === bName.trim()){
                        bNameIsExist = true;
                        $('.mui-model').showMessage({
                            type:'warning',
                            message: languageJson.bucketNameRepeat,
                            ok: function () {
                                $("#bucketName").focus();
                                $("#bucketName").val('');
                                $("#createBucketPage").css('z-index', '1000');
                            },
                            title: languageJson.warning
                        });
                        $("#createBucketPage").css('z-index', '90');
                        return false;
                    }
                }
                if(!bNameIsExist){
                    if(str.trim().length===0){
                        var start = new Date().getTime();
                        var storageType = $("#chosedStorageType").html();
                        var policyType = $("#chosedBucketPolicyType").html();
                        var multiAzMode = $("#chosedBucketMultiAzMode").html();
                        var multiAz =  _.contains(global.supportMultiAzRegions, region) ? (multiAzMode == '3az' ? '3az' : null) : null;
                        bucketAndObjectAction.createBucket(storageType,bName,region,multiAz,function(err,data){
                            var end = new Date().getTime();
                            logger.info('createBucket time =====',end-start);
                            if (err) {
                                if(err.code === "Unauthorized"){//创建桶未实名
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#auth").removeClass('mui-hide');
                                    $("#auth").addClass('shown');
                                    divDragFunc('authDrag','auth');
                                }
                                logger.error("create bucket err",err);
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok:function () {
                                            $("#createBucketPage").css('z-index', '1000');
                                        }
                                    });
                                }
                                loading.close();
                                $("#createBucketPage").css('z-index', '90');
                                showOverlay();
                            }
                            else {
                                // 设置桶策略
                                bucketAttributeAction.headBucket(bName, function(err, results){
                                    var policy = null;
                                    if(policyType === "private"){
                                        policy = null;
                                    }else if(policyType === "publicRead"){
                                        policy = {
                                            Id: "Policy" + $.now(),
                                            Version: "2008-10-17",
                                            Statement: {
                                                Sid: "publicReadOnlyPolicyStatementId",
                                                Effect: "Allow",
                                                Principal: {
                                                    AWS: ["*"]
                                                },
                                                Action: ["s3:GetObject", "s3:GetObjectVersion"],
                                                Resource: ["arn:aws:s3:::"+bName+"/*"]
                                            }
                                        }
                                    }else {
                                        policy = {
                                            Id: "Policy" + $.now(),
                                            Version: "2008-10-17",
                                            Statement: {
                                                Sid: "publicReadWritePolicyStatementId",
                                                Effect: "Allow",
                                                Principal: {
                                                    AWS: ["*"]
                                                },
                                                Action: ["s3:PutObject", "s3:GetObject", "s3:GetObjectVersion", "s3:DeleteObjectVersion", "s3:DeleteObject"],
                                                Resource:["arn:aws:s3:::"+bName+"/*"]
                                            }
                                        }
                                    }
                                    if (!policy) {
                                        $("#createBucketPage").removeClass('shown');
                                        $("#createBucketPage").css('z-index', '1000');
                                        $('#bucketName').val('');
                                        $("#regionStr").val('');
                                        $('#btnCeacelCreateBucket').click();
                                        var msg = CommonUtils.format(languageJson.createBucketSuccess, CommonUtils.encodeForHTML(bName));
                                        $('.mui-model').showMessage({
                                            message: msg,
                                            ok: function () {
                                                $("#createBucketPage input").each(function () {
                                                    $(this).val('');
                                                });
                                                if ($("#mui-overlay").size() > 0) {
                                                    mui.overlay('off');
                                                }
                                                $("#pathInputCollect").removeClass("mui-hide");
                                                var path = "obs://" + bName + "/";
                                                global.inputPath = path;
                                                $("#pathInput").val(path);
                                                return false;
                                            },
                                            title: languageJson.info
                                        });
                                        return;
                                    }
                                    var policyContext = JSON.stringify(policy);
                                    if (err) {
                                        global.logger.warn("Add bucket headbucket err ",err);
                                    } else {
                                        bucketAttributeAction.putBucketPolicy(bName, policyContext, function(err,data){
                                            if (err) {
                                                global.logger.error("putBucketPolicy failed.", err)
                                                if(errorConfig[err.code]){
                                                    $('.mui-model').showErrorMessage({
                                                        message: errorConfig[err.code],
                                                        obsError: obsError(err.code,err.message)
                                                    });
                                                }
                                                loading.close();
                                                return false;
                                            } else {
                                                $("#createBucketPage").removeClass('shown');
                                                $("#createBucketPage").css('z-index', '1000');
                                                $('#bucketName').val('');
                                                $("#regionStr").val('');
                                                $('#btnCeacelCreateBucket').click();
                                                var msg = CommonUtils.format(languageJson.createBucketSuccess, CommonUtils.encodeForHTML(bName));
                                                $('.mui-model').showMessage({
                                                    message: msg,
                                                    ok: function () {
                                                        $("#createBucketPage input").each(function () {
                                                            $(this).val('');
                                                        });
                                                        if ($("#mui-overlay").size() > 0) {
                                                            mui.overlay('off');
                                                        }
                                                        return false;
                                                    },
                                                    title: languageJson.info
                                                });
                                            }
                                        });
                                    }
                                });
                                bucketAndObjectAction.listBucket(function(err,data){
                                    listBucketUI(err,data,loading,bName)
                                });
                                showOverlay();
                            }
                            return false;
                        });
                    }
                    else{
                        loading.close();
                        showOverlay();
                        $("#createBucketPage").css('z-index', '1000');
                        $('.mui-model').showMessage({
                            type:"warning",
                            message:str,
                            ok:function(){
                                $('#bucketName').focus();
                            },
                            title:languageJson.warning
                        });
                        return false;
                    }
                }else{
                    loading.close();
                    $("#createBucketPage").css('z-index', '1000');
                    showOverlay();
                }
            }
        });
        return false;
    });

    $("#btnCeacelCreateBucket").on('click', function () {
        $("#createBucketPage").removeClass('shown');
        $('#bucketName').val('');
        $("#regionStr").val('');
        $('#ExBucketName').val('');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var appElement = document.getElementById("createBucketPage");
        var $scope = angular.element(appElement).scope();
        $scope.bucket.multiAz.selectedId = '3az';
        $scope.isCurrentRegionSupportMultiAz = true;
        $scope.bucket.multiAz.az_coldnotsupport_tip = "";
        $scope.$apply();
    });

    //新建文件夹
    $("#btnCreateFolder").on('click', function () {
        var path = getCurrPath();
        var bucketName = $('#curBucketName').html();
        var folderName = $("#floderName").val();
        bucketAndObjectAction.folderNameCharacter(folderName,languageJson, function (errMsg,folderName,errKey) {
            if(errMsg){
                if(errKey === "folderNameTooLarge"){
                    $('.mui-model').showErrorMessage({
                        message: languageJson.folderNameTooLarge,
                        obsError: obsError("folderNameTooLarge")
                    });
                    return false;
                }
                $("#floderName").val(folderName);
                $('.mui-model').showMessage({
                    type:'warning',
                    message: errMsg,
                    ok: function () {
                        $("#floderName").focus();
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                if(bucketName) {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    var loading = loadingShow();
                    $("#createFolderPage").css('z-index', '90');

                    //检查文件夹是否存在
                    bucketAndObjectAction.listObject(bucketName,"true",path+folderName.trim()+"/",function(err,data){
                        if(err){
                            loading.close();
                            if(errorConfig[err.code]){
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code,err.message),
                                    ok: function () {
                                        $("#createFolderPage").css('z-index', '1000');
                                        return false;
                                    },
                                });
                                showOverlay();
                            }
                        } else if (data.Contents.length >0 || data.CommonPrefixes.length >0){
                            loading.close();
                            $('.mui-model').showMessage({
                                type:'warning',
                                message: languageJson.FolderAlreadyExists,
                                ok: function () {
                                    $("#createFolderPage").css('z-index', '1000');
                                    return false;
                                },
                                title: languageJson.warning
                            });
                            showOverlay();
                        } else{
                            bucketAndObjectAction.createFolder(bucketName,path+folderName.trim()+"/",function(err,data){
                                if (err) {
                                    logger.error(err);
                                    if(errorConfig[err.code]){
                                        $('.mui-model').showErrorMessage({
                                            message: errorConfig[err.code],
                                            obsError: obsError(err.code,err.message)
                                        });
                                    }
                                    loading.close();
                                    $("#createFolderPage").css('z-index', '1000');
                                    showOverlay();
                                }
                                else {
                                    $(".mui-page-full.shown").removeClass('shown');
                                    $("#floderName").val('');
                                    loading.close();
                                    $("#createFolderPage").css('z-index', '1000');
                                    $('.mui-model').showMessage({
                                        message:CommonUtils.format(languageJson.createFolderSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(folderName)+"/")),
                                        ok: function () {
                                            if ($("#mui-overlay").size() > 0) {
                                                mui.overlay('off');
                                            }
                                            return false;
                                        },
                                        title: languageJson.info
                                    });
                                    pageContext = {};//重置分页对象
                                    pageContext.nowPage = 1;
                                    $("#prefixSearch").val('');
                                    $("#clearPrefixSearchInput").addClass("mui-hide");
                                    bucketAndObjectAction.listObject(bucketName,'true',path,function(err,data){
                                        listObjectUI(err,data,bucketName);
                                    });
                                    $("#downloadFileName").val('');
                                    showOverlay();
                                }
                                return false;
                            });
                        }
                    });
                }else
                {
                    $('.mui-model').showMessage({
                        type:"warning",
                        message:languageJson.selectBucket,
                        ok:function(){
                            return false;
                        },
                        title:languageJson.warning
                    });
                }
            }
        },path);
    });

    //关闭新建文件夹页面
    $("#btnCeacelCreateFolder").on('click', function () {
        $("#createFolderPage").removeClass('shown');
        $('#floderName').val('');
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //检查更新
    $("#checkUpdate").on('click', function () {
        //升级功能
        mosUpdate(true);
    });
    var objectpolicy = undefined;
    //policy授权界面展示
    $("#PolicyBtn").on("click", function () {
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        $("#allPolicy").get(0).checked = false;
        $("#deletePolicy").addClass("mui-disabled");
        objectpolicy = undefined;
        var loading =loadingShow();
        accessConnector.queryUsers(function(err,data){
            loading.close();
            if(err){
                $("#DomainID").removeClass("mui-hide");
                $("#DomainID").addClass('shown');
                divDragFunc('DomainIDDrag','DomainID');
                showOverlay();
            }else{
                var Bucket = $("#curBucketName").html();
                var path = getCurrPath();
                var ObjectName = getChoseObjName();
                var key = Bucket + '/' + path + ObjectName;
                bucketAttributeAction.getBucketPolicy(Bucket, function (err, data) {
                    if (err) {
                        if (err.code === "NoSuchBucketPolicy") {
                            data = {Policy: ""};
                        } else {
                            logger.error("get  buecktPolicy failed......", Bucket, err);
                            if (errorConfig[err.code]) {
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code, err.message),
                                    ok: function () {
                                        $(".refreshCtx").click();
                                        return false
                                    }
                                });
                                return;
                            }
                        }
                    }
                    //获取桶策略成功，传过去
                    var policy = data.Policy;
                    objectpolicy = new ObjectPolicy(key, policy);
                    loadObjectPolicyListPage(objectpolicy);
                    $("#ObjectName").val(key);
                    $("#ObjectName").attr('title',key);
                    $(".ObjectName").html(key);
                    $(".ObjectName").attr('title',key);
                    $(".mui-page-full.shown").removeClass('shown');
                    $("#Policy").addClass('shown');
                    $("#Policy").css('z-index',"1000");
                    $("#Policy").removeClass('mui-hide');
                    divDragFunc('PolicyDrag', 'Policy');
                    showOverlay();
                });
            }
        });
    });
    //更多里的policy
    $("#ObjectPolicy").on("click",function () {
        $("#PolicyBtn").click();
    })
    //文件夹的单行policy
    $("#objLists tbody").delegate('.mui-icon-handel-policy','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $("#PolicyBtn").click();
        },10);
    });
    function loadObjectPolicyListPage(objectpolicy){
        var user = [];
        if(objectpolicy.statements.length>0){
            for(var i=0;i<objectpolicy.statements.length;i++){
                var Sid = objectpolicy.statements[i].Sid;
                var userinfo = objectpolicy.statements[i].getUserInfo();
                var username = [];
                var ids = [];
                var permission,action;
                for(var j = 0 ;j<userinfo.length;j++){
                    username.push(userinfo[j].name);
                    ids.push(userinfo[j].id);
                }
                if(objectpolicy.statements[i].actionToStr() === "r"){
                    action = 'r';
                    permission = languageJson.obs_objectPolicy_read_option;
                }else if(objectpolicy.statements[i].actionToStr() === "rw"){
                    action = "rw";
                    permission = languageJson.obs_objectPolicy_readAndWrite_option;
                }else{
                    action = "other";
                    permission = languageJson.others;
                }
                user.push(
                    {
                        name:username.join(","),
                        id:ids.join("/"),
                        sid:Sid,
                        action:action,
                        permission:permission,
                        edit:global.langData.edit,
                        delete : global.langData.delete
                    })
            }
        }
        $("#PolicyTab tbody").html(renderSync("SimplePolicyTemplate", user));
    }
    //保存policy授权
    $("#savePolicy").on("click", function () {
        var afterFunc=function(err){
            if (err) {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code, err.message),
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    }
                });
                return;
            }else{
                $('.mui-model').showMessage({
                    message:languageJson.obs_objectPolicy_createSuccess_msg,
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.info
                });
            }
            $("#Policy").removeClass('shown');
            $("#Policy").addClass('mui-hide');
        };

        var Bucket = $("#curBucketName").html();
        if (!objectpolicy) {
            logger.error("no object found,not possible.", Bucket)
            return false;
        }

        var bucketPolicyStr = objectpolicy.save();
        if(bucketPolicyStr) {
            bucketAttributeAction.putBucketPolicy(Bucket, bucketPolicyStr, function (err, data) {
                afterFunc(err);
            });
        }else{
            bucketAttributeAction.delBucketPolicy(Bucket, function (err, data) {
                afterFunc(err);
            });
        }
        return false;
    })

    //关闭policy授权页面
    $("#closePolicy").on("click", function () {
        $("#Policy").removeClass('shown');
        $("#Policy").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    })

    //输入domainID确定
    $("#subDomainID").on('click',function () {
        var domainID = $("#DomainIDIput").val().trim();
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading =loadingShow();
        accessConnector.queryUsers(domainID,function(err,data){
            loading.close();
            if(err){
                global.logger.info("use domainID queryUsers failed",err)
                var messages = languageJson.obs_objectPolicy_accountIDError_msg;
                $('.mui-model').showErrorMessage({
                    message: messages,
                    ok: function () {
                        $("#DomainID").css("z-index","1000");
                    }
                });
                showOverlay();
            }else{
                $("#DomainIDIput").val("");
                $("#DomainID").removeClass('shown');
                $("#DomainID").addClass('mui-hide');
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                $("#PolicyBtn").click();
                return false;
            }
        })
    });
    //输入domainID取消
    $("#cancelDomainID").on('click',function () {
        $("#DomainIDIput").val("")
        $("#DomainID").removeClass('shown');
        $("#DomainID").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });
    //新建policy
    $("#AddPolicy").on("click", function () {
        initPolicyPage();
    });

    function initPolicyPage(action = undefined, selectUserInfoes = "", Sid = undefined,) {
        var appElement = document.getElementById("CreatePolicy");
        var $scope = angular.element(appElement).scope();
        if (action !== "r" && action !== "rw") {
            action = "r";
        }
        $scope.permissionSelected.value = action;
        $scope.Sid = Sid;
        $scope.objectPolicy = objectpolicy;
        var options = [];
        accessConnector.userCache.forEach(function (data) {
            options.push({label: data.name, id: data.id, "data": data});
        })
        $scope.simplePolicyModel.options = options;
        $scope.simplePolicyModel.selectedUserId = [];
        for (let selectUserID of selectUserInfoes.split("/")) {
            $scope.simplePolicyModel.selectedUserId.push(selectUserID);
        }
        $scope.$digest();
        $("#Policy").css("z-index", "90");
        $("#CreatePolicy").removeClass("mui-hide");
        $("#CreatePolicy").addClass('shown');
        divDragFunc('CreatePolicyDrag', 'CreatePolicy');
    }
    //编辑policy
    $("#PolicyTab tbody").delegate('.editPolicy', 'click', function () {
        $("#CreatePolicyDrag .mui-page-full-title").html(languageJson.obs_objectPolicy_edit_button);
        var self = this;
        var ids = $(self).parent().parent().parent().data("id");
        var action = $(self).parent().parent().parent().data("action");
        var Sid = $(self).parent().parent().parent().data("sid");
        initPolicyPage(action, ids, Sid);
    });
    //删除单行policy
    $("#PolicyTab tbody").delegate('.deletePolicy','click',function(){
        var self = this;
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: languageJson.obs_objectPolicy_del_msg,
                isFocus: true,
                ok: function () {
                    var Sid = $(self).parent().parent().parent().data("sid");
                    objectpolicy.deleteSimplePolicy(Sid);
                    loadObjectPolicyListPage(objectpolicy);
                    return false;
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_objectPolicy_del_winTitle
            }
        );
    })
    //删除选中policy
    $("#deletePolicy").on("click",function () {
        var self = this ;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        var arr = $("#PolicyTab .checkedPolicy");
        if(arr.length>1){
            var message = languageJson.obs_objectPolicy_delMulti_msg.format(arr.length);
        }else{
            var message = languageJson.obs_objectPolicy_del_msg;
        }
        $('.mui-model').showMessage(
            {
                type: "warning",
                message: message,
                isFocus: true,
                ok: function () {
                    $("#PolicyTab .checkedPolicy").each(function () {
                        var self = this;
                        var Sid = $(self).parent().parent().data("sid");
                        objectpolicy.deleteSimplePolicy(Sid);
                    })
                    loadObjectPolicyListPage(objectpolicy);
                    return false;
                },
                cancel: function () {
                    return false;
                },
                title: languageJson.obs_objectPolicy_del_winTitle
            }
        );
    })
    //policy单选checkbox
    $("#PolicyTab tbody").delegate('.policyCheck','click',function () {
        var self = this;
        if($(self).is(":checked")){
            $("#deletePolicy").removeClass("mui-disabled");
            $(self).addClass("checkedPolicy");
            if($("#PolicyTab .checkedPolicy").length === $("#PolicyTab tr").length){
                $("#allPolicy").get(0).checked = true;
            }
        }else{
            $(self).removeClass("checkedPolicy");
            $("#allPolicy").get(0).checked = false;
            if($("#PolicyTab .checkedPolicy").length===0){
                $("#deletePolicy").addClass("mui-disabled");
            }
        }
    })
    //全选policy
    $("#allPolicy").on("change",function () {
        var self = this;
        if($("#PolicyTab tbody tr").length<1){//没有策略则直接返回
            return false;
        }
        if($(self).is(":checked")){
            $("#deletePolicy").removeClass("mui-disabled");
            $(".policyCheck").each(function () {
                $(this).get(0).checked = true;
                $(this).addClass("checkedPolicy");
            })
        }else{
            $("#deletePolicy").addClass("mui-disabled");
            $(".policyCheck").each(function () {
                $(this).get(0).checked = false;
                $(this).removeClass("checkedPolicy");
            })
        }
    })
    //复制对象
    $("#copyObjectPath").on("click",function () {
        var Url2=document.getElementById("ObjectName");
        Url2.select(); // 选择象
        document.execCommand("Copy");
        $('.mui-model').showMessage({//增加复制成功提示信息
            type:"info",
            message:languageJson.obs_objectPolicy_copyObjectSuccess_msg,
            ok:function(){
                return false;
            },
            title:languageJson.info
        });
    });
    //取消选中框
    function cancleCheck() {
        
    }
    //恢复并下载checkbox
    $("#recoverAndDowload").on("change",function () {
        var self = this ;
        if($(self).is(":checked")){
           $("#recoverTime,#recoverSpeed").removeClass("mui-hide");
        }else{
            $("#recoverTime,#recoverSpeed").addClass("mui-hide");
        }
    });
    //上传移动文件显示
    $("#isMove").on("change",function () {
        var self = this ;
        if($(self).is(":checked")){
            $("#showMovePath").removeClass("mui-hide");
        }else{
            $("#showMovePath").addClass("mui-hide");
        }
    });
    //上传移动文件夹显示
    $("#isMoveFloder").on("change",function () {
        var self = this ;
        if($(self).is(":checked")){
            $("#showMoveFloder").removeClass("mui-hide");
        }else{
            $("#showMoveFloder").addClass("mui-hide");
        }
    });
    //选择下载路径
    $("#chosePath").on("click",function () {
        $("#downloadFloder").trigger("click");
    });
    //选择文件夹下载后显示在文本框中
    $("#downloadFloder").on("change",function () {
        var self = this ;
        $("#recoverAndDowloadPath").val($(self).val());
    })
    $("#createBucketPageDrag,#createFolderPageDrag,#ExBucketPageDrag").on('mousedown',function(){
        $('.help-tips').html('');
        $('.help-tips').css('top','-650px');
        $('.help-tips').removeClass('active');
    });
    //关闭系统配置页面
    $("#cancelSysConfig").on('click', function () {
        $("#config").removeClass('shown');
        $("#systemConfig").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    });

    //关闭账户配置页面
    $("#cancelAccountBth").on('click', function () {
        $('#createAccount input').each(function () {
            $(this).val('');
        });
        $("#isSaveSK").get(0).checked = true;
        $("#accountList").css('z-index','1000');
        if($("#saveAccountBtn").attr('data-init')==='true'){
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            $("#saveAccountBtn").removeAttr('data-init');
        }
        if($("#saveAccountBtn").attr('data-edit')==='true'){
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
            $("#saveAccountBtn").removeAttr('data-edit');
        }
        $("#createAccount").removeClass('shown');
        $("#createAccountTab").addClass('mui-hide');
    });

    //读取系统配置信息
    $('#sysSetting').on('click', function () {
        if(UCDVersion == 'HEC'){
            $("#MD5check").parent().removeClass('mui-hide');
        }
        indexAction.loadSetting(function (configObj) {
            if (configObj) {
				//伙伴云场景下屏蔽KMS,同时把保存的KMS的配置修改为false
                if(UCDVersion === 'HEC'){
                    if (global.cloudType === 1) {
                        configObj.isServerEncryption = false;
                        global.serverEncryption = false;
                        $('#serverEncryptionDiv').hide();
                    } else {
                        $('#serverEncryptionDiv').show();
                    }
                }
                $("#isAutoUpdate").get(0).checked = ("Y" === configObj.isAutoUpdate);
                $("#isHttps").get(0).checked = ("Y" === configObj.isHttps);
                $("#isSSL").get(0).checked = ("Y" === configObj.isSSL);
                $("#MD5check").get(0).checked = ("Y" === configObj.isMD5check);
                if(configObj.isHttps === "Y"){
                    $("#isSSL").attr("disabled",false);
                    $("#isSSL").next().removeClass("ti-text-muted");
                    $("#serverEncryption").attr("disabled",false);
                    $("#serverEncryption").next().removeClass("ti-text-muted");
                    ;                }
                //服务端加密显示
                if(isShowServerEncryption){
                    $("#serverEncryption").get(0).checked = (true == configObj.isServerEncryption);
                }
                if (configObj && configObj.uploadTaskNum) {
                    uploadTaskNum = parseInt(configObj.uploadTaskNum);
                    $("#uploadTaskNum").val(uploadTaskNum);
                }
                if (configObj && configObj.downloadTaskNum) {
                    downloadTaskNum = parseInt(configObj.downloadTaskNum);
                    $("#downloadTaskNum").val(downloadTaskNum);
                }
                if(configObj.language){
                    $("#language").val(configObj.language);
                    $("#language").selectmenu('refresh', true);
                    //如果语言配置文件不存在，则显示默认语言
                    if(!$("#language").val()){
                        $("#language").val(curLang);
                        $("#language").selectmenu('refresh', true);
                    }
                    //如果当前语言为中文并且版本为DT版本或者Russia，修改语言配置
                    if($("#language").val()=='zh'&& (UCDVersion === 'Russia' || UCDVersion === 'DT')){
                        $("#language").val('en');
                        $("#language").selectmenu('refresh', true);
                    }
                }
                if(configObj.multiUploadNum){
                    $("#multiUploadNum").val(configObj.multiUploadNum);
                    $("#multiUploadNum").removeAttr('disabled');
                }
                if(configObj.multiDownloadNum){
                    $("#multiDownloadNum").val(configObj.multiDownloadNum);
                    $("#multiDownloadNum").removeAttr('disabled');
                }

                if(configObj.proxy){
                    $("#isProxy").get(0).checked = (configObj.proxy.isProxy);
                    if(configObj.proxy.isProxy){
                        $("#proxyAddress").val(configObj.proxy.proxyIP).removeAttr('disabled');
                        $("#proxyPort").val(configObj.proxy.proxyPort).removeAttr('disabled');
                        $("#isAuthentication").removeAttr('disabled');
                        $("#proxyAuth,#proxyInfo").removeClass('mui-hide');
                    }else{
                        $("#proxyAuth,#proxyInfo").addClass('mui-hide');
                        $("#proxyAddress").val('').attr('disabled',true);
                        $("#proxyPort").attr('disabled',true);
                        $("#proxyPort").val('8080');
                        $("#isAuthentication").attr('disabled',true);
                    }
                    $("#isAuthentication").get(0).checked = (configObj.proxy.isAuthentication);
                    if(configObj.proxy.isAuthentication){
                        $("#proxyusname").val(configObj.proxy.proxyUserName).removeAttr('disabled');
                        $("#proxypswd").next().val(pwdPlaceHolder).removeAttr('disabled');
                        $("#proxypswd").val(configObj.proxy.proxyPwd);   //隐藏的控件保存原值
                        $("#proxydomain").val(configObj.proxy.proxyDomain).removeAttr('disabled');
                    }else{
                        $("#proxyusname").val('').attr('disabled',true);
                        $("#proxypswd").next().val('').attr('disabled',true);
                        $("#proxydomain").val('').attr('disabled',true);
                    }
                }
                if(configObj.dbpath){
                    $("#dbPath").val(configObj.dbpath);
                }else{
                    $("#dbPath").val(global.appDataPath+"data");
                }
                if(configObj.objPerPageSize) {
                    $("#objPerPageSize").val(configObj.objPerPageSize);
                }
            }else if(language){
                $("#language").val(language);
                $("#language").selectmenu('refresh', true);
                if($("#language").val()=='zh'&&(UCDVersion === 'DT' || UCDVersion === 'Russia')){
                    $("#language").val('en');
                    $("#language").selectmenu('refresh', true);
                }
            }

            //DT版本只有英文版，去掉语言选择配置项
            if(UCDVersion==='DT'){
                $("#language").val('en');
                $("#language").selectmenu('refresh', true);
                $("#languageDiv").addClass('mui-hide');
            } else if(UCDVersion === 'CTC' || _.isEqual(UCDVersion,"CMCC")) {//CTC和CMCC版本只有中文版，去掉语言选择配置项
                $("#language").val('zh');
                $("#language").selectmenu('refresh', true);
                $("#languageDiv").addClass('mui-hide');
            }
            $("#systemConfig").removeClass('mui-hide');
            $("#config").addClass('shown');
            return false;
        });
        $("#general").click();
        divDragFunc('configDrag','config');
        showOverlay();
        tabFocus("subSysConfig");
    });
    //对象列表选中框
    $('#objLists').delegate('.objectCheckbox',"mousedown", function (ev) {
        var self = this ;
        $(self).parent().parent().parent().children().find('.mui-ellipsis-prototype').removeClass('show-span-active');
        if($(".ObjectChecked").length<1){//无checkbox选中时点击选中取消其他tr样式
            $(self).parent().parent().siblings().removeClass("selected-tr-active")
        }
        if($(self).is(":checked")){
            $(self).get(0).checked = false;
            $(self).removeClass('ObjectChecked');
            $("#allObject").get(0).checked = false;
            $(self).parent().parent().removeClass("selected-tr-active")
        }else{
            $(self).get(0).checked = true;
            $(self).addClass('ObjectChecked');
            $(self).parent().parent().addClass("selected-tr-active");
            if($(".ObjectChecked").length>1){
                $("#PolicyBtn").addClass('mui-disabled');
                $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            }
        }
        if($(".ObjectChecked").length === $("#objLists tr").length){
            $("#allObject").get(0).checked = true;
        }
        return false;
    })
    //选中所有
    $("#allObject").on("click",function () {
        var self = this;
        if($(self).is(":checked")){
            allBucttion();
            if($("#objLists tr").length===1){
                disabledBtn($("#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn"));
                // if(storage != "STANDARD" && storage != "STANDARD_IA"){
                //     disabledBtn($("#recoverBtn"));
                // }
            }else if($("#objLists tr").length ===0){
                $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
                $("#movebtn,#copybtn").attr('data-title', languageJson.selectFileOrFolder);
                $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            }else{
                $("#PolicyBtn").addClass("mui-disabled");
                disabledBtn($("#movebtn,#copybtn,#ObjectMorebtn"));
                $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            }
            disabledBtn($("#recoverBtn"));
            $(".objectCheckbox").each(function () {
                $(this).get(0).checked = true;
                $(this).addClass('ObjectChecked');
                $(this).parent().parent().addClass("selected-tr-active");
                var hiddenObjData = $(this).parent().parent().find(".hiddenObjData").text();
                hiddenObjData = JSON.parse(hiddenObjData);
                var storage = hiddenObjData.StorageClass;
                if(storage === "STANDARD" || storage === "STANDARD_IA"){
                    $("#recoverBtn").addClass("mui-disabled");
                }
            })
        }else{
            $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
            $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
            $("#movebtn,#copybtn").attr('data-title', languageJson.selectFileOrFolder);
            $(".objectCheckbox").each(function () {
                $(this).get(0).checked = false;
                $(this).removeClass('ObjectChecked');
                $(this).parent().parent().removeClass("selected-tr-active");
            })
        }
        // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
        if (window.isPartnerCloud) {
            $("#PolicyBtn").addClass('mui-disabled');
        } else {
            $("#PolicyBtn").removeClass('mui-disabled');
        }
    });
    //复制按钮点击
    $("#copybtn").on("click",function(){
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        var lis = $("#objLists tr.selected-tr-active");
        var arr = [];
        var bucket = $("#curBucketName").html();
        var location = getCurrPath();
        for(var i=0; i<lis.length;i++){
            var obj = JSON.parse($(lis[i]).find('.hiddenObjData').text());
            var isFloder = $(lis[i]).attr("data-type") === "folder";
            var objKey = "";
            var objSize,objName
            if(isFloder){
                objKey = obj.name;
                objSize = "--";
                var splitArray = obj.name.split("/");
                objName = splitArray[splitArray.length-2] + "/";
            }else{
                objKey = location + obj.name;
                objSize = obj.dataSize;
                objName = obj.name
            }
            arr.push(
                {
                    key:objKey,
                    size:objSize,
                    name:objName,
                    isFolder:isFloder
                }
            );
        }
        global.glbClipboard.addAll(bucket,location,TaskEnum.TASK_TYPE.copy.value,arr);
    });
    //移动按钮点击
    $("#movebtn").on("click",function(){
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        var lis = $("#objLists tr.selected-tr-active");
        var arr = [];
        var bucket = $("#curBucketName").html();
        var location = getCurrPath();
        for(var i=0; i<lis.length;i++){
            var obj = JSON.parse($(lis[i]).find('.hiddenObjData').text());
            var isFloder = $(lis[i]).attr("data-type") === "folder";
            var objKey = "";
            var objSize,objName
            if(isFloder){
                objKey = obj.name;
                objSize = "--";
                var splitArray = obj.name.split("/");
                objName = splitArray[splitArray.length-2] + "/";
            }else{
                objKey = location + obj.name;
                objSize = obj.dataSize;
                objName = obj.name
            }
            arr.push(
                {
                    key:objKey,
                    size:objSize,
                    name:objName,
                    isFolder:isFloder
                }
            );
        }
        global.glbClipboard.addAll(bucket,location,TaskEnum.TASK_TYPE.move.value,arr);
    });
    //重命名
    $(".renameCtx").on("click",function () {
        var objName = getChoseObjName();
        $(".isCopy").addClass("mui-hide");
        $("#newName").val(objName);
        $(".mui-page-full.shown").removeClass('shown');
        $("#ObjectRename").addClass('shown');
        $("#ObjectRename").css('z-index',"1000");
        $("#ObjectRename").removeClass('mui-hide');
        divDragFunc('ObjectRenameDrag', 'ObjectRename');
        $("#newName").focus();
        showOverlay();
        return false;
    });
    //重命名确定
    $("#saveObjectRename").on("click",function () {
        var newName = $("#newName").val().trim();
        var bName = $("#curBucketName").html();
        var prefix = getCurrPath();
        if(!newName){
            $('.mui-model').showMessage({
                type:'warning',
                message: languageJson.obs_term_renameObject_nameNull_msg,
                ok: function () {
                    return;
                },
                title: languageJson.warning
            });
            return false;
        }else if(newName.indexOf("/") >= 0){
            $('.mui-model').showMessage({
                type:'warning',
                message: languageJson.obs_term_renameObject_valid_0001,
                ok: function () {
                    return;
                },
                title: languageJson.warning
            });
            return false;
        }else if((prefix+newName).length>1023){
            $('.mui-model').showMessage({
                type:'warning',
                message: languageJson.KeyTooLong,
                ok: function () {
                    return;
                },
                title: languageJson.warning
            });
            return false;
        }
        bucketAndObjectAction.headObject(bName,prefix+newName,function (err,data) {
            if(err){
                if(err.code === "NoSuchKey"){
                    if (taskManager) {
                        taskManager.setPauseAll(false);
                        taskManager.abortAll = false;
                    }
                    if($("#objLists tr.selected-tr-active").length>0){
                        var Objkey = getChoseObjKey();
                        var size = getChoseObSize();
                        taskControlAction.pasteObject(bName,prefix+newName,bName,Objkey,size,TaskEnum.TASK_TYPE.rename.value,TaskEnum.TASK_STAT.wait.value)
                    }else{
                        var Objkey = global.glbClipboard.contents[0].key;
                        var size = global.glbClipboard.contents[0].size;
                        taskControlAction.pasteObject(bName,prefix+newName,bName,Objkey,size,global.glbClipboard.action,TaskEnum.TASK_STAT.wait.value)
                    }
                    $("#ObjectRename").removeClass('shown');
                    $("#ObjectRename").addClass('mui-hide');
                    showCreateTasksAnimation();
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                }else{
                    if(errorConfig[err.code]){
                        $('.mui-model').showErrorMessage({
                            message: errorConfig[err.code],
                            obsError: obsError(err.code,err.message),
                            ok: function () {
                                return false;
                            }
                        });
                    }
                }
            }else{
                $('.mui-model').showMessage({
                    type:'warning',
                    message: languageJson.obs_term_renameObject_nameSame_msg,
                    ok: function () {
                        return;
                    },
                    title: languageJson.warning
                });
                return false;
            }
        })
    });
    //重命名取消
    $("#closeObjectRename").on("click",function () {
        $("#ObjectRename").removeClass('shown');
        $("#ObjectRename").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });
    //粘贴
    $("#pastebtn").on("click",function(){
        var self = this;
        if($(self).hasClass("mui-disabled")){
            return false;
        }
        $(".pasteCtx").click();
    })
    function allBucttion() {
        disabledBtn($("#downloadbtn,#btnDeleteObjects"));
        var arr_tr = $("#objLists tr");
        var currFileName = '';
        arr_tr.each(function(i,obj){
            var fileName = '';
            if($(obj).find('td').eq(0).find('span i').hasClass("mui-icon-object-folder"))
            {
                fileName = JSON.parse($(obj).find('.hiddenObjData').text()).name;
            }else
            {
                fileName = JSON.parse($(obj).find('.hiddenObjData').text()).name;
            }
            if(currFileName.indexOf(fileName)===-1)
            {//判断被选择文件是否已经存在于已选文件
                currFileName = currFileName+fileName+"|";
            }
        });
        $("#downloadFileName").val(currFileName);
        //全选下载按钮是否置灰
        var restore_state = $("#objLists tr").find('.restore_stat');
        var no_restore_objNum=false;
        for(var j = 0; j < restore_state.length; j++) {
            if(_.isEqual($(restore_state[j]).text(), languageJson.obs_term_notRestored_lable)){
                no_restore_objNum=true;
                break;
            }
            if(_.isEqual($(restore_state[j]).text(), languageJson.obs_term_restoring_lable)){
                no_restore_objNum=true;
                break;
            }
        }
        //如果有未恢复对象，置灰下载按钮
        if(no_restore_objNum){
            $("#downloadbtn").addClass('mui-disabled');
        }else{
            disabledBtn($("#downloadbtn"));
        }

        //属性按钮置灰
        if($("#objLists tr").length == 1 && $("#objLists tr").attr("data-type") == "file") {
            //判断对象是否已经恢复
            var path = getCurrPath();
            checkObjectRestore(path + JSON.parse($("#objLists tr").find('.hiddenObjData').text()).name);
        } else {
            disabledBtn($("#recoverBtn"));
        }
        //全选后，当选中对象中存在不符合恢复条件对象时，禁用恢复按钮
        var category=$("#objLists tr td:nth-child(2)").find('span');
        for(var i=0;i<category.length;i++){
            if(UCDVersion === "HEC" || UCDVersion === "HK"){
                if($(category[i]).html() != languageJson.obs_term_coldline_lable_HEC){
                    $("#recoverBtn").addClass("mui-disabled");
                    $("#recoverBtn").attr("disabled",true);
                    $("#recoverBtn").attr("title",languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
                    break;
                }
            }else{
                if($(category[i]).html() != languageJson.obs_term_coldline_lable){
                    $("#recoverBtn").addClass("mui-disabled");
                    $("#recoverBtn").attr("disabled",true);
                    $("#recoverBtn").attr("title",languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
                    break;
                }
            }
        };
    }
    $('#objLists').delegate('.mui-icon-handel-download','mouseenter', function (e) {
        $(this).attr('title',languageJson.down);
    });

    $('#objLists').delegate('.mui-icon-handel-del','mouseenter', function (e) {
        $(this).attr('title', languageJson.delete);

    });

    $('#objLists').delegate('.mui-icon-handel-share','mouseenter', function (e) {
        $(this).attr('title',languageJson.objectAttr);
    });
    //实名认证确定按钮
    $("#sureAuth").on("click",function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#auth").addClass('mui-hide');
        $("#createBucketPage input").each(function () {//清空创建桶页面input值
            $(this).val('');
        });
    })
    //修改路径后确认关闭
    $("#savePath").on("click",function () {
        var dbpath = $("#dbPath1").val().trim();
        if(dbpath.length>0){//如果配置了db路径
            if((/[\u4e00-\u9fa5]/).test(dbpath)){//路径不能为中文
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.obs_browser_setDBPath_valid,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                if(fs.existsSync(global.appDataPath + "setting")){
                    var setting = fs.readFileSync(global.appDataPath + "setting", "utf-8");
                    var b = new Base64();
                    var base64Str = b.decode(setting);
                    setting = JSON.parse(base64Str);
                    setting.dbpath = dbpath;
                    var base64 = b.encode(JSON.stringify(setting));
                    fs.writeFileSync(global.appDataPath + 'setting', base64);
                }
                $(".mui-page-full.shown").removeClass('shown');
                $("#mongodbPath").addClass('mui-hide');
                // 备份账户信息
                backupAccountInfos();
            }
        }
    })
    //修改路径取消
    $("#cancelPath").on("click",function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#mongodbPath").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
    })

    $(".mui-model .mui-model-close").on('click', function () {
        $(this).parent().removeClass('mui-active').removeClass('mui-model-mini');
        $('.mui-btn.cancel').click();
        $('.mui-btn.ok').click();
        $(this).parent().find('.mui-btn.ok,.mui-btn.cancel').unbind();
        return false;
    });

    $("#serverEncryption").on("change", function(){
        var checked = $("#serverEncryption").is(":checked");
        if(checked) {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.defaultKMSKeyInit,
                ok: function () {
                    return false;
                },
                cancel: function () {
                    $("#serverEncryption").get(0).checked = false;
                    return false;
                },
                title: languageJson.warning
            });
        }
    })
    //保存系统配置信息
    $("#subSysConfig").click(function () {
        var configObj = {};
        isAutoUpdate = $("#isAutoUpdate").is(":checked") ? 'Y' : 'N';
        configObj.isAutoUpdate = isAutoUpdate;
        userExperience = $("#userExperience").is(":checked") ? 'Y' : 'N';
        configObj.isMD5check = $("#MD5check").is(":checked") ? "Y" : "N";
        if(UCDVersion !== 'HEC'){
            configObj.isMD5check = 'N';
        }
        global.isMD5check = configObj.isMD5check;
        configObj.userExperience = userExperience;
        language = $("#language").val();
        configObj.mongoAuthPwd = global.newMongoPwd;
        //服务端加密信息保存
        var isServerEncryption = $("#serverEncryption").is(":checked") ? true : false;

        if(isServerEncryption){
            if(!$("#isHttps").is(":checked")){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.isUsedHttps,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }
        }

        global.serverEncryption = isServerEncryption;
        configObj.isServerEncryption = isServerEncryption;

        //读取系统语言
        configObj.language = language;
        var valUpload= $("#uploadTaskNum").val().trim();
        var valDown=$("#downloadTaskNum").val().trim();
        //保存下载分段大小参数
        configObj.multiDownloadNum = $("#multiDownloadNum").val();
        downloadConfig.multiDownloadNum = $("#multiDownloadNum").val();
        var multiUploadNum = parseInt($("#multiUploadNum").val().trim() || 0);
        if (multiUploadNum >= 5 && multiUploadNum <= 5120) {
            configObj.multiUploadNum = $("#multiUploadNum").val();
            uploadConfig.multiUploadNum = $("#multiUploadNum").val();
        }
        else {
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.notMoreThan5GB,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }

        var uploadTaskNumber = parseInt(valUpload || 0);
        var downloadTaskNumber = parseInt(valDown || 0);
        var min=parseInt($("#uploadTaskNum").attr('min'));
        var max=parseInt($("#uploadTaskNum").attr('max'));
        if(uploadTaskNumber<min || uploadTaskNumber>max){
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.maxUploadTaskNumWarn,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }else{
            uploadTaskNum = uploadTaskNumber;
            configObj.uploadTaskNum = uploadTaskNum;
            uploadConfig.maxUploadTasks = uploadTaskNum;
        }
        min=parseInt($("#downloadTaskNum").attr('min'));
        max=parseInt($("#downloadTaskNum").attr('max'));
        if(downloadTaskNumber < min || downloadTaskNumber > max){
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.maxDownloadTaskNumWarn,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }else{
            downloadTaskNum = downloadTaskNumber;
            configObj.downloadTaskNum = downloadTaskNum;
            downloadConfig.maxTaskNum = downloadTaskNum;
        }

        //添加网络代理配置
        var proxys = {};
        proxys.isProxy = $("#isProxy").is(":checked") ? true : false;
        if(proxys.isProxy){
            var proxyIP = $("#proxyAddress").val().trim();
            var proxyPort = $("#proxyPort").val();
            var regAdress = /^(?=^.{3,255}$)[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+$/;
            var regIP = /^(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)\.(25[0-5]|2[0-4]\d|[01]?\d\d?)$/i;
            if(!(proxyIP)){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.ProxyIPNotNull,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else if(proxyIP.length>255){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.obs_term_proxyAddressLength_valid,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                var regIsNum = /^[0-9]*$/;
                var isNum = regIsNum.test(proxyIP.split('.').join(''));
                if(isNum){
                    if (!regIP.test(proxyIP)) {
                        $(".config-left li[data-href=\"#networkSetting\"]").click();
                        $('.mui-model').showMessage({
                            type: "warning",
                            message:  languageJson.obs_term_proxyAddress_valid,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                }else{
                    if (!regAdress.test(proxyIP)) {
                        $(".config-left li[data-href=\"#networkSetting\"]").click();
                        $('.mui-model').showMessage({
                            type: "warning",
                            message:  languageJson.obs_term_proxyAddress_valid,
                            ok: function () {
                                return false;
                            },
                            title: languageJson.warning
                        });
                        return false;
                    }
                }
            }
            if (proxyPort>65535){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.ProxyPortErr,
                    ok: function () {
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                proxys.proxyIP = proxyIP;
                proxys.proxyPort = proxyPort;
            }
            proxys.isAuthentication = $("#isAuthentication").is(":checked") ? true : false;
            if(proxys.isAuthentication){
                var proxyUserName = $("#proxyusname").val().trim();
                var proxyPwd = $("#proxypswd").next().val();
                if(proxyPwd===pwdPlaceHolder){
                    //未修改，取原值
                    proxyPwd = $("#proxypswd").val();
                }
                var proxyDomain = $("#proxydomain").val();
                if(!proxyUserName){
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: languageJson.userOrPwdIsNull,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                    return false;
                }else if(proxyUserName.length>255){
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: languageJson.obs_term_proxyUserLength_valid,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                    return false;
                }else{
                    proxys.proxyUserName = proxyUserName;
                    proxys.proxyPwd = proxyPwd;
                    proxys.proxyDomain = proxyDomain;
                }
            }
        }
        var dbPath = $("#dbPath").val().trim();
        if(dbPath.length>0){//如果配置了db路径
            if((/[\u4e00-\u9fa5]/).test(dbPath)){//路径不能为中文
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.obs_browser_setDBPath_valid,
                    ok: function () {
                        $("#others").click();//在其他tab的时候切到当前tab
                        return false;
                    },
                    title: languageJson.warning
                });
                return false;
            }else{
                configObj.dbpath = dbPath;
                logger.info("setting dbpath ",dbPath);
            }
        }
        configObj.proxy = proxys;
        proxy = JSON.parse(JSON.stringify(proxys));
        if(taskManager){
            taskManager.setUploadConfig(uploadConfig);
            taskManager.setDownloadConfig(downloadConfig);
        }
        var https = $("#isHttps").is(":checked") ? "Y" : "N";

        if(!chekcObjPageSize(configObj)) {
            return false;
        }

        if (isHttps !== https) {
            if ("N" === https) {
                configObj.isHttps = https;
                isHttps = https;
                configObj.isSSL = "N";
                isSSL = configObj.isSSL;
                indexAction.writeSysConfig(configObj);
                $("#config").removeClass('shown');
                isLoaded = false;
                $('.btnUserInfo').addClass('userNoLogin');
                $("#lsBuckets").html('');//清空桶列表
                $("#objContainer").html('');//清空对象列表
                $("#objLists tbody").html('');
                if(taskControlAction){
                    taskControlAction.pauseAllTasks(function(){
                        if(taskManager){
                            taskControlAction.closeInterval();
                        }
                        changeUserUI(currentUserId);
                    });
                }else{
                    changeUserUI(currentUserId);
                }
                $("#multiDownloadNum").val(5);
                $("#multiUploadNum").val(5);
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            } else if ("Y" === https && userType === '2') {
                configObj.isHttps = https;
                isHttps = https;
                $("input[name='res']").click();
                configObj.isSSL = $("#isSSL").is(":checked") ? "Y" : "N";
                isSSL = configObj.isSSL;
                indexAction.writeSysConfig(configObj);
                $("#config").removeClass('shown');
                isLoaded = false;
                $('.btnUserInfo').addClass('userNoLogin');
                $("#lsBuckets").html('');//清空桶列表
                $("#objContainer").html('');//清空对象列表
                $("#objLists tbody").html('');
                if(taskControlAction){
                    taskControlAction.pauseAllTasks(function(){
                        if(taskManager){
                            taskControlAction.closeInterval();
                        }
                        changeUserUI(currentUserId);
                    });
                }else{
                    changeUserUI(currentUserId);
                }
                $("#multiDownloadNum").val(5);
                $("#multiUploadNum").val(5);
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            } else {
                configObj.isHttps = https;
                isHttps = https;
                $("input[name='res']").click();
                configObj.isSSL = $("#isSSL").is(":checked") ? "Y" : "N";
                isSSL = configObj.isSSL;
                indexAction.writeSysConfig(configObj);
                $("#config").removeClass('shown');
                isLoaded = false;
                $('.btnUserInfo').addClass('userNoLogin');
                $("#lsBuckets").html('');//清空桶列表
                $("#objContainer").html('');//清空对象列表
                $("#objLists tbody").html('');
                if(taskControlAction){
                    taskControlAction.pauseAllTasks(function(){
                        if(taskManager){
                            taskControlAction.closeInterval();
                        }
                        changeUserUI(currentUserId);
                    });
                }else{
                    changeUserUI(currentUserId);
                }
                $("#multiDownloadNum").val(5);
                $("#multiUploadNum").val(5);
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            }
        } else {
            configObj.isHttps = https;
            isHttps = https;
            if("Y" === https){
                configObj.isSSL = $("#isSSL").is(":checked") ? "Y" : "N";
            }else{
                configObj.isSSL = "N";
            }
            isSSL = configObj.isSSL;
            $("input[name='res']").click();
            indexAction.writeSysConfig(configObj);
            $("#config").removeClass('shown');
            $("#multiDownloadNum").val(5);
            $("#multiUploadNum").val(5);
            if ($("#mui-overlay").size() > 0) {
                mui.overlay('off');
            }
        }
        $("#systemConfig").addClass('mui-hide');
        s3 = indexAction.updateS3(s3,configObj);


    });

    //用户意见反馈
    $('#btnUserSurvey').on('click', function () {
        showUserCommentWind();
        divDragFunc('userCommentDivDrag','userCommentDiv');
    });

    $("#config input[type='checkbox']").change(function () {
        var self = this;
        var href = $(self).attr('data-href');
        if ($(self).is(':checked')) {
            $("#" + href).attr("disabled", false);
        } else {
            $("#" + href).attr("disabled", true);
        }
    });
    //桶列表按照名称排序
    $("#bucketNameTh").on('click',function(){
        if(UCDVersion != "HEC" && UCDVersion !== 'HK'){
            return false;
        }
        $('#bucketLists .mui-ellipsis-td .mui-icon-extBucket').parent().parent().addClass("ext_bucket");
        var $trs = $('#bucketLists tbody tr:not(.ext_bucket)');
        $trs.sort(function(a,b){
            var t1 = $(a).find('span[name="bucketBodyItem"]').text();
            var t2 = $(b).find('span[name="bucketBodyItem"]').text();
            if(t1 === t2) return 0;
            if(bucketNameSort){
                if(t1 > t2) return 1;
                else return -1;
            }else {
                if(t1 > t2) return -1;
                else return 1;
            }
        });
        if(bucketNameSort){
            bucketNameSort = false;
            $trs.detach().appendTo('#bucketLists tbody');
        }else {
            bucketNameSort = true;
            $trs.detach().prependTo('#bucketLists tbody');
        }
    });
    //桶列表按照区域排序
    $("#regionTh").on('click',function(){
        if(UCDVersion != "HEC" && UCDVersion !== 'HK'){
            return false;
        }
        $('#bucketLists .mui-ellipsis-td .mui-icon-extBucket').parent().parent().addClass("ext_bucket");
        var $trs = $('#bucketLists tbody tr:not(.ext_bucket)');
        $trs.sort(function(a,b){
            var t1 = $(a).find('span[name="region"]').text();
            var t2 = $(b).find('span[name="region"]').text();
            if(t1 === t2) return 0;
            if(bucketRegionSort){
                if(t1 > t2) return 1;
                else return -1;
            }else {
                if(t1 > t2) return -1;
                else return 1;
            }
        });
        if(bucketRegionSort){
            bucketRegionSort = false;
            $trs.detach().appendTo('#bucketLists tbody');
        }else {
            bucketRegionSort = true;
            $trs.detach().prependTo('#bucketLists tbody');
        }
    });
    //桶列表按照创建时间排序
    $("#createTimeTh").on('click',function(){
        $('#bucketLists .mui-ellipsis-td .mui-icon-extBucket').parent().parent().addClass("ext_bucket");
        var $trs = $('#bucketLists tbody tr:not(.ext_bucket)');
        $trs.sort(function(a,b){
            var t1 = $(a).find('span[name="localDate"]').text();
            var t2 = $(b).find('span[name="localDate"]').text();
            t1 = t1.replace(/-/g, "/");
            t2 = t2.replace(/-/g, "/");
            if(language == 'Portuguese' || language == 'Spanish' ){
                t1 = swapDayMonthStr(t1);
                t2 = swapDayMonthStr(t2);
            }
            var x = new Date(Date.parse(t1));
            var y = new Date(Date.parse(t2));
            if(bucketCreatedSort){
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return 1;
                else return -1;
            }else {
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return -1;
                else return 1;
            }

        });
        if(bucketCreatedSort){
            bucketCreatedSort = false;
            $trs.detach().appendTo('#bucketLists tbody');
        }else {
            bucketCreatedSort = true;
            $trs.detach().prependTo('#bucketLists tbody');
        }
    });
    //对象列表按照最后修改时间排序
    $("#lastUpdateTh").on('click',function(){
        var $trs = $('#objLists tbody tr[data-type="file"]');
        $trs.sort(function(a,b){
            var t1 = $(a).find('span[name="date"]').text();
            var t2 = $(b).find('span[name="date"]').text();
            var x = new Date(Date.parse(t1.replace(/-/g, "/")));
            var y = new Date(Date.parse(t2.replace(/-/g, "/")));
            if(objSort){
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return 1;
                else return -1;
            }else {
                if(parseInt(x.getTime()) < parseInt(y.getTime())) return -1;
                else return 1;
            }
        });
        if(objSort){
            objSort = false;
            $trs.detach().appendTo('#objLists tbody');
        }else {
            objSort = true;
            $trs.detach().prependTo('#objLists tbody');
        }
    });
    //前缀查询输入框获取焦点增加颜色
    $("#prefixSearch").on('focus',function () {
        $("#PrefixIput").addClass("dtColor")
    });
    //前缀查询输入框失去焦点取消颜色
    $("#prefixSearch").on('blur',function () {
        $("#PrefixIput").removeClass("dtColor")
    });
    //桶左侧输入框获取焦点增加颜色
    $("#bucketSearch").on('focus',function () {
        $("#BucketIput").addClass("dtColor")
    });
    //桶左侧输入框失去焦点取消颜色
    $("#bucketSearch").on('blur',function () {
        $("#BucketIput").removeClass("dtColor")
    });
    //前缀查询
    $(".btnSearch").on('click', function () {
        var prefix = $("#prefixSearch").val().trim();
        if(searchBucketTable(prefix)) {
            return;
        }
        var mui_hide = $("#bucketArea").attr("class");
        //有这个hide样式，则是object列表，否则是bucket列表
        if(!mui_hide && mui_hide != "mui_hide") {
            return
        }
        var bucketName = $('#curBucketName').html();
        if(prefix.length > 0){
            $("#isSearch").val("true");
        }else{
            $("#isSearch").val("");
        }
        var path = getCurrPath();
        prefix = path + prefix;
        if(bucketName)
        {
            var loading=loadingShow();
            pageContext = {};//重置分页对象
            pageContext.nowPage = 1;
            bucketAndObjectAction.listObject(bucketName,"true",prefix,function(err,data){
                if(err && err.message && err.message.indexOf("prefix") > -1 && err.message.indexOf("too") > -1) {
                    global.logger.error("searchPrefixTooLong!", err);
                    err.code = "searchPrefixTooLong";
                }
                if(data.Contents.length >0||data.CommonPrefixes.length>0){//能够搜索到文件或文件夹
                    var prefix = data.Prefix;
                    var arr = prefix.split("/");
                    var str = {
                        name: bucketName
                    };
                    var htmStr = renderSync("head-navi-item", {
                        currPath: JSON.stringify(str),
                        folderName: bucketName
                    });
                    $(".mui-body .mui-content .path").html(htmStr);
                    var length = 0;
                    for(var i=0;i<arr.length-1;i++){
                        length+=arr[i].length+1;
                        var str = {
                            name: prefix.slice(0,length)
                        }
                        var htmStr = renderSync("head-navi-item", {
                            currPath: JSON.stringify(str),
                            folderName: arr[i]
                        });
                        $(".mui-body .mui-content .path").append(htmStr);
                    }

                }
                listObjectUI(err,data,bucketName);
                loading.close();
            });
        }else{
            $('.mui-model').showMessage({
                type:"warning",
                message:languageJson.selectBucket,
                ok:function(){
                    return false;
                },
                title:languageJson.warning
            });
        }
    });

    //全选功能
    $('#listObjBodyDiv,#uploadTaskDiv,#downloadTaskDiv,#deleteTaskDiv,#recoverTaskDiv,#lifecycleTabDiv,#multipartDiv,#corsTabDiv').on('mouseover',function(){
        if(!$(this).hasClass('onMouseOver')){
            $('#listObjBodyDiv,#uploadTaskDiv,#downloadTaskDiv,#deleteTaskDiv,#recoverTaskDiv,#lifecycleTab,#multipartTab,#corsTab').removeClass('onMouseOver');
            $(this).addClass('onMouseOver');
        }
    });

    $('body').on('keypress', function (event) {
        if (event.keyCode === 13)
        {
            if($("textarea").is(':focus')){
                return true;
            }else{
                return false;
            }
        }
    });
    //禁用tab
    $('body').on('keydown', function (event) {
        if (event.keyCode === 9) {
            return false;
        }
    });

    //挂载外部桶
    $('.btnExBucket').on('click', function () {
        $(".mui-page-full.shown").removeClass('shown');
        showOverlay();
        $("#ExBucketPage").addClass('shown');
        divDragFunc('ExBucketPageDrag','ExBucketPage');
        tabFocus('ExBucketName');
        return false;
    });

    window.onresize = function(){
        $("#objLists").css("width",$("#objListsHead").css("width"));
        $("#" + selected + " table").css("width",$("#taskTabHead").css("width"));
        $("#corsTab").css("width",$("#corsTabDiv").css("width"));
        $("#multipartTab").css("width",$("#multipartPageTab").css("width"));
    };


    //挂载外部桶
    $('#btnCeacelExBucket').on('click', function () {
        $("#createBucketPage").removeClass('shown');
        $('#ExBucketName').val('');
        $('#regionStr').val('');
        $('#bucketName').val('');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });
    /**
     * 添加外部桶前检查是否coldline
     * @param err
     * @param data
     * @returns {boolean}
     */
    function checkColdlineBucket(err, data) {
        var currBucketStorage = (data && data.StorageType) || false;
        if(currBucketStorage === 'Coldline'){
            $('.mui-model').showErrorMessage({
                message: languageJson.obs_task_createAddColdlineExternalBucket_info,
                ok:function(){
                    $('#ExBucketName').focus();
                }
            });
            return false
        }
        return currBucketStorage;
    }
    //保存外部桶
    $('#btnExBucket').on('click',function(){
        var bName=$('#ExBucketName').val().trim();
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $('#btnExBucket').attr('disabled','disabled');
        var loading = loadingShow();
        $("#createBucketPage").css('z-index', '90');
        //桶名为空警告
        if(!bName){
            $('.mui-model').showMessage({
                type:"warning",
                message: languageJson.bucketNameNotNull,
                ok:function(){
                    $('#ExBucketName').focus();
                    showCreateBucket();
                    return false;
                },
                title:languageJson.warning
            });
            showOverlay();
            $("#createBucketPage").css('z-index', '90');
            return false;
        };
        bucketAttributeAction.headBucket(bName, function(err, results){
            var str = bucketAndObjectAction.bucketNameCheck(bName,languageJson);
            //桶名符合校验规范情况
            if(str.trim().length===0){
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                //外部桶名是否重复
                var isExtNameRepeat = false;
                $('#bucketLists .mui-icon-extBucket').each(function () {
                    //判断外部桶是否已经挂载
                    if($(this).text() === bName){
                        isExtNameRepeat = true;
                    }
                });
                $("#createBucketPage").css('z-index', '90');
                bucketAndObjectAction.extBucketNameCheck(bName,languageJson, function (err,data) {
                    if(err && err.code !== "AccessDenied"){
                        $('.mui-model').showErrorMessage({
                            message:languageJson.InternalError,
                            obsError: obsError("InternalError"),
                            ok:function(){
                                $('#ExBucketName').focus();
                                showCreateBucket();
                            }
                        });
                        if(loading){
                            loading.close();
                        }
                        showOverlay();
                        $("#createBucketPage").css('z-index', '90');
                    } else if((data||err.code === "AccessDenied" )&& !isExtNameRepeat){
                        bucketAndObjectAction.listObject(bName, 'true','', function (err,data) {
                            if(!err){
                                $("#createBucketPage").removeClass('shown');
                                $('#ExBucketName').val('');
                                $('#btnCeacelExBucket').click();
                                var temp = true;
                                if(ExtBucket&&ExtBucket.length!==0){//外部桶持久化文件存在
                                    for(var i in ExtBucket){
                                        if(ExtBucket[i].id===currentUserId){
                                            ExtBucket[i].bucketArr.push(bName);
                                            temp = false;
                                            break;
                                        }
                                    }
                                    if(temp){
                                        var obj = {};
                                        obj.id = currentUserId;
                                        obj.bucketArr = [bName];
                                        ExtBucket.push(obj);
                                    }
                                }else{
                                    ExtBucket = [];
                                    var obj = {};
                                    obj.id = currentUserId;
                                    obj.bucketArr = [bName];
                                    ExtBucket.push(obj);
                                }
                                indexAction.writeExBucket(ExtBucket);
                                $('.mui-model').showMessage({
                                    type:"info",
                                    message:CommonUtils.format(languageJson.exBucketSuccess, CommonUtils.encodeForHTML(bName)),
                                    ok:function(){
                                        $('#btnExBucket').removeAttr('disabled');

                                        $("#createBucketPage").css('z-index', '1000');
                                        if ($("#mui-overlay").size() > 0) {
                                            mui.overlay('off');
                                        }
                                        $('#all-refresh-div').click();
                                        return false;
                                    },
                                    title:languageJson.info
                                });
                                var lsHtml = '<li data-href="' + bName +'"';
                                lsHtml += 'class="bucket-item ext">';
                                lsHtml += '<span class="mui-icon-ext-bucket mui-ellipsis-tips tooltips">'+encoderForHtml(bName) + '</span></li>';
                                $("#lsBuckets").append(lsHtml);

                                var tbody = $("#bucketLists tbody");
                                var extBucketTableList = [];
                                var showKey=(encoderForHtml(bName).replace(new RegExp(' ','gm'),'&nbsp;'));
                                var SNCMap = {};
                                if(_.isEqual(UCDVersion,"HEC") || _.isEqual(UCDVersion,"HK")){
                                    SNCMap = {
                                        Nearline: languageJson.obs_term_nearline_lable_HEC,
                                        Coldline: languageJson.obs_term_coldline_lable_HEC,
                                        Standard: languageJson.obs_term_standard_lable
                                    }
                                }else{
                                    SNCMap = {
                                        Nearline: languageJson.obs_term_nearline_lable,
                                        Coldline: languageJson.obs_term_coldline_lable,
                                        Standard: languageJson.obs_term_standard_lable
                                    }
                                }
                                extBucketTableList.push({
                                    showKey: showKey,
                                    bucketName: bName,
                                    aclConfig: languageJson.aclPermissions,
                                    multipart: languageJson.multipart,
                                    delete: languageJson.delete,
                                    obs_term_unlinkBucket_button: languageJson.obs_term_unlinkBucket_button,
                                    storageType: SNCMap[results.StorageType],
                                    coldline: pkg.coldline,
                                    objectColdline: pkg.objectColdline,
                                })
                                tbody.append(renderSync("lsExtBucketsTableTemplate", extBucketTableList));
                                if(loading){
                                    loading.close();
                                }
                                showOverlay();
                            }else{
                                global.logger.error('exBucket error:',err);
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok: function () {
                                            $('#ExBucketName').focus();
                                            showCreateBucket();
                                        }
                                    });
                                    if(loading){
                                        loading.close();
                                    }
                                    showOverlay();
                                    $("#createBucketPage").css('z-index', '90');
                                }else{
                                    $('.mui-model').showErrorMessage({
                                        message:languageJson.InternalError,
                                        obsError: obsError("InternalError"),
                                        ok:function(){
                                            $('#ExBucketName').focus();
                                            showCreateBucket();
                                        }
                                    });
                                    if(loading){
                                        loading.close();
                                    }
                                    showOverlay();
                                    $("#createBucketPage").css('z-index', '90');
                                }
                            }
                        });
                    }else{
                        $('.mui-model').showErrorMessage({
                            message:languageJson.bucketNameRepeat,
                            obsError: obsError("bucketNameRepeat"),
                            ok:function(){
                                $('#ExBucketName').focus();
                                showCreateBucket();
                            }
                        });
                        if(loading){
                            loading.close();
                        }
                        showOverlay();
                        $("#createBucketPage").css('z-index', '90');
                    }
                });
                return false;
            }
            //桶名不符合校验报错
            else{
                var loading = loadingShow();
                $('.mui-model').showMessage({
                    type:"warning",
                    message:str,
                    ok:function(){
                        $('#bucketName').focus();
                        showCreateBucket();
                    },
                    title:languageJson.warning
                });
                if(loading){
                    loading.close();
                }
                showOverlay();
                $("#createBucketPage").css('z-index', '90');
                return false;
            }
            if(err) {
                global.logger.error("Add ExtBucket, Head Bucket failed", err)
                var errMsg = obsError(err.code,err.message) ? obsError(err.code).description : languageJson.ERR_CODE_InternalError;
                var loading = loadingShow();
                $('.mui-model').showErrorMessage({
                    message: errMsg,
                    ok:function(){
                        $('#ExBucketName').focus();
                        showCreateBucket();
                    }
                });
                if(loading){
                    loading.close();
                }
                showOverlay();
                $("#createBucketPage").css('z-index', '90');
                return false;
            }
            return false;
        })
    });
    //挂载外部桶报错提示框确定
    function showCreateBucket (){
        $('#btnExBucket').removeAttr('disabled');
        $("#createBucketPage").css('z-index', '1000');
    }

    //分享对象URL
    function showProperty(bName, href,region) {
        var parentPath = getCurrPath();
        var url = getObjectUrl(bName, href, region, parentPath);
        //开启对象温冷才显示取回状态
        if(pkg.objectColdline == true){
            $("#recoverTr").removeAttr('hidden');
            $("#recoverExpiresTr").show();
        }else{
            $("#recoverTr").attr('hidden',true);
            $("#recoverExpiresTr").hide();
        }
        if (isShowServerEncryption || pkg.objectColdline == true) {
            var loading = loadingShow();
            if(isShowServerEncryption){
                $("#encryptionTr").removeAttr('hidden');
            }
            bucketAndObjectAction.headObject(bName, parentPath + href, function (err, data) {
                loading.close();
                if(err && err.code === 'NotFound'){
                    global.logger.error('copyObject error:',err);
                    $('.mui-model').showErrorMessage({
                        message: languageJson.NoSuchKey
                    });
                    return false;
                }
                if (data && data.SSEKMSKeyId) {
                    $("#objectEncryption").text(languageJson.EncryptionYes);
                    $("#btnServerEncryption").attr('hidden', 'hidden');
                } else if(data) {
                    $("#objectEncryption").text(languageJson.EncryptionNo);
                    $("#btnServerEncryption").removeAttr('hidden');
                } else {
                    $("#objectEncryption").text("--");
                    $("#btnServerEncryption").removeAttr('hidden');
                }
                if (pkg.objectColdline == true || currBucketStorage == 'Coldline') {
                    $("#recoverTr").show();
                    $("#recoverExpiresTr").show();
                    var objId = AWS.util.crypto.sha256(parentPath + href, 'hex');
                    var dataKey = objId + Const("RESTORE_STATUS_SUFFIX");
                    var storageType = JSON.parse($("#objLists .selected-tr-active .hiddenObjData").text()).StorageClass;
                    global.restoreCache.putCache(data, dataKey);
                    //根据head结果判断对象取回状态
                    $("#objectRecover").text("--");
                    $("#objectRecoverExpires").text("--");
                    if (data && data.Restore && data.Restore.indexOf('ongoing-request="false"') > -1) {
                        $("#objectRecover").text(languageJson.obs_term_restored_lable);
                        $("#" + dataKey).html(languageJson.obs_term_restored_lable);
                        var result = data.Restore.split('=');
                        if (result[2]) {
                            $("#recoverExpiresTr").removeAttr('hidden');
                            $("#objectRecoverExpires").text(indexAction.gmtDate2LocaleDate(result[2], language));
                        }
                    } else if (data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1) {
                        $("#objectRecover").text(languageJson.obs_term_restoring_lable);
                        $("#" + dataKey).html(languageJson.obs_term_restoring_lable);
                    } else if (data && storageType == "GLACIER") {
                        $("#objectRecover").text(languageJson.obs_term_notRestored_lable);
                        $("#" + dataKey).html(languageJson.obs_term_notRestored_lable);
                    } else if (data && storageType == "STANDARD"){
                        $("#recoverTr").attr('hidden',true);
                        $("#recoverExpiresTr").hide();
                    } else if (data && storageType == "STANDARD_IA"){
                        $("#recoverTr").attr('hidden',true);
                        $("#recoverExpiresTr").hide();
                    } else {
                        $("#objectRecover").text("--");
                        $("#" + dataKey).html("--");
                    }
                } else {
                    $("#recoverTr").hide();
                    $("#recoverExpiresTr").hide();
                }
                if(err && err.code === 'Forbidden'){
                    $("#objectEncryption").text('--');
                    $("#objectEncryption").attr('title',languageJson.obs_task_viewEncryptionDeny_tip);
                }else{
                    $("#objectEncryption").removeAttr('title');
                }
                $(".mui-page-full.shown").removeClass('shown');
                $("#objectURLPage").addClass('shown');
                setTimeout(function () {
                    mui.overlay('on', {"static": true, keyboard: false});
                }, 50);
                $("#objectUrlName").val(href);
                $("#UrlAdress").val(url);
                divDragFunc('objectURLPageDrag','objectURLPage');
            });
        } else {
            $(".mui-page-full.shown").removeClass('shown');
            $("#objectURLPage").addClass('shown');
            mui.overlay('on', {"static": true, keyboard: false});
            $("#objectUrlName").val(href);
            $("#UrlAdress").val(url);
            divDragFunc('objectURLPageDrag','objectURLPage');
        }
    }

    /**
     * 显示properties对话框
     * @param href
     */
    function checkAndShowProp(href) {
        var bName = $("#curBucketName").html();
        bucketAndObjectAction.headObject(bName, getCurrPath() + href, function (err, data) {
            if (err && err.hasOwnProperty("code") && errorConfig[err.code]) {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok:function () {
                        bucketAndObjectAction.listObject(bName, 'true', '', function (err, data) {
                            listObjectUI(err, data, bName, true);
                        });
                    }
                });
            } else {
                bucketAttributeAction.headBucket(bName, function (err, data) {
                    if(err){
                        showProperty(bName, href);
                    }else{
                        var region = data.LocationConstraint;
                        showProperty(bName, href,region);
                    }
                })
            }
            ;
        });
    }
    /**
     * 显示share对话框
     * @param href
     */
    function checkAndShowShare(href) {
        var bName = $("#curBucketName").html();
        bucketAndObjectAction.headObject(bName, getCurrPath() + href, function (err, data) {
            if (err && err.hasOwnProperty("code") && errorConfig[err.code]) {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok:function () {
                        bucketAndObjectAction.listObject(bName, 'true', '', function (err, data) {
                            listObjectUI(err, data, bName, true);
                        });
                    }
                });
            } else {
                // 加密对象不支持分享
                if(data && data.SSEKMSKeyId){
                    $('.mui-model').showMessage({
                        type:'warning',
                        message: languageJson.obs_term_shareObject_encrypted_tip,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                    return false;
                }
                bucketAttributeAction.headBucket(bName, function (err, data) {
                    $("#shareObjectName").html(href);
                    // 名称过长，显示title
                    checkAddTitle($("#shareObjectName"),href);
                    if(err){
                        $(".mui-page-full.shown").removeClass('shown');
                        $("#shareObjectPage").addClass('shown');
                        mui.overlay('on', {"static": true, keyboard: false});
                        divDragFunc('shareObjectPageDrag','shareObjectPage');
                    }else{
                        var region = data.LocationConstraint;
                        $(".mui-page-full.shown").removeClass('shown');
                        $("#shareObjectPage").addClass('shown');
                        mui.overlay('on', {"static": true, keyboard: false});
                        var expireTime = $("#expireTime").val();
                        var realExpireTime = 0;
                        if(expireTime){
                            realExpireTime = parseInt(new Date().getTime()/1000 + parseInt(expireTime)*60);
                        }else{
                            realExpireTime = parseInt(new Date().getTime()/1000 + 300);
                        }
                        var url = generateDownloadUrl(bName, href, region, realExpireTime);
                        $("#shareUrl").val(url);
                        divDragFunc('shareObjectPageDrag','shareObjectPage');
                        var appElement = document.getElementById("shareObjectPage");
                        var $scope = angular.element(appElement).scope();
                        $scope.numberOptions.value = 5 ;
                        $scope.downloadUrl = url;
                        $scope.$apply();
                        $("#expireTime").focus();
                    }
                })
            }
        });
    }

    // 关闭分享弹框
    $('#shareObjectSure').on('click',function(){
        $(".mui-page-full.shown").removeClass('shown');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });


    //目前主要是提供邮件菜单的properties功能
    $("#propBtn").on("click", function(){
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var href = JSON.parse($("#objLists .selected-tr-active .hiddenObjData").text()).name;
        checkAndShowProp(href);
    })
    //点击操作列取消checkbox选中
    function cancleCheckbox() {
        $("#allObject").get(0).checked = false;
        $("#objLists tbody").find(".objectCheckbox").each(function () {
            $(this).get(0).checked = false;
            $(this).removeClass('ObjectChecked');
        })
    }
    //取消选中一行
    function cancleChoosedRow() {
        $("#objLists tbody").find(".mui-icon-handel-more").each(function () {
            $(this).parent().parent().removeClass('selected-tr-active');
        })
    }
    //点击操作列中的share图标
    $("#objLists tbody").delegate('.mui-icon-handel-share2','click',function(){
        $(this).parent().parent().click();
        cancleCheckbox();
        var href = JSON.parse($(this).parent().next().text()).name;
        checkAndShowShare(href);

    });
    //点击更多里的share
    $("#shareInMore").on("click",function(){
        var objName = getChoseObjName();
        checkAndShowShare(objName);
    });
    //点击操作列中的properties图标
    $("#objLists tbody").delegate('.mui-icon-handel-share','click',function(){
        $(this).parent().parent().click();
        cancleCheckbox();
        var href = JSON.parse($(this).parent().next().text()).name;
        checkAndShowProp(href);
    });
    //点击更多里的properties
    $("#PropertyInMore").on("click",function(){
        var objName = getChoseObjName();
        checkAndShowProp(objName);
    });
    //点击更多里的copy link
    $("#copyUrlInMore").on("click",function(){
        $(".copyObjectUrlCtx").click();
    });

    $("#copyUrl").on('click', function () {
        var Url2=document.getElementById("UrlAdress");
        Url2.select(); // 选择象
        document.execCommand("Copy");
        $('.mui-model').showMessage({//增加复制成功提示信息
            type:"info",
            message:languageJson.copySuccess,
            ok:function(){
                return false;
            },
            title:languageJson.info
        });
    });
    $("#copyAccessDomain").on('click', function () {
        var accessDomain = $("#accessDomain").val();
        copyToClipboard(accessDomain, languageJson.obs_term_copyDomain_copySeccess_msg);
    });
    $("#copyBucketEndpoint").on('click', function () {
        var bucketEndpoint = $("#bucketEndpoint").val();
        copyToClipboard(bucketEndpoint, languageJson.obs_term_copyEndpoint_copySeccess_msg);
    });
    $("#copyOwnerUserIDVal").on('click', function () {
        var ownerUserIDVal = $("#ownerUserIDVal").val();
        copyToClipboard(ownerUserIDVal, languageJson.obs_term_copyAccountID_copySeccess_msg);
    });

    $('#closeUrlPage').on('click', function () {
        $("#objectURLPage").removeClass('shown');
        $('#objectUrlName').val('');
        $('#UrlAdress').val('');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });

    $("#language").on('change', function () {
        var lang = $("#language").val();
        if(lang!==language){
            $('.mui-model').showMessage({
                type:"info",
                message:languageJson.restartToLanguageEffect,
                ok:function(){
                    return false;
                },
                title:languageJson.info
            });
        }
        return false;
    });

    $("#UrlAdress, #objectUrlName, #accessDomain, #bucketEndpoint, #ownerUserIDVal").on('mouseover', function (e) {
        if(this.offsetWidth<this.scrollWidth){
            $(this).attr('title',$(this).val());
        } else {
            $(this).attr('title','');
        }
    });
    //=============================================弹出框可拖拽功能============================================================

    //界面尺寸变更，重新加载弹出框拖拽方法
    $(window).resize(function() {
        $(".mui-page").each(function () {
            $(this).css({left:($('body').width()-$(this).width())/2,top:'20%'});
        });
        $("#lifecycleChild").css({left:($('body').width()-$("#lifecycleChild").width())/2,top:'6%'});
        $("#model").css({left:($('body').width()-$("#model").width())/2,top:'20%'});//系统对话框位置重置
        divDragFunc('createBucketPageDrag','createBucketPage');
        divDragFunc('createFolderPageDrag','createFolderPage');
        divDragFunc('createPathPageDrag','createPathPage');
        divDragFunc('helpDrag','help');
        divDragFunc('multipartPageDrag','multipartPage');
        divDragFunc('accountListDrag','accountList');
        divDragFunc('createAccountDrag','createAccount');
        divDragFunc('configDrag','config');
        divDragFunc('exportDataDrag','exportData');
        divDragFunc('userCommentDivDrag','userCommentDiv');
        divDragFunc('bucketProDrag','bucketPro');
        divDragFunc('helpDtDrag','helpDt');
        divDragFunc('ACLConfigDrag','ACLConfig');
        divDragFunc('ObjACLConfigDrag','ObjACLConfig');
        divDragFunc('changeStorageTypeDrag','changeStorageType');
        divDragFunc('renameNoticeDrag','renameNotice');
        divDragFunc('authDrag','auth');
        divDragFunc('mongodbPathDrag','mongodbPath');
        divDragFunc('changeStorageClassDrag','changeStorageClass');
        divDragFunc('uploadFileDrag','uploadFileDialog');
        divDragFunc('lifecycleConfigDrag','lifecycleConfig');
        divDragFunc('lifecycleChildDrag','lifecycleChild');
        divDragFunc('policyConfigDrag','policyConfig');
        divDragFunc('corsConfigDrag','corsConfig');
        divDragFunc('CDNConfigDrag','CDNConfig');
        divDragFunc('CDNChildDrag','CDNChild');
        divDragFunc('corsConfigChildDrag','corsConfigChild');
        divDragFunc('PolicyDrag','Policy');
        divDragFunc('DomainIDDrag','DomainID');
        divDragFunc('CreatePolicyDrag','CreatePolicy');
        divDragFunc('ObjectRenameDrag','ObjectRename');
        divDragFunc('bucketLoggingDrag','bucketLogging');
        divDragFunc('objectURLPageDrag','objectURLPage');
        divDragFunc('modelDrag','model');

        var location = getNodeLocation("btnTaskManage");
        $("#taskDivHead").css({left:location.popX - 7,top:location.popY + 23});
    });

    $(".config-left li").on('click', function () {
        $(this).parent().find('li').each(function () {
            $(this).removeClass('curr');
        });
        $(this).addClass('curr');
        var href = $(this).attr('data-href');
        $("#GeneralSetting,#networkSetting,#otherSetting").addClass('mui-hide');
        $(href).removeClass('mui-hide');
    });

    $("#isProxy").on('change',function(){
        if($("#isProxy").is(':checked')){
            $("#proxyAddress,#proxyPort,#isAuthentication").removeAttr('disabled');
            $("#proxyAuth,#proxyInfo").removeClass('mui-hide');
        }else{
            $("#proxyAuth,#proxyInfo").addClass('mui-hide');
            if($("#isAuthentication").is(':checked')){
                $("#isAuthentication").click();
            }
            $("#proxyAddress,#proxyPort,#isAuthentication").attr('disabled',true);
        }
    });

    $("#isAuthentication").on('change',function(){
        if($("#isAuthentication").is(':checked')){
            $("#proxyusname,#proxydomain").removeAttr('disabled');
            $("#proxypswd").next().removeAttr("disabled");
        }else{
            $("#proxyusname,#proxydomain").attr('disabled', true);
            $("#proxypswd").next().attr("disabled", true);
        }
    });

    //选中对象服务端加密
    $('#btnServerEncryption').on('click', function () {
        var bucketName = $('#curBucketName').html();
        var parentPath = getCurrPath();
        var filename = $("#downloadFileName").val();

        if (!filename) {
            var htmlStr = languageJson.selectDeleteObject;
            $('.mui-model').showMessage({
                type: "warning",
                message: htmlStr,
                ok: function () {
                    return false;
                },
                title: languageJson.warning
            });
            return false;
        }
        mui.overlay('on', {"static": true});
        $('.mui-model').showMessage({
            type: "warning",
            message: languageJson.isSureEncryption,
            ok: function (model) {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                if (bucketName && filename) {
                    var loading = loadingShow();
                    $("#objectURLPage").css('z-index', '90');
                    bucketAndObjectAction.copyObject(bucketName, parentPath+$("#objectUrlName").val(), function (err,data) {
                        loading.close();
                        $("#objectURLPage").css('z-index', '1000');
                        if(err){
                            global.logger.error('copyObject error:',err);
                            if(errorConfig[err.code]){
                                $('.mui-model').showErrorMessage({
                                    message: errorConfig[err.code],
                                    obsError: obsError(err.code,err.message)
                                });
                            }
                        }else{
                            $('.mui-model').showMessage({
                                type:'info',
                                message: languageJson.EncryptionSuccess,
                                ok: function () {
                                    bucketAndObjectAction.headObject(bucketName,parentPath+$("#objectUrlName").val(),function(err,data) {
                                        if (data&&data.SSEKMSKeyId) {
                                            $("#objectEncryption").text(languageJson.EncryptionYes);
                                            $("#btnServerEncryption").attr('hidden', 'hidden');
                                        } else {
                                            $("#objectEncryption").text(languageJson.EncryptionNo);
                                            $("#btnServerEncryption").removeAttr('hidden');
                                        }
                                    });
                                    return false;
                                },
                                title: languageJson.info
                            });
                        }
                    });
                } else {
                    $('.mui-model').showMessage({
                        type: "info",
                        message: languageJson.oneOrMoreDeleteObjcet,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.hint
                    });
                }

            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: languageJson.warning
        });
    });

    //控制左边桶列表显示与隐藏
    $("#showOrHideBucket").on('click',function () {
        if(!$(".bucketPathLeftDiv").hasClass("mui-hide")){
            $("#showOrHidePathCollect").click();
        }
        if(!$("#showOrHidePathCollect").hasClass('showPathCollect')){
            $("#showOrHidePathCollect").addClass('showPathCollect');
            $("#showOrHidePathCollect").removeClass('hidePathCollect');
        }
        $(".bucketLeftDiv").toggleClass("mui-hide");
        $(".mui-body .mui-content .area").toggleClass("show");
        $("#showOrHideBucket").toggleClass('showBucket');
        $("#showOrHideBucket").toggleClass('hideBucket');
        $("#objLists").resize();
    });

    //控制左边路径收藏列表显示与隐藏
    $("#showOrHidePathCollect").on('click',function () {
        if(!$(".bucketLeftDiv").hasClass("mui-hide")){
            $("#showOrHideBucket").click();
        }
        if(!$("#showOrHideBucket").hasClass('showBucket')){
            $("#showOrHideBucket").addClass('showBucket');
            $("#showOrHideBucket").removeClass('hideBucket');
        }
        $(".bucketPathLeftDiv").toggleClass("mui-hide");
        $(".mui-body .mui-content .area").toggleClass("show");
        $("#showOrHidePathCollect").toggleClass('showPathCollect');
        $("#showOrHidePathCollect").toggleClass('hidePathCollect');
        $("#objLists").resize();
    });

    //返回到桶列表
    $("#bread-path-box-bucket").on('click',function () {
        global.inputPath = "obs://";
        $("#pathInput").val("obs://");
        $("#pathInputCollect").addClass("mui-hide");
        if($("#bucketArea").hasClass('mui-hide')){
            $("#bucketArea").removeClass('mui-hide');//桶列表和对象列表切换
            $("#objectArea").addClass('mui-hide');
            $("#objectBtnDiv").addClass('mui-hide');
            $("#bucketBtnDiv").removeClass('mui-hide');
            $("#all-back-div").addClass('all-back-btn-disabled');//后退按钮样式修改
            $("#all-back-div").removeClass('all-back-btn');
            $("#objectProDiv").addClass('mui-hide');//隐藏对象属性栏
            $("#bucketProDiv").removeClass('mui-hide');//显示桶属性栏
            $("#prefixSearch").attr('placeholder',languageJson.bucketSearchInfo);
        }
        $(".mui-icon-more").css('display','block');
        $(".mui-icon-fragment").css('display','none');
        $("#bucketSearch").val('');//清空查询条件
        $("#prefixSearch").val('');//清空查询条件
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#clearBucketSearchInput").addClass("mui-hide");
        $(".bucket-delete,.mui-icon-property,.mui-icon-aclConfig,.mui-icon-more").addClass('mui-disabled');
        var loading = loadingShow();
        lastBucket = '';
        $("#curBucketName").html('');
        $("#objectNum").html('');
        $("#storageSize").html('');
        bucketAndObjectAction.listBucket(function (err, data) {
            $("#path p").children().each(function () {
                $(this).remove();
            });
            listBucketUI(err,data,loading);
        });
    });

    //选择桶列表的行
    $("#bucketLists tbody").delegate('tr','click',function(event){
        $("#bucketLists tr.selected-tr-active>td:first-child").find('span').removeClass('show-span-active');
        $("#bucketLists tr.selected-tr-active td").find('.mui-ellipsis-prototype').removeClass('show-span-active');
        $("#bucketLists tr.selected-tr-active").removeClass('selected-tr-active');
        $(this).addClass('selected-tr-active');
        $(this).find('td').eq(0).find('span').addClass('show-span-active');
        disabledBtn($(".bucket-delete,.mui-icon-aclConfig,.mui-icon-more"));
        if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//如果是外部桶，则不显示基本信息按钮
            $(".mui-icon-property").addClass('mui-disabled');//置灰基本信息按钮
            $(".mui-icon-more").css('display','none');
            $(".mui-icon-fragment").css('display','block');
        }else{
            disabledBtn($(".mui-icon-property"));
            $(".mui-icon-more").css('display','block');
            $(".mui-icon-fragment").css('display','none');
        }
        $("#curBucketName").html($(this).find('td').eq(0).find('span').attr('data-href'));

        // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
        var region = $(event.target).parents('tr').find('span[name="region"]').text();
        window.isPartnerCloud = false;
        if (global.isPartnerCloudF(region)) {
            window.isPartnerCloud = true;
            window.partnerCloudName = region;
            $('.bucket-delete,.mui-icon-aclConfig,.mui-icon-more').addClass('mui-disabled').removeAttr('data-title').attr('disabled');
        } else {
            window.partnerCloudName = null;
            $('.bucket-delete,.mui-icon-aclConfig,.mui-icon-more').removeAttr('disabled').removeClass('mui-disabled');
        }
        return false;
    });

    //点击操作区删除桶按钮
    $("#bucketLists tbody").delegate('.mui-icon-handel-delBucket','click',function(){
        $(this).parent().parent().click();
        setTimeout(function () {
            $('.bucket-delete').click();
        },10);
    });

    //点击操作区more按钮
    $("#bucketLists tbody").delegate('.mui-icon-handel-more','mouseup',function(ev){
        var show = $('#bucketHandle2').hasClass('mui-active');
        if(show) {
            $('#bucketHandle2').removeClass('mui-active');
        } else {
            hideOtherPop();
            $(this).parent().parent().click();
            handleExtbucket();//外部桶桶属性按钮隐藏
            $('#bucketHandle2').addClass('mui-active');

            //计算弹出窗口位置
            //计算位置时偏移两个像素，避免弹出框的边界和Browser边框重合
            var border = 2;
            //header高度
            var headerHeight = 60;
            var dx = $(window).width() - ev.originalEvent.x;
            var dy = $(window).height() - ev.originalEvent.y;
            var menuWidth = $('#bucketHandle2 li').width()+border;
            var menuHeight = $('#bucketHandle2').height()+border;
            var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
            var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;

            $('#bucketHandle2').css({left: popX, top: popY - headerHeight});
        }
        // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
        var region = $(ev.target).parents('tr').find('span[name="region"]').text();
        var $ctxmenu = $('#bucketHandle2')
        if (global.isPartnerCloudF(region)) {
            $('.bucket-delete,.mui-icon-aclConfig,.mui-icon-more').addClass('mui-disabled').removeAttr('data-title').attr('disabled');
            $ctxmenu.find('li>.btnAclPermissions').addClass('mui-disabled-task');
            $ctxmenu.find('li>.btnConfigPolicy').addClass('mui-disabled-task');
            $ctxmenu.find('li>.btnCDN').addClass('mui-disabled-task');
        } else {
            $('.bucket-delete,.mui-icon-aclConfig,.mui-icon-more').removeAttr('disabled').removeClass('mui-disabled');
            $ctxmenu.find('li>.btnAclPermissions').removeClass('mui-disabled-task');
            $ctxmenu.find('li>.btnConfigPolicy').removeClass('mui-disabled-task');
            $ctxmenu.find('li>.btnCDN').removeClass('mui-disabled-task');
        }
        return false;
    });

    //点击对象列表操作区more按钮
    $("#objLists tbody").delegate('.mui-icon-handel-more','mouseup',function(ev){
        cancleChoosedRow();//取消选中行
        $(this).parent().parent().addClass("selected-tr-active");//选中该行
        cancleCheckbox();
        // CMCC 暂时屏蔽对象ACL操作
        if(_.isEqual(UCDVersion,"CMCC")){
            $("#ObjectAcl").addClass("mui-hide");
        }
        var show = $('#objectMoreOperate').hasClass('mui-active-object');
        var restoreState = $(this).parent().parent().find(".restore_stat").text();
        if(restoreState){
            if(restoreState == languageJson.obs_term_notRestored_lable || restoreState == languageJson.obs_term_restoring_lable){
                $('#changeStorageTypeInMore').addClass("mui-disabled-task");
                $('#changeStorageTypeInMore').parent().attr('title',languageJson.obs_task_changeStorageClassUnavailable_tip);
            }else{
                $('#changeStorageTypeInMore').removeClass("mui-disabled-task");
                $('#changeStorageTypeInMore').parent().attr('title','');
            }
        }
        var objectStorage = getChoseObjType();
        if (pkg.coldline && (objectStorage === 'Coldline' || objectStorage === "GLACIER")){
            if(restoreState && pkg.share){
                if(_.isEqual(restoreState, languageJson.obs_term_restored_lable)){ //已恢复
                    $("#shareInMore").removeClass("mui-hide");
                    $("#PropertyInMore").removeClass("mui-hide");
                    $('#shareInMore').removeClass("mui-disabled-task");
                    $('#shareInMore').parent().attr('title',"");
                }else{
                    $("#shareInMore").removeClass("mui-hide");
                    $('#shareInMore').addClass("mui-disabled-task");
                    $('#shareInMore').parent().attr('title', languageJson.obs_term_shareObject_restoring_tip);
                    $("#PropertyInMore").addClass("mui-hide");
                }
            }else{
                $("#shareInMore").addClass("mui-hide");
                $("#PropertyInMore").addClass("mui-hide");
                $('#shareInMore').removeClass("mui-disabled-task");
                $('#shareInMore').parent().attr('title',"");
            }
        }else{
            $("#shareInMore").addClass("mui-hide");
            $("#PropertyInMore").addClass("mui-hide");
        }
        var path = getCurrPath();
        checkObjectRestore(path + JSON.parse($(this).parent().parent().find('.hiddenObjData').text()).name);
        if(show) {
            $('#objectMoreOperate').removeClass('mui-active-object');
        } else {
            hideOtherPop();
            $(this).parent().parent().click();
            var StorageType = $(this).parent().parent().find('td').eq(2).find('span').text();
            if(pkg.objectColdline){
                if(StorageType == languageJson.obs_term_standard_lable){
                    StorageType = 'Standard';
                }else if(StorageType == languageJson.obs_term_nearline_lable || StorageType == languageJson.obs_term_nearline_lable_HEC){
                    StorageType = 'Nearline';
                }else{
                    StorageType = 'Coldline'
                };
                var a = "";
                var inputs = $("#StorageClassdsc").parent().find("input");
                for (var index in inputs){
                    if (inputs[index].value == StorageType){
                        a = index;
                    }
                };
                var appElements = document.getElementById("changeStorageClass");
                var $scope = angular.element(appElements).scope();
                $scope.object.selected.value = $scope.object.storageTypeList[a].key;
                $scope.object.description = $scope.object.storageTypeList[a].desc;
                $scope.$apply();
                var fileType = $(this).parent().parent().data('type');
                if(fileType == 'folder') {
                    $('#changeStorageTypeInMore').parent().hide();
                }else{
                    $('#changeStorageTypeInMore').parent().show();
                }
            }else{
                $('#changeStorageTypeInMore').parent().hide();
            }
            if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//判断被选择的桶是否为外部桶
                $("#ObjectPolicy").parent().addClass("mui-hide");
            }
            handleExtbucket();//外部桶桶属性按钮隐藏
            $('#objectMoreOperate').addClass('mui-active-object');
            if (_.isEqual($(this).parent().parent().find('.restore_stat').text(), languageJson.obs_term_restored_lable)) {
                $("#downloadInMore").removeClass('mui-disabled-task');
                $("#downloadInMore").parent().removeAttr('title');
            } else {
                $("#downloadInMore").addClass('mui-disabled-task');
                $("#downloadInMore").parent().attr('title',languageJson.ERR_CODE_InvalidObjectState);
            }
            //控制拷贝和移动的显示隐藏
            copyMoveOptionDisplay();
            //计算弹出窗口位置
            //计算位置时偏移两个像素，避免弹出框的边界和Browser边框重合
            var border = 2;
            //header高度
            var headerHeight = 60;
            var dx = $(window).width() - ev.originalEvent.x;
            var dy = $(window).height() - ev.originalEvent.y;
            var menuWidth = $('#objectMoreOperate li').width()+border;
            var menuHeight = $('#objectMoreOperate').height()+border;
            var popX = dx < menuWidth ? $(window).width() - menuWidth : ev.originalEvent.x;
            var popY = dy < menuHeight ? $(window).height() - menuHeight : ev.originalEvent.y;

            $('#objectMoreOperate').css({left: popX, top: popY - headerHeight});
        }
        // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
        var $ctxmenu = $('#objectMoreOperate')
        if (window.isPartnerCloud) {
            $('.bucket-delete,.mui-icon-aclConfig').addClass('mui-disabled').removeAttr('data-title').attr('disabled');
            $ctxmenu.find('li>#ObjectAcl').addClass('mui-disabled-task');
            $ctxmenu.find('li>#ObjectPolicy').addClass('mui-disabled-task');
        } else {
            $('.bucket-delete,.mui-icon-aclConfig').removeAttr('disabled').removeClass('mui-disabled');
            $ctxmenu.find('li>#ObjectAcl').removeClass('mui-disabled-task');
            $ctxmenu.find('li>#ObjectPolicy').removeClass('mui-disabled-task');
        }
        return false;
    });
    //导出报表确定按钮
    $('#SureExport').on('click',function () {
        $("#exportData").add('mui-hide');
        $("#exportData").removeClass('shown');
    });
    //取消导出
    $('#CancelExport').on('click',function () {
        $("#exportData").add('mui-hide');
        $("#exportData").removeClass('shown');
    });
    //选择日期
    $('#pickDateBtn').on('click', function() {
        var options ={
            'type':'date',
            'beginYear':'2017',
            'endYear':'2020'
        }
        var picker = new mui.Datepicker(options);
        picker.show(function(rs){
            picker.innerText = rs.text;
            picker.dispose()
        })
    });
    //对象修改存储类别
    $("#changeStorageTypeInMore").on('click',function(){
        var href = getChoseObjName();
        var bName = $("#curBucketName").html();
        //先判断对象存在与否，报错弹出提示，确定刷新列表
        bucketAndObjectAction.headObject(bName, getCurrPath() + href, function (err, data) {
            if (err && err.hasOwnProperty("code") && errorConfig[err.code]) {
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok:function () {
                        bucketAndObjectAction.listObject(bName, 'true', '', function (err, data) {
                            listObjectUI(err, data, bName);
                        });
                    }
                });
            }else{
                showOverlay();
                $(".mui-page-full.shown").removeClass('shown');
                $("#changeStorageClass").removeClass('mui-hide');
                $("#changeStorageClass").addClass('shown');
                divDragFunc('changeStorageClassDrag','changeStorageClass');
            }
        });
    });
    $("#deleteInMore").on('click',function(){//单行更多删除
        $('#btnDeleteObjects').click();
    });
    $("#deletedInMore").on('click',function(){//上方更多按钮删除
        $('#btnDeleteObjects').click();
    });
    $("#PolicyBtnInMore").on('click',function(){//上方更多按钮policy授权
        $('#PolicyBtn').click();
    });
    $("#restoredInMore").on('click',function(){//上方更多按钮恢复
        $('#recoverBtn').click();
    });
    //取消蒙层并刷新
    function refresh (){
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        $(".refreshCtx").click();
        return false;
    }
    //确定保存
    $('#saveChanges').on('click',function () {
        $(".mui-page-full.shown").removeClass('shown');
        $("#changeStorageClass").addClass('mui-hide');
        var bName = $("#curBucketName").html();
        var href = getChoseObjName();
        var Objkey = getChoseObjKey();
        var storagePolicy = $('#StorageClassdsc').html();
        storagePolicy = CommonUtils.translateStorageClass(storagePolicy);
        //关闭蒙层显示加载图标
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        var loading = loadingShow();
        async.parallel([
            function(callback) {
                bucketAndObjectAction.headObject(bName,Objkey,function (err,data) {
                    callback(err,data)
                });
            },
            function(callback) {
                var params = {
                    Bucket : bName,
                    Key : Objkey
                };
                s3.getObjectAcl(params,function (err,data) {
                    callback(err,data)
                })
            }
        ], function (err, results) {
            if(err){
                global.logger.info("head object or getobejctacl err",err)
                loading.close();
                if(errorConfig[err.code]){
                    $('.mui-model').showErrorMessage({
                        message: errorConfig[err.code],
                        obsError: obsError(err.code,err.message),
                        ok: function () {
                            refresh();
                        }
                    });
                }
            }else{
                var data = results[0];
                var isKMS;//对象是否为KMS加密
                var sseKMSKeyId; /// 加密keyid
                if(data && data.SSEKMSKeyId){
                    isKMS = true;
                    sseKMSKeyId = data.SSEKMSKeyId;
                }else{
                    isKMS = false;
                }
                var acl = results[1];
                var putAclParams = {
                    Bucket: bName,
                    Key: Objkey,
                    AccessControlPolicy: {
                        Grants: acl.Grants,
                        Owner: acl.Owner
                    }
                };
                bucketAndObjectAction.copyObject(bName,storagePolicy,Objkey,isKMS, sseKMSKeyId, function (err,data) {
                    //关闭加载图标，增加蒙层
                    loading.close();
                    showOverlay();
                    if(err){
                        global.logger.info("copyobject err",err)
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message),
                                ok: function () {
                                    refresh();
                                }
                            });
                        }
                    }else{
                        s3.putObjectAcl(putAclParams,function () {
                            if(err){
                                global.logger.info("putobejctacl err",err)
                                if(errorConfig[err.code]){
                                    $('.mui-model').showErrorMessage({
                                        message: errorConfig[err.code],
                                        obsError: obsError(err.code,err.message),
                                        ok: function () {
                                            refresh();
                                        }
                                    });
                                }
                            }else{
                                $('.mui-model').showMessage({
                                    type:"info",
                                    message:languageJson.obs_term_changeStorageClass_objectSuccess_msg.format(href),
                                    ok:function(){
                                        refresh();
                                    },
                                    title:languageJson.hintInfo
                                });
                            }
                        })
                    }
                });
            }
        });
    });
    //取消
    $('#cancelChanges').on('click',function () {
        $("#changeStorageClass").removeClass('shown');
        $("#changeStorageClass").addClass('mui-hide');
        if ($("#mui-overlay").size() > 0) {
            mui.overlay('off');
        }
        return false;
    });
    //打开任务管理
    $(".btnTaskManage").on('click',function () {
        showTips();
        if(!$("#overlay").hasClass('mui-hide')){
            return false;
        }
        $("#taskOverlay").toggleClass('mui-hide');
        $("#taskPanel").toggleClass('mui-active');
        $("#taskDivHead").toggleClass('triangle-up');
        var location = getNodeLocation("btnTaskManage");
        $("#taskDivHead").css({left:location.popX - 7,top:location.popY + 23});
        $("[tab-for='processingTaskPanel']").click();
        reloadTasks(true);
    });
    //点击运行列表重新注册tips
    $("[tab-for='processingTaskPanel']").on("click",function () {
        setTimeout(function () {
            showTips();
        },0)
    });
    //图标hover显示tips
    function showTips() {
        $('.mui-icon-note').on('mouseover',function(e){
            var hf = $(this).attr('data-href');
            if(hf && $(hf).size() === 1){
                $('.help-tips').html($(hf).html());
            }
            $('.help-tips').addClass('active');
            var bodyW = $('body').width();
            var bodyH = $('body').height();
            var tipsW = $('.help-tips').width();
            var tipsH = $('.help-tips').height();
            var pageX = e.pageX;
            var pageY = e.pageY;
            if(bodyW-pageX<tipsW&&bodyH-pageY<tipsH+20){
                $('.help-tips').css({left:bodyW-tipsW-10,top:bodyH-tipsH-20});
            }else if(bodyW-pageX<tipsW&&bodyH-pageY>tipsH+20){
                $('.help-tips').css({left:bodyW-tipsW-10,top:(pageY+15)});
            }else if(bodyW-pageX>tipsW&&bodyH-pageY<tipsH+20){
                $('.help-tips').css({left:pageX,top:bodyH-tipsH-20});
            }else{
                $('.help-tips').css({left:pageX,top:(pageY+15)});
            }
            $('.more-user-btns').removeClass('mui-active');
            $('.task-status-check').removeClass('mui-active').css('top','-1440px');
            return false;
        });
        $('.mui-icon-note').on('mouseout',function(e){
            $('.help-tips').removeClass('active');
        });
    }
    //关闭任务管理
    $(".mui-task-close").on('click',function () {
        $("#taskPanel").toggleClass('mui-active');
        $("#taskDivHead").toggleClass('triangle-up');
        $("#taskOverlay").addClass('mui-hide');
    });

    //打开冷对象恢复界面
    $("#recoverBtn").on('click',function () {
        if($(this).hasClass('mui-disabled')){
            return false;
        }
        var bName = $("#curBucketName").html();
        var path = getCurrPath();
        var lis = $("#objLists tr.selected-tr-active");
        if(lis.length === 1 && $("#objLists tr.selected-tr-active").attr("data-type") === "file"){
            var currObj = $('#objLists .selected-tr-active').find('.hiddenObjData').text();
            var objName = JSON.parse(currObj).name;
            var loading = loadingShow();
            bucketAndObjectAction.headObject(bName,path+objName,function (err,data) {
                //如果对象正在恢复，则不能继续做恢复操作
                loading.close();
                if(data && data.Restore && data.Restore.indexOf('ongoing-request="true"') > -1){
                    $('.mui-model').showMessage({
                        type: "warning",
                        message: obsError('RestoreAlreadyInProgress').description,
                        ok: function () {
                            return false;
                        },
                        title: languageJson.warning
                    });
                }else{
                    $(".mui-page-full.shown").removeClass('shown');
                    $("#recoverObjectPage").addClass('shown');
                    mui.overlay('on', {"static": true, keyboard: false});
                    $("#recoverBucketNmae").html(bName);
                    $("#recoverObjectTr").removeClass('mui-hide');
                    $("#recoverObjectName").html(objName);
                    checkAddTitle($("#recoverObjectName"),objName);
                    checkAddTitle($("#recoverBucketNmae"),bName);
                    if(data && data.Restore){
                        var result = data.Restore.split('=');
                        if(result[2]){
                            $("#recoverObjectExpires").html(result[2]);
                        }
                    }
                    $("#recoverObjectSize").html((data && data.ContentLength) || 0);
                    divDragFunc('recoverObjectPageDrag','recoverObjectPage');
                }
            });
        }else{
            //批量恢复对象
            $(".mui-page-full.shown").removeClass('shown');
            $("#recoverObjectPage").addClass('shown');
            mui.overlay('on', {"static": true, keyboard: false});
            $("#recoverObjectTr").addClass('mui-hide');
            $("#recoverBucketNmae").html(bName);
            checkAddTitle($("#recoverBucketNmae"),bName);
            divDragFunc('recoverObjectPageDrag','recoverObjectPage');
        }
    });

    $("#objLists tbody").delegate('.mui-icon-handel-recover','click',function(){
        $(this).parent().parent().click();
        cancleCheckbox();
        disabledBtn($("#recoverBtn"));
        $("#recoverBtn").click();
    });
});

(function ($, w) {

    w.loadingShow = function (option) {
        //判断是否显示loading框
        if ($("#mui-overlay").size() > 0) {
            return false;
        }
        var startTime = $("#mui-overlay").attr('startTime');
        var nowTime = new Date();
        //如果请求时间超过400ms就显示loading
        if (startTime && (nowTime.getTime() - startTime) < 400) {
            return false;
        }
        var loading = mui.overlay('on', {"static": true,keyboard:false});
        $(loading).attr('startTime', nowTime.getTime());
        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&&  UCDVersion !== 'CMCC'&&  UCDVersion !== 'HCS'&&UCDVersion !== 'YLM'&&UCDVersion !== 'HK'){
            loading.innerHTML = '<div class="loading-dt"></div>';
        }else{
            loading.innerHTML = '<div class="loading"></div>';
        }

        if (!option) {
            option = {};
        }
        if (!option.timeout) {
            option.timeout = 100000;
        }

        setTimeout(function () {
            if (loading) {
                loading.innerHTML = '';
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            }
        }, option.timeout);

        this.close = function () {

            if (loading) {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            }
            loading = false;
        };

        return this;
    };

    /**
     * 弹出错误提示框，如果obsError存在，则使用obsError.description作为message
     * 默认选项：
     * title:Error
     * type:error
     * ok:function () {
                return false;
            }
     * @param option
     */
    $.fn.showErrorMessage = function (option) {
        if(option.obsError) {
            option.message = option.obsError.description;
            if(option.showDetail == true) {
                option.obsError.detailTitle = "Detail"
                option.obsError.codeTitle = "Code"
                option.obsError.nameTitle = "Name"
                option.obsError.suggestionTitle = "Suggestion"
                //错误详情渲染
                $("#err_detail_pad").html(renderSync("errDetailPadTemplate", option.obsError));
                $("#err_detail_content").hide();
                $("#err_detail_title").click(function () {
                    if ($("#err_detail_content").is(":hidden")) {
                        $("#err_detail_content").show();
                    } else {
                        $("#err_detail_content").hide();
                    }
                })
            }
        }
        option.type = "error";
        option.ok = option.ok ? option.ok : function () {
            return false;
        }
        option.title = option.title ? option.title : global.langData.error;
        $(this).showMessage(option);
    }
    //加载消息提示框
    $.fn.showMessage = function (option) {
        if ($(".mui-model.mui-model-mini").hasClass('shown')) {
            return false;
        }
        $(".mui-page.shown").each(function () {
            var self = this;
            var zIndex = $(self).css('z-index');
            if(zIndex>100){
                $(self).css('z-index','99');
            }
        });
        return this.each(function () {
            var $model = $(this);
            $model.find('.mui-model-content').find('p').html(option.message);
            $model.find('.mui-model-content').find('p').addClass("mui-text-info");
            if ('error' === option.type) {
                $model.find('.mui-model-content').find('img').attr("src", "images/dialog_error2.png");
            }
            else if ('warning' === option.type) {
                $model.find('.mui-model-content').find('img').attr("src", "images/alarm-big.svg");
                $model.find('.mui-model-content').find('img').addClass("war-size");
            }else if('tips' === option.type){
                $model.find('.mui-model-content').find('img').attr("src", "images/prompt-big.png");
            }else if ('choose_warning' === option.type) {
                $model.find('.mui-model-content').find('img').attr("src", "images/alarm-big.svg");
                $model.find('.mui-model-content').find('img').addClass("war-size");
                $model.find('.mui-model-content>button.ok').html(languageJson.obs_term_createBucket_private_button);
                $model.find('.mui-model-content>button.cancel').html(languageJson.obs_term_createBucket_confirmChangePolicy_button);
                $model.find('.mui-model-content>button.ok').addClass("choose_private");
                // 英文的按钮长度要长些
                if(language === "en"){
                    $model.find('.mui-model-content>button.ok').css("max-width", "136px");
                    $model.find('.mui-model-content>button.cancel').css("max-width", "136px");
                }
            }
            else {
                $model.find('.mui-model-content').find('img').attr("src", "images/dialog_sucess.png");
            }

            if (option.title) {
                $model.find('.mui-model-title').html(option.title);
            }
            if (option.ok) {
                $model.find('.mui-model-content>button.ok').removeClass('mui-hide');
                $model.find('.mui-model-content>button.ok').one('click', function () {
                    $model.find('.mui-model-content>button.ok').html(languageJson.ok);
                    $model.find('.mui-model-content>button.cancel').html(languageJson.cancel);
                    $model.find('.mui-model-content>button.ok').removeClass("choose_private");
                    option.ok($model);
                    $model.removeClass('mui-model-mini');
                    $model.find('.mui-model-content>button.cancel').unbind();
                    $(".mui-page.shown").each(function () {
                        var zIndex = $(this).css('z-index');
                        if(zIndex==99){
                            $(this).css('z-index','1000');
                        }
                    });
                });
                if(option.isFocus){
                    $model.find('.mui-model-content').find('.cancel').addClass('mui-btn-default');
                    $model.find('.mui-model-content').find('.ok').removeClass('mui-btn-default');
                }else{
                    $model.find('.mui-model-content').find('.cancel').removeClass('mui-btn-default');
                    $model.find('.mui-model-content').find('.ok').addClass('mui-btn-default');
                }
            }
            else {
                $model.find('.mui-model-content>button.ok').addClass('mui-hide');
            }

            if (option.okHide) {
                $model.find('.mui-model-content>button.ok').addClass('mui-hide');
            }

            if (option.noClose) {
                $model.find('.mui-model-close').addClass('mui-hide');
            }

            if (option.cancel) {
                $model.find('.mui-model-content>button.cancel').removeClass('mui-hide');
                $model.find('.mui-model-content>button.cancel').one('click', function () {
                    $model.find('.mui-model-content>button.ok').html(languageJson.ok);
                    $model.find('.mui-model-content>button.cancel').html(languageJson.cancel);
                    $model.find('.mui-model-content>button.ok').removeClass("choose_private");
                    option.cancel();
                    $model.removeClass('mui-model-mini');
                    $model.find('.mui-model-content>button.ok').unbind();
                    $(".mui-page.shown").each(function () {
                        var zIndex = $(this).css('z-index');
                        if(zIndex==99){
                            $(this).css('z-index','1000');
                        }
                    });
                });
            }
            else {
                $model.find('.mui-model-content>button.cancel').addClass('mui-hide');
            }
            if (option.cancelHide) {
                $model.find('.mui-model-content>button.cancel').addClass('mui-hide');
            }
            $model.addClass('mui-model-mini');
            divDragFunc('modelDrag','model');
        });
    };

})(jQuery, window);

function copyUninsFiles(upd) {
    var copyFiles = ['/unins000.exe', '/unins000.dat'];
    for (var n = 0; n < copyFiles.length; n++) {
        var fileName = copyFiles[n];
        var exists = fs.existsSync(upd.getAppPath().replace(/\\/g, "/") + fileName);
        upd['newAppPath'] = upd['newAppPath'].replace(/\\/g, "/");
        if (exists) {
            var tempPath = upd['newAppPath'].substring(0, upd['newAppPath'].lastIndexOf("/"));
            var readable = fs.createReadStream(upd.getAppPath().replace(/\\/g, "/") + fileName);
            var writable = fs.createWriteStream(tempPath + fileName);
            readable.pipe(writable);
        }

    }
}

function saveAccountAndKillDB(upd, currentBucket) {

    accountService.saveCurrentAccount(currentUserId, currentBucket, function () {
        if (!taskControlAction) {
            taskControlAction = new TaskControlAction();
        }
        taskControlAction.pauseAllTasks(function () {//暂停正在运行的任务
            if (window.mongod) {
                window.mongod.kill(0);
            }
            exec(commonUtils.getStopDBCommand(), {}, function (err) {
                if (err) {
                    logger.error(err);
                }
            });
            setTimeout(function () {
                upd.runInstaller(upd['newAppPath'], [upd.getAppPath(), upd.getAppExec()], {});
                logger.info("runInstaller......" +upd["newAppPath"]+"========"+upd.getAppPath() + "======" + upd.getAppExec());
                gui.Window.get().close(true);
            }, 2000);
        });
    });
}
function closeAlert(currentBucket) {
    var msg = languageJson.sureQuitClint;

    if (hasRunning()) {
        msg = languageJson.quitWithTask;
    }
    hasMovingTask(function(err, data) {
        if(data > 0){
            msg = languageJson.obs_quit_check_move_task_confirm;
        }
        $('.mui-model').showMessage({
            type: "warning",
            message: msg,
            isFocus: true,
            ok: function () {
                userCommentLogout(function () {
                    accountService.saveCurrentAccount(currentUserId, currentBucket, function () {
                        if (!taskControlAction) {
                            taskControlAction = new TaskControlAction();
                        }
                        taskControlAction.pauseAllTasks(function () {
                            exec(commonUtils.getStopDBCommand(), {}, function (err) {
                                if (err) {
                                    global.logger.error("kill obsdb error", err);
                                }
                            });

                            //判断是否需要更新密钥
                            if (global.Tools.checkPwd()) {
                                gui.Window.get().close(true);
                            } else {
                                updatePwd(function () {
                                    gui.Window.get().close(true);
                                })
                            }
                        });
                    });
                });
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: languageJson.warning
        });
        showOverlay();
    });
}
$(document).ready(function(){
    $(document).tooltip();
    $('#delDataTime').datepicker({
        minDate: 1,
        dateFormat:'yy-mm-dd'
    });
    $('#selType').selectmenu({
        change: function( event, ui ) {
            if ('1' === $(this).val()) {
                $("#endpointDiv").addClass('mui-hide');
            } else {
                $("#endpointDiv").removeClass('mui-hide');
            }
        }
    }).selectmenu( "menuWidget" ).addClass("obs-connect-type");
    $('#language').selectmenu({
        change: function(event, ui){
            var lang = $("#language").val();
            if(lang!==language){
                $('.mui-model').showMessage({
                    type:"info",
                    message:languageJson.restartToLanguageEffect,
                    ok:function(){
                        return false;
                    },
                    title:languageJson.info
                });
            }
            return false;
        }
    }).selectmenu( "menuWidget" ).addClass("obs-connect-type");

    $("#loggingSelector").selectmenu();

    i18n_learnMore.initLearnMoreDomainName();


});
window.addEventListener('load', function () {

    if (window.require) {
        window.path = gui.App.dataPath.replace("\\User Data\\Default","") + "/";
        var curWin = gui.Window.get();
        document.getElementById('btnClose').addEventListener('click', function () {
            gui.Window.get().close();
        });
        document.getElementById('btnMinisize').addEventListener('click', function () {
            gui.Window.get().minimize();
        });
        document.getElementById('btnMaxsize').addEventListener('click', function () {
            if($("#btnMaxsize").hasClass('btnMax')){//切换全屏模式
                gui.Window.get().maximize();
            }else{
                gui.Window.get().unmaximize();
                $("#btnMaxsize").removeClass('btnMaxReturn');
                $("#btnMaxsize").addClass('btnMax');
            }
        });
        gui.Window.get().on('maximize', function () {
            $("#btnMaxsize").removeClass('btnMax');
            $("#btnMaxsize").addClass('btnMaxReturn');
        });
        gui.Window.get().on('unmaximize', function () {
            $("#btnMaxsize").removeClass('btnMaxReturn');
            $("#btnMaxsize").addClass('btnMax');
        });
        gui.Window.get().on('close', function () {
            curWin.show();//显示browser界面
            curWin.focus();//界面获取焦点
            var currentBucket = $('#curBucketName').html();
            var upd = window.upd;
            if (upd && upd['newAppPath']) {
                copyUninsFiles(upd);
                saveAccountAndKillDB(upd, currentBucket);
                return;
            }
            // 如果是obsdb进程被kill掉，数据库不可用，提示用于关闭browser
            if(window.mongod.exitCode){
                $('.mui-model').showMessage({
                    type: "warning",
                    message: languageJson.sureQuitClint,
                    isFocus: true,
                    ok: function () {
                        gui.App.quit();
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                    },
                    cancel: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        return false;
                    },
                    title: languageJson.warning
                });
                showOverlay();
            }else{
                closeAlert(currentBucket);
            }
        });

        //将数据库文件保存在用户数据目录
        var dbpath = global.appDataPath+"/data";
        if(fs.existsSync(global.appDataPath + "setting")){
            var setting = fs.readFileSync(global.appDataPath + "setting", "utf-8");
            var b = new Base64();
            var base64Str = b.decode(setting);
            setting = JSON.parse(base64Str);
            if(setting.dbpath){
                dbpath = setting.dbpath;
            }
        }
        if(!fs.existsSync(dbpath)){
            createLocalFolder(dbpath);
        }
        global.mongodbPath = dbpath;
        global.logger.info("startDB dbpath",dbpath);
        var startDB = function(){
            var path = require('path');
            var spawn = require('child_process').spawn;
            window.mongod = spawn(path.dirname(process.execPath)+'/obsdb.exe', ['--dbpath', dbpath ,'--bind_ip' ,'127.0.0.1','--port' ,27117,'--auth']);

            window.mongod.stdout.on('data', function (data) {
                global.dbLogger.debug(data.toString());
            });

            window.mongod.stderr.on('data', function (data) {
                logger.error(data.toString());
            });

            window.mongod.on('close', function (code) {
                logger.info("obsdb close",code);
            });
        };


        fs.exists(dbpath+'/mongod.lock', function (exists) {
            if(exists){
                fs.unlink(dbpath+'/mongod.lock',function(err){
                    if(err){
                        logger.info(err);
                    }
                    startDB();
                });
            }
            else{
                startDB();
            }
        });
        var option = {
            key: 'Ctrl+F5',
            active: function () {
                var keyCode = this.key;
                if (keyCode === 'Ctrl+A') {
                    if (!triggerInputCtrlA()) {
                        return false;
                    }
                    if($("#objLists tr").length > 0){
                        disabledBtn($("#copybtn,#movebtn,#ObjectMorebtn"));
                    }
                    if($("#objLists tr").length===1){
                        $("#PolicyBtn").removeClass("mui-disabled");
                    }else{
                        $("#PolicyBtn").addClass("mui-disabled");
                        $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
                    }
                    // 检查是否为伙伴云节点，当前设置默认伙伴云为法电（eu-west-0）
                    if (window.isPartnerCloud) {
                        $("#PolicyBtn").addClass('mui-disabled');
                    } else {
                        $("#PolicyBtn").removeClass('mui-disabled');
                    }
                    if ($("#mui-overlay").size() > 0) {
                        $('#listObjBodyDiv,#uploadTaskDiv,#downloadTaskDiv,#deleteTaskDiv,#recoverTaskDiv').removeClass('onMouseOver');
                    }
                    $(".onMouseOver tbody tr").addClass('selected-tr-active');
                    if($(".onMouseOver tbody .selected-tr-active").length==1){
                        disabledBtn($("#editCors,#deleteCors,#editLifecycle,#deleteLifecycle"));
                        disabledBtn($(".mui-page .shown .mui-icon-del-16"));
                    }else if($(".onMouseOver tbody .selected-tr-active").length>1){
                        $("#editCors,#editLifecycle").addClass('mui-disabled');
                        disabledBtn($("#deleteCors,#deleteLifecycle"));
                    }
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-6').addClass('show-span-active');
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-4').addClass('show-span-active');
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-prototype').addClass('show-span-active');
                    $(".onMouseOver tbody tr td").find('.mui-ellipsis-multipart').addClass('show-span-active');
                    if($("#objLists tbody tr").hasClass('selected-tr-active')){
                        $("#allObject").get(0).checked = true;
                        $("#objLists tbody").find(".objectCheckbox").each(function () {
                            $(this).get(0).checked = true;
                            $(this).addClass('ObjectChecked');
                        })
                        disabledBtn($("#downloadbtn,#btnDeleteObjects"));
                        var arr_tr = $("#objLists tbody tr.selected-tr-active");
                        var currFileName = '';
                        arr_tr.each(function(i,obj){
                            var fileName = '';
                            if($(obj).find('td').eq(0).find('span i').hasClass("mui-icon-object-folder"))
                            {
                                fileName = JSON.parse($(obj).find('.hiddenObjData').text()).name;
                            }else
                            {
                                fileName = JSON.parse($(obj).find('.hiddenObjData').text()).name;
                            }
                            if(currFileName.indexOf(fileName)===-1)
                            {//判断被选择文件是否已经存在于已选文件
                                currFileName = currFileName+fileName+"|";
                            }
                        });
                        $("#downloadFileName").val(currFileName);
                        //全选下载按钮是否置灰
                        var restore_state = $("#objLists tr.selected-tr-active").find('.restore_stat');
                        var no_restore_objNum=false;
                        for(var j = 0; j < restore_state.length; j++) {
                            if(_.isEqual($(restore_state[j]).text(), languageJson.obs_term_notRestored_lable)){
                                no_restore_objNum=true;
                                break;
                            }
                            if(_.isEqual($(restore_state[j]).text(), languageJson.obs_term_restoring_lable)){
                                no_restore_objNum=true;
                                break;
                            }
                        }
                        //如果有未恢复对象，置灰下载按钮
                        if(no_restore_objNum){
                            $("#downloadbtn").addClass('mui-disabled');
                        }else{
                            disabledBtn($("#downloadbtn"));
                        }
                    }

                    //属性按钮置灰
                    if($("#objLists tr.selected-tr-active").length == 1 && $("#objLists tr.selected-tr-active").attr("data-type") == "file") {
                        //判断对象是否已经恢复
                        var path = getCurrPath();
                        checkObjectRestore(path + JSON.parse($(this).find('.hiddenObjData').text()).name);
                    } else {
                        disabledBtn($("#recoverBtn"));
                    }
                    //全选后，当选中对象中存在不符合恢复条件对象时，禁用恢复按钮
                    var category=$("#objLists tr.selected-tr-active").find('.hiddenObjData');
                    for(var i=0;i<category.length;i++){
                        var hiddenObjData = JSON.parse($(category[i]).text());
                        var storage = hiddenObjData.StorageClass;
                        if(storage === "STANDARD" || storage === "STANDARD_IA"){
                            $("#recoverBtn").addClass("mui-disabled");
                            $("#recoverBtn").attr("disabled",true);
                            $("#recoverBtn").attr("title",languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
                            break;
                        }
                    };
                }else if (keyCode === 'Ctrl+A') {
                    return false;
                }
            },
            failed: function (msg) {

            }

        };

        var triggerInputCtrlA=function(){
            var element = document.activeElement;
            if(element.nodeName==="INPUT" || element.nodeName==="TEXTAREA"){
                element.select();
                return false;
            }
            return true;
        }

        //Ctrl+F5----->刷新桶
        //Ctrl+F6----->刷新桶列表
        //Delete 删除选中对象
        //Ctrl+Delete 删除当前桶
        //Ctrl + A
        var keys = ['Ctrl+A','Ctrl+Z'];
        var cuts=[];
        for (var k in keys) {
            option.key = keys[k];
            var shortcut = new gui.Shortcut(option);
            cuts.push(shortcut);
        }

        gui.Window.get().on("focus",function(){
            for(var c in cuts){
                gui.App.registerGlobalHotKey(cuts[c]);
            }
        });

        gui.Window.get().on("blur",function(){
            for(var c in cuts){
                gui.App.unregisterGlobalHotKey(cuts[c]);
            }
        });

        // Give it a menu
        checkColdline(pkg.coldline);
        checkObjectColdline(pkg.objectColdline);
        setTimeout(function () {
            //获取用户信息列表
            accountService.getAccountList(function (err, lsAccount) {
                global.accountObj = lsAccount;
                if(UCDVersion === 'DT'|| UCDVersion === 'Russia'){
                    $("#zhLanguage").remove();
                }
                for(var i = 0;i<langaugeArr.length;i++){
                    $("#language").append("<option style='width:200px;' value='" + encoderForHtml(langaugeArr[i].key) + "'> <span style='max-width: 200px;'>" + encoderForHtml(langaugeArr[i].value) + "</span> </option>");
                }
                indexAction.loadingBasicSetting(pkg,function (err,data) {
                    if(data){
                        global.logger.info("setting in package configuration...", data);
                        var setObj = JSON.parse(data);
                        logger.level = setObj.loggerLevel;
                        global.dbLogger.level = setObj.loggerLevel;//设置mongodb数据库日志级别
                        global.logger=logger;
                        if(setObj.rubbishDays){
                            rubbishDays = parseFloat(setObj.rubbishDays);
                        }
                        isShowServerEncryption = setObj.isShowServerEncryption;
                        if(setObj.isShowServerEncryption){
                            signatureVersion = 'v4';
                        } else {
                            $("#serverEncryptionDiv").hide();
                        }
                    }else{
                        global.logger.error('loadingBasicSetting error:',err);
                    }
                });
                if (lsAccount) {
                    var htmlStr = "";
                    var userStr = '<ul style="max-height: 500px;overflow-y: scroll">';
                    var arr = lsAccount.Accounts.Account;
                    var currentId = lsAccount.Accounts.$.current.toString();
                    if(arr.length>0){
                        $(".btnUserInfo").css("max-width","221px");
                    }else{
                        $(".btnUserInfo").css("max-width","46px");
                    }
                    setTimeout(function(){
                        for (var i = 0; i < arr.length; i++) {
                            if(currentId===arr[i].ID[0]){
                                var showName = encoderForHtml(arr[i].Name).length>20?encoderForHtml(arr[i].Name).substring(0,20)+"...":encoderForHtml(arr[i].Name);
                                var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                                $(".btnUserInfo").html(str);
                            }
                            //在账号管理列表里面，如果账号字符大于30，则添加title
                            var accountDomTitle = encoderForHtml(arr[i].Name).length> 27 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                            htmlStr =
                                "<tr>" +
                                "<td style='padding-left: 20px;width: 340px;'>" +
                                "<span " + accountDomTitle + " class='mui-ellipsis-prototype'>" + encoderForHtml(arr[i].Name) + "</span>" +
                                "</td>" +
                                "<td style='width: 120px'>" +
                                "<a href='#' data-href='createAccount' data-id='" + arr[i].ID + "' class='mui-icon-account-edit'>"+languageJson.edit+"</a>" +
                                "<a href='#' style='margin-left: 20px;' data-href='accountList' data-id='" + arr[i].ID + "' class='mui-icon-account-del'>"+languageJson.delete+"</a>" +
                                "</td>" +
                                "</tr>";
                            $("#accountTab tr:last").after(htmlStr);
                            var accountDomTitleDownList = encoderForHtml(arr[i].Name).length > 51 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                            userStr +=
                                "<li>" +
                                "<a href='#' class='user' data-id='"+arr[i].ID+"' data-href='"+encoderForHtml(arr[i].Name)+"'>" +
                                "<span " + accountDomTitleDownList + " class='mui-ellipsis-prototype mui-icon-account1'>"+ encoderForHtml(arr[i].Name) +"</span>" +
                                "</a>" +
                                "</li>";
                        }
                        if(arr.length>0){
                            userStr +='</ul>'+'<li class="mui-border-before"><a href="#" id="accountManager" class="manager" style="padding: 4px 8px"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
                        }else{
                            userStr +='</ul>'+'<li><a href="#" id="accountManager" class="manager" style="padding: 4px 8px"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
                        }
                        $("#userList").html(userStr);
                    },2000);
                    if (gui.App.argv.length < 2) {
                        setTimeout(function () {
                            curWin.show();
                            var tray = false;
                            if(UCDVersion === 'DT' || UCDVersion === 'SBB'){//DT版本
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/dt_images/OTC32.png'});
                            } else if(UCDVersion === 'OCB'){//FT版本
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/ft_images/OCB32.png'});
                            } else if(UCDVersion === 'Russia'){//Russia版本
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/russia_images/OBS32.png'});
                            }else{
                                tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/icons/OBS32.png'});
                            }
                            tray.on('click', function () {
                                curWin.focus();
                            });
                        }, 200);
                    }
                    winType = os.platform();
                    indexAction.loadSetting(function (obj) {
                        initSysConfig(obj);
                        if(pkg){
                            var version = pkg.newVersion;
                            var lastUpdateDate = languageJson.lastUpdateDate + pkg.LastUpdateDate;
                            global.appVersion = version;
                            var showVersion = pkg.showVersion;
                            if(showVersion){
                                version  = showVersion;
                            }
                            $("#helpVersion").html(version);
                            $("#helpDtVersion").html(version);
                            $("#lastUpdateTime").html(lastUpdateDate);
                            if(UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'HCS' && UCDVersion !== 'SBB'&& UCDVersion !== 'HK'){
                                $("#websiteTr").addClass('mui-hide');
                                $(".more-user-btns").css('right','68px');
                                $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.DTStorage+"</span>");
                                $("#userExperienceDiv").addClass('mui-hide');
                                $("#aboutLi").addClass('mui-hide');
                                $("#otherSetting").addClass('mui-hide');
                                $("#isAutoUpdate").get(0).checked = (isAutoUpdate=='Y'?true:false);
                                if(UCDVersion!=='DT'){//不是DT版本
                                    $("#DtProductMsg").addClass('mui-hide');
                                    $("#CopyrightOwner").html(languageJson[commonUtils.getDiffVersionLang(UCDVersion,"copyright")]);
                                }
                            }else{
                                $("#hwcloudsWeb").removeClass('mui-hide');
                                $("#dtloudsWeb").addClass('mui-hide');
                                $("#aboutDtLi").addClass('mui-hide');
                                $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.MOSStorage+"</span>");
                                $("#isAutoUpdate").get(0).checked = (isAutoUpdate=='Y'?true:false);
                            }
                        }
                        errorConfig = indexAction.initErrorConfig(errorConfig,languageJson);
                        indexAction.loadExtBucket(function (data) {
                            ExtBucket = data;
                            if(obj && (obj.mongoAuthPwd==="" || obj.mongoAuthPwd)){
                                global.newMongoPwd = obj.mongoAuthPwd;
                                loaderUser();
                            } else {
                                //如果之前没有设置db的密码，则设置mongodb密码为空
                                var configObj = {};
                                global.newMongoPwd = "";
                                if (obj) {
                                    configObj = obj;
                                } else {
                                    configObj = {
                                        isAutoUpdate: isAutoUpdate,
                                        userExperience: 'N',
                                        isMultiUpload: true,
                                        multiUploadNum: 5,
                                        language: 'zh',
                                        isMultiDownload: true,
                                        isHttps: 'Y'
                                    };
                                    if(navigator.language.indexOf("zh")<0){//不是中文环境
                                        configObj.language = "en";
                                    }
                                    if (UCDVersion !== 'HEC' && UCDVersion !== 'HK' && UCDVersion !== 'CTC' && UCDVersion !== 'CMCC' && UCDVersion !== 'HCS') {
                                        configObj.language = "en";
                                    }
                                }
                                configObj.mongoAuthPwd = "";
                                indexAction.writeSysConfig(JSON.parse(JSON.stringify(configObj)), userPath);
                                loaderUser();
                            }
                        });

                    });
                } else {
                    var trs = $("#accountTab tbody").find('tr').length;
                    if (gui.App.argv.length < 2) {
                        allButtonChange('1');
                        setTimeout(function () {
                            //读取本地region配置文件信息
                            indexAction.getBucketRegion(pkg, function (err,data) {
                                if(!err){
                                    var configObj = JSON.parse(data);
                                    var arr = configObj.options;
                                    var htmlStr = "";
                                    var selBody = $("#regionSelect");
                                    selBody.html('');
                                    for (var index in arr) {
                                        if(language!='zh'){
                                            if(UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'HCS'&&UCDVersion !== 'SBB'&&UCDVersion !== 'HK'){
                                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                                                if(arr.length === 1){
                                                    $("#regionSelect").addClass('mui-hide');
                                                    $("#regionStr1").removeClass('mui-hide');
                                                    $("#regionStr1").html(encoderForHtml(arr[index].value));
                                                }
                                            }else{
                                                if(arr[index].value=='cn-north-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN North-Beijing1</option>";
                                                }else if(arr[index].value=='cn-east-2'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN East-Shanghai2</option>";
                                                }else if(arr[index].value=='cn-south-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN South-Guangzhou</option>";
                                                }else if(arr[index].value=='ap-southeast-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Hong Kong</option>";
                                                }else if(arr[index].value=='ap-southeast-2'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Bangkok</option>";
                                                }else if(arr[index].value=='cn-north-4'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN North-Beijing4</option>";
                                                }else if(arr[index].value=='cn-southwest-2'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>cn-southwest-2</option>";
                                                }else if(arr[index].value=='af-south-1'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AF-Johannesburg</option>";
                                                }else if(arr[index].value=='ap-southeast-3'){
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Singapore</option>";
                                                }else{
                                                    htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                                                }
                                            }
                                        }else{
                                            htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                                        }
                                        selBody.append(htmlStr);
                                    }
                                    domainName = configObj.domainName;
                                    global.domainName = configObj.domainName;
                                    defaultRegion = configObj.defaultRegion;
                                    updateServer = configObj.updateServer;
                                }else{
                                    logger.error(err);
                                }
                                indexAction.loadSetting(function (obj) {
                                    initSysConfig(obj);
                                    if ('Y' === isAutoUpdate && process.platform.startsWith("win")) {
                                        mosUpdate();
                                    }
                                    if (pkg) {
                                        var version = pkg.newVersion;
                                        var lastUpdateDate = languageJson.lastUpdateDate + pkg.LastUpdateDate;
                                        global.appVersion = version;
                                        var showVersion = pkg.showVersion;
                                        if(showVersion){
                                            version  = showVersion;
                                        }
                                        $("#helpVersion").html(version);
                                        $("#helpDtVersion").html(version);
                                        $("#lastUpdateTime").html(lastUpdateDate);
                                        if(UCDVersion !== 'HEC'&&UCDVersion !== 'CTC'&&UCDVersion !== 'CMCC'&&UCDVersion !== 'HCS'&& UCDVersion !== 'SBB'&& UCDVersion !== 'HK'){
                                            $("#websiteTr").addClass('mui-hide');
                                            $(".more-user-btns").css('right','68px');
                                            $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.DTStorage+"</span>");
                                            $("#userExperienceDiv").addClass('mui-hide');
                                            $("#aboutLi").addClass('mui-hide');
                                            $("#otherSetting").addClass('mui-hide');
                                            $("#isAutoUpdate").get(0).checked = (isAutoUpdate == 'Y' ? true : false);
                                            if(UCDVersion!=='DT'){//不是DT版本
                                                $("#DtProductMsg").addClass('mui-hide');
                                                $("#CopyrightOwner").html(languageJson[commonUtils.getDiffVersionLang(UCDVersion,"copyright")]);
                                            }
                                        }else{
                                            $("#hwcloudsWeb").removeClass('mui-hide');
                                            $("#dtloudsWeb").addClass('mui-hide');
                                            $("#aboutDtLi").addClass('mui-hide');
                                            $("#selType").find('option:selected').html("<span style='font-size: 0.8em;'>"+languageJson.MOSStorage+"</span>");
                                            $("#isAutoUpdate").get(0).checked = (isAutoUpdate == 'Y' ? true : false);
                                        }
                                    }
                                    errorConfig = indexAction.initErrorConfig(errorConfig,languageJson);
                                });
                            });
                            $(".btnUserInfo").css("max-width","46px");
                            var str = '<span class="mui-ellipsis-2" style="color: #ffffff;"></span><i class="btn-account"></i>';
                            $(".btnUserInfo").html(str);
                            setTimeout(function(){
                                var userStr = '<li><a href="#" id="accountManager" class="manager"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
                                $("#userList").html(userStr);
                            },2000);
                            if (gui.App.argv.length < 2) {
                                setTimeout(function () {
                                    curWin.show();
                                    var tray = false;
                                    if(UCDVersion === 'DT' || UCDVersion === 'SBB'){//DT版本
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/dt_images/OTC32.png'});
                                    } else if(UCDVersion === 'OCB'){//FT版本
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/ft_images/OCB32.png'});
                                    } else if(UCDVersion === 'Russia'){//Russia版本
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/russia_images/OBS32.png'});
                                    } else{
                                        tray = new gui.Tray({title: 'OBS Browser', icon: 'client_ui/icons/OBS32.png'});
                                    }
                                    tray.on('click', function () {
                                        curWin.focus();
                                    });
                                }, 200);
                            }
                            showOverlay();
                            indexAction.loadSetting(function (obj) {
                                if (obj && (obj.mongoAuthPwd === "" || obj.mongoAuthPwd)) {
                                    global.newMongoPwd = obj.mongoAuthPwd;
                                    $("#createAccount").addClass('shown');
                                    if(_.isEqual(UCDVersion,"HCS") || _.isEqual(UCDVersion,"SBB")){
                                        $("#HCS").parent().addClass('mui-hide');
                                    }
                                    $("#createAccountTab").removeClass("mui-hide");
                                    $("#saveAccountBtn").attr('data-init', 'true');
                                    $(".btnUserInfo").addClass('userNoLogin');
                                }else{
                                    $(".btnUserInfo").addClass('userNoLogin');
                                    var configObj = {};

                                    global.newMongoPwd = "";
                                    if (obj) {
                                        configObj = obj;
                                    } else {
                                        configObj = {
                                            isAutoUpdate: isAutoUpdate,
                                            userExperience: 'N',
                                            isMultiUpload: true,
                                            multiUploadNum: 5,
                                            language: 'zh',
                                            isMultiDownload: true,
                                            isHttps: 'Y'
                                        };
                                        if(navigator.language.indexOf("zh")<0){//不是中文环境
                                            configObj.language = "en";
                                        }
                                        if (UCDVersion !== 'HEC' && UCDVersion !== 'HK' && UCDVersion !== 'CTC' && UCDVersion !== 'CMCC' && UCDVersion !== 'HCS') {
                                            configObj.language = "en";
                                        }
                                    }
                                    configObj.mongoAuthPwd = "";

                                    indexAction.writeSysConfig(JSON.parse(JSON.stringify(configObj)), userPath);
                                    $("#createAccount").addClass('shown');
                                    if (_.isEqual(UCDVersion, "HCS") || _.isEqual(UCDVersion, "SBB")) {
                                        $("#HCS").parent().addClass('mui-hide');
                                    }
                                    $("#createAccountTab").removeClass("mui-hide");
                                    $("#saveAccountBtn").attr('data-init', 'true');

                                }
                                divDragFunc('createAccountDrag', 'createAccount');
                            });
                        }, 50);
                    }
                }
            });
            // 隐藏收藏图标
            $("#pathInputCollect").addClass("mui-hide");
        }, 300);
    }
});

function firstWordUpperCase(str){
    return str.toLowerCase().replace(/(\s|^)[a-z]/g, function(char){
        return char.toUpperCase();
    });
}

function initSysConfig(obj){
    if (obj && obj.isAutoUpdate) {
        isAutoUpdate = obj.isAutoUpdate;
    }else{
        isAutoUpdate = 'N';
    }
    if (obj && obj.isOverwritePower) {
        isOverwritePower = obj.isOverwritePower;
    }
    if (obj && obj.language) {
        language = obj.language;
        if(UCDVersion==='DT'){
            language = 'en';
        }
        loadLanguge();
    }else if(UCDVersion !== 'HEC'&& UCDVersion !== 'HK' && UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'HCS'){
        language = 'en';
        loadLanguge();
    }else{
        language = 'zh';
        loadLanguge();
    }
    if (obj && obj.isHttps) {
        isHttps = obj.isHttps;
    }
    if(obj && obj.isSSL){
        isSSL = obj.isSSL;
    }
    if(obj && obj.isMD5check){
        global.isMD5check = obj.isMD5check;
    }
    if (obj && obj.downloadTaskNum) {
        downloadTaskNum = obj.downloadTaskNum;
        downloadConfig.maxTaskNum = downloadTaskNum;
    }
    if (obj && obj.uploadTaskNum) {
        uploadTaskNum = obj.uploadTaskNum;
        uploadConfig.maxUploadTasks = uploadTaskNum;
    }
    if (obj && obj.multiUploadNum) {
        uploadConfig.multiUploadNum = obj.multiUploadNum;
    }
    if (obj && obj.isMultiDownload) {
        downloadConfig.isMultiDownload = obj.isMultiDownload;
    }
    if (obj && obj.proxy) {
        proxy = obj.proxy;
        initProxy();
    }
    if(obj && obj.isServerEncryption && isShowServerEncryption)
    {
        global.serverEncryption = obj.isServerEncryption;
    }

    if(obj && obj.objPerPageSize) {
        global.objPerPageSize = obj.objPerPageSize;
    }

    initTinyCompnents();
    initDepondLang();
}

function  loadLanguge(){
    languageJson=languageData;
    if(UCDVersion === 'TLF'){//如果是TLF版本,修改账户欠费词条
        var data = {
            "en":"Your account is frozen.",
            "Portuguese":"A sua conta está congelada.",
            "Spanish":"Su cuenta está congelada."
        }
        languageJson.InArrearOrInsufficientBalance = data[language];
    }
    global.langData = languageJson;
};

// 根据路径是否已经收藏，显示收藏图标样式
function showFavouriteIcon(pathName) {
    var isFav = isFavouritePath(pathName,favouritePath, currentUserId);
    if(isFav){
        $("#pathInputCollect").addClass("uncollectInputPath");
        $("#pathInputCollect").attr("title", languageJson.common_term_cancelCollect_button);
    }else {
        $("#pathInputCollect").removeClass("uncollectInputPath");
        $("#pathInputCollect").attr("title", languageJson.common_term_collect_button);
    }
}

function updateFavouritePathCount() {
    var arr = [];
    for(var i in favouritePath){
        if(favouritePath[i].id===currentUserId){
            arr = favouritePath[i].pathArr;
            break;
        }
    }
    var num = arr.length > 100 ? 100 : arr.length;
    var btnText = languageJson.obs_term_collectPath_add_button.format(num);
    $("#addFavouritePath").text(btnText);
}

function loaderUser(currentId,isShowMsg,accObject) {
    // 读取用户收藏路径
    indexAction.loadFavouritePath(function (data) {
        favouritePath = data;
    });
    
    //每次切换用户需要清理copy/move剪切板
    global.glbClipboard.clean();
    var isShowerr = false;
    if(isShowMsg){
        isShowerr = isShowMsg;
    }
    accountService.getAccountInfo(currentId, function (result) {
        if(accObject){
            result.secretKey = accObject.secretKey;
        }
        if(!result){
            if(isShowerr){
                $('.mui-model').showErrorMessage({
                    message: languageJson.getConfigInfoErr,
                    obsError: obsError("getConfigInfoErr")
                });
            }
            allButtonChange('1');
            return false;
        }else{
            global.currentUserName = result.name.toString();
        }
        require("./js/access/iam/IAMConnector").loadUserInfo(result);
        indexAction.loadingBasicSetting(pkg,function (err,data) {
            if(data){
                var setObj = JSON.parse(data);
                logger.level = setObj.loggerLevel;
                global.logger=logger;
                global.dbLogger.level = setObj.loggerLevel;//设置mongodb数据库日志级别
                if(setObj.rubbishDays){
                    rubbishDays = parseFloat(setObj.rubbishDays);
                }
                isShowServerEncryption = setObj.isShowServerEncryption;
                if(setObj.isShowServerEncryption){
                    signatureVersion = 'v4';
                } else {
                    $("#serverEncryptionDiv").hide();
                }
            }else{
                global.logger.error('loadingBasicSetting error');
            }
        });
        indexAction.getBucketRegion(pkg, function (err, data) {
            if(!err){
                var configObj = JSON.parse(data);
                var arr = configObj.options;
                var htmlStr = "";
                var selBody = $("#regionSelect");
                selBody.html('');
                for (var index in arr) {
                    if(language!='zh'){
                        if(UCDVersion !== 'HEC'&& UCDVersion !== 'CTC'&& UCDVersion !== 'CMCC'&& UCDVersion !== 'HCS' && UCDVersion !== 'SBB'&& UCDVersion !== 'HK'){
                            htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                            if(arr.length === 1){
                                $("#regionSelect").addClass("mui-hide");
                                $("#regionStr1").removeClass("mui-hide");
                                $("#regionStr1").html(arr[index].value);
                            }
                        }else{
                            if(arr[index].value=='cn-north-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN North-Beijing1</option>";
                            }else if(arr[index].value=='cn-east-2'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN East-Shanghai2</option>";
                            }else if(arr[index].value=='cn-south-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN South-Guangzhou</option>";
                            }else if(arr[index].value=='ap-southeast-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Hong Kong</option>";
                            }else if(arr[index].value=='ap-southeast-2'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Bangkok</option>";
                            }else if(arr[index].value=='cn-north-4'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>CN North-Beijing4</option>";
                            }else if(arr[index].value=='cn-southwest-2'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>cn-southwest-2</option>";
                            }else if(arr[index].value=='af-south-1'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AF-Johannesburg</option>";
                            }else if(arr[index].value=='ap-southeast-3'){
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>AP-Singapore</option>";
                            }else{
                                htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                            }
                        }
                    }else{
                        htmlStr = "<option value = '" + encoderForHtml(arr[index].value) + "'>" + encoderForHtml(arr[index].key) + "</option>";
                    }
                    selBody.append(htmlStr);
                }
                if(!$('#regionSelect').hasClass('mui-hide')){
                    $('#regionSelect').selectmenu().selectmenu( "menuWidget" ).addClass("obs-connect-type");
                }
                domainName = configObj.domainName;
                global.domainName = configObj.domainName;
                defaultRegion = configObj.defaultRegion;
                global.apiProxyAddress = configObj.apiProxyAddress;
                updateServer = configObj.updateServer;
                window.partnerClouds = configObj.partnerClouds;
                global.partnerClouds = configObj.partnerClouds;
            } else {
                logger.error(err);
            }
            if ('Y' === isAutoUpdate && process.platform.startsWith("win")) {
                mosUpdate();
            }
            //保存https协议信息，301重定向时需要
            global.isHttps = isHttps;
            var option = {};
            if(result.secretKey){
                option = {
                    accessKey: result.accessKey,
                    secretKey: result.secretKey,
                    endpoint: result.endpoint,
                    isHttps: isHttps,
                    proxy:proxy,
                    isSSL:isSSL,
                    isMD5check:global.isMD5check
                };
            }else{
                allButtonChange('1');
                $("#createAccount .mui-page-full-title").html(languageJson.editAccount);
                $("#name").val(result.name);
                $("#accessKey").val(result.accessKey);
                $("#selType").val(result.type);
                $("#loadingPath").val(result.loadPath)
                $("#selType").selectmenu('refresh', true);
                if(result.type.toString().trim()==='1'){
                    $("#endpointDiv").addClass('mui-hide');
                }else{
                    $("#endpointDiv").removeClass('mui-hide');
                    $("#endpoint").val(result.endpoint);
                }
                $("#isSaveSK").get(0).checked = false;
                $("#userId").val(result.userID);
                $("#createAccount").addClass('shown');
                $("#createAccountTab").removeClass("mui-hide");
                $("#saveAccountBtn").attr('data-edit', 'true');
                divDragFunc('createAccountDrag','createAccount');
                return false;
            }


            //加载region信息，V4鉴权必须
            if (defaultRegion)
            {
                option.defaultRegion = defaultRegion;
            }
            //加载鉴权版本
            if (signatureVersion)
            {
                option.signatureVersion = signatureVersion;
            }
            s3 = indexAction.initS3(option);
            global.s3 = s3;
            bucketAndObjectAction = new BucketAndObjectAction(s3,0);
            bucketAttributeAction = new BucketAttributeAction(s3);
            var userPath = global.appDataPath;
            currentUserId = result.userID[0];
            global.currentUserId = currentUserId;

            endpoint=result.endpoint;
            userType = result.type[0];
            if (objectShowWay === "list") {
                $("#listObjBodyDiv").removeClass("mui-hide");
                $("#objContainer").addClass("mui-hide");
            } else {
                $("#listObjBodyDiv").addClass("mui-hide");
                $("#objContainer").removeClass("mui-hide");
            }
            lastBucket = result.lastBucket ? result.lastBucket.toString() : "";
            var loading = loadingShow();
            if(typeof result.loadPath !== "undefined"){
                var loadPath = result.loadPath[0];
                if(loadPath.indexOf("/")>-1){
                    var arr = loadPath.split("/");
                    var bucket = arr.shift();
                }else{
                    var bucket = loadPath ;
                }
                $('#curBucketName').html(bucket);
                var str = {
                    name: bucket
                };
                var htmStr = renderSync("head-navi-item", {
                    currPath: JSON.stringify(str),
                    folderName: bucket
                });
                $(".mui-body .mui-content .path").html(htmStr);
                var prefix = loadPath.slice(bucket.length+1);
                loadFavouritePathList(bucket);
                bucketAndObjectAction.listObject(bucket,"true",prefix,function(err,data){
                    if(err){
                        if(err.code === "Unauthorized"){//未实名
                            $(".mui-page-full.shown").removeClass('shown');
                            $("#auth").removeClass('mui-hide');
                            $("#auth").addClass('shown');
                            divDragFunc('authDrag','auth');
                            $('.btnUserInfo').removeClass('userLogin');
                            $("#overlay").removeClass('mui-hide');
                        }
                        global.logger.info(err)
                        if(err.message && err.message.indexOf("prefix") > -1 && err.message.indexOf("too") > -1) {
                            global.logger.error("searchPrefixTooLong!", err);
                            err.code = "searchPrefixTooLong";
                        }
                        if(errorConfig[err.code]){
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message),
                                ok: function () {
                                    return false;
                                }
                            });
                        }
                    }else{
                        var len = loadPath.length;
                        var index = loadPath.lastIndexOf("/");
                        var path = "";
                        if(len === (index +1)){ //以“/”结尾的访问路径
                            path = "obs://" + loadPath;
                            showFavouriteIcon(loadPath);
                        }else {
                            var subPath = loadPath.substr(0,index+1);
                            path = "obs://" + loadPath.substr(0,index+1);
                            showFavouriteIcon(subPath);
                        }
                        global.inputPath = path;
                        $("#pathInput").val(path);
                        $("#pathInputCollect").removeClass("mui-hide");
                        allButtonChange('2');
                        $("#objectArea").removeClass('mui-hide');//桶列表和对象列表切换
                        $("#bucketArea").addClass('mui-hide');
                        $("#objectBtnDiv").removeClass('mui-hide');
                        $("#bucketBtnDiv").addClass('mui-hide');
                        $("#prefixSearch").val("");
                        $("#all-back-div").addClass('all-back-btn');//修改后退按钮样式
                        $("#all-back-div").removeClass('all-back-btn-disabled');
                        $(".mui-font-color-gray").removeClass('mui-hide');//显示下方属性栏
                        $("#prefixSearch").attr('placeholder', languageJson.prefixSearchInfo);
                        if(data&&(data.Contents.length >0||data.CommonPrefixes.length>0)){//能够搜索到文件或文件夹
                            reloadTask();
                            //登录成功后,记录用户登录
                            if(UCDVersion === 'HEC'|| UCDVersion === 'CTC'|| UCDVersion === 'CMCC'|| UCDVersion === 'HCS'|| UCDVersion === 'HK'){
                                userCommentLogin(result.accessKey, result.secretKey);
                            }
                            var prefix = data.Prefix;
                            isLoaded = true;
                            $('.btnUserInfo').addClass('userLogin');
                            var arr1 = prefix.split("/");
                            var ObjectName = arr1.pop();
                            if(ObjectName.length>0){
                                $("#isSearch").val(ObjectName);
                            }
                            var str = {
                                name: bucket
                            };
                            var htmStr = renderSync("head-navi-item", {
                                currPath: JSON.stringify(str),
                                folderName: bucket
                            });
                            $(".mui-body .mui-content .path").html(htmStr);
                            var length = 0;
                            for(var i=0;i<arr1.length;i++){
                                length+=arr1[i].length+1;
                                var str = {
                                    name: prefix.slice(0,length)
                                }
                                var htmStr = renderSync("head-navi-item", {
                                    currPath: JSON.stringify(str),
                                    folderName: arr1[i]
                                });
                                $(".mui-body .mui-content .path").append(htmStr);
                            }
                        }
                        listObjectUI(err, data, bucket);
                    }
                    loading.close();
                });
            }else{
                bucketAndObjectAction.listBucket(function (err, data) {
                    if (!err || err.code === "AccessDenied") {
                        if(data) {
                            global.curOnwerId = data.Owner.ID;
                            global.curDisplayName = data.Owner.DisplayName;
                        }
                        reloadTask();
                        //登录成功后,记录用户登录
                        if(UCDVersion === 'HEC'|| UCDVersion === 'CTC'|| UCDVersion === 'CMCC'|| UCDVersion === 'HCS'|| UCDVersion === 'HK'){
                            userCommentLogin(result.accessKey, result.secretKey);
                        }
                    }
                    listBucketUI(err, data, loading);
                });
            }
            $("#taskConcole .body tbody").html('');
        });
    });
}
function reloadTask() {
    if(taskManager){
        taskManager = null;
        delete taskManager;
    }
    if(taskControlAction){
        taskControlAction = null;
        delete taskControlAction;
    }
    taskManager = new TaskManager(currentUserId,s3,'',uploadConfig,downloadConfig);
    taskControlAction = new TaskControlAction(s3, taskManager);
    taskManager.on("dbconn", function (task) {
        reloadTasks(true);//强制重新加载任务
        refreshTaskNum();//查询已有任务数量
        taskManager.pauseAll = true;

        if(!checkRecoverInterval) {
            global.logger.info("NUM_RECOVER_QUERY_TIMES:" + Const("NUM_RECOVER_QUERY_TIMES"));
            checkRecoverInterval = setInterval(function () {
                checkRecoverStatus()
            }, Const("NUM_RECOVER_QUERY_TIMES"));
        }
    })
        .on("onStart", function (task) {

            if (nowstat === "WAIT") {
                removeTask(task);
            }
            else if (nowstat === "") {
                refrchStat(task);
            }

        }).
    on("progress", function (task, evt) {
        refresh(task, evt);
    }).
    on("onWait", function (task) {
        if (!isLoaded) {
            return false;
        }
        if (nowstat === "PAUSE" || nowstat === "FAILED") {
            removeTask(task);
        }
        else if (nowstat === "WAIT") {
            addToTask(task);
        }
        else if (nowstat === "") {
            refrchStat(task);
        }
    }).
    on("onPause", function (task) {
        if (!isLoaded) {
            return false;
        }
        if (nowstat === "WAIT") {
            removeTask(task);
        } else if (nowstat === "PAUSE") {
            addToTask(task);
        } else if (nowstat === "") {
            refrchStat(task);
        }
    }).
    on("failed", function (task) {
        if (!isLoaded) {
            return false;
        }
        if (nowstat === "FAILED") {
            addToTask(task);
        } else if (nowstat === "") {
            refrchStat(task);
        }
    }).
    on("onAbort", function (task) {
        if (!isLoaded) {
            return false;
        }
        removeTask(task);
    }).
    on("end", function (task) {
        if (!isLoaded) {
            return false;
        }
        if($(".obs-tab-navi .obs-tab-active").attr('tab-for') === 'processingTaskPanel'){
            removeTask(task);
        }
        invokeTool.invokeWithInterval(refreshUI,task,1003,"refreshUI");
    });
}

function cleanObjectList() {
    $("#objLists tbody").find('tr').each(function () {
        $(this).remove();
    });
    $("#objLists tbody").html('');
}

// 如果不是以"/"结尾，则加上"/"
function addEndSlash(pathName) {
    if(!pathName){
        return "/";
    }
    var len = pathName.length;
    var index = pathName.lastIndexOf("/");
    var path = "";
    if(len === (index +1)){
        return pathName;
    }
    return pathName + "/";
}

function isFavouritePath(pathName, favouritePath, currentUserId) {
    var path = addEndSlash(pathName);
    var arr = [];
    for(var i in favouritePath){
        if(favouritePath[i].id===currentUserId){
            arr = favouritePath[i].pathArr;
            break;
        }
    }
    for(var index in arr){
        if(arr[index]===path){
            return true;
        }
    }
    return false;
}

/**
 *
 * @param err 调用S3返回的错误对象
 * @param data S3接口返回是数据对象
 * @param bucketName 桶名称
 * @param autoRefresh 如果是自动刷新，出现错误时则不弹出对话框
 * @param isLastPage 是否是最后一页
 * @returns {boolean}
 */
function listObjectUI(err,data,bucketName,autoRefresh,isLastPage){
    $("#path a").each(function(){
        var pathNodeName = $(this).attr("folderName");
        if(pathNodeName.length > 12) {
            $(this).attr("title", pathNodeName);
        }
    });
    copyMoveOptionDisplay();
    $(".pathInput").addClass("mui-hide");
    $("#bread-path-box").removeClass("mui-hide");
    getBucketStorageInfo(bucketName);
    $("#allObject").get(0).checked = false;
    $("#downloadbtn,#btnDeleteObjects,#recoverBtn,#PolicyBtn,#movebtn,#copybtn,#ObjectMorebtn").addClass('mui-disabled');
    $("#PolicyBtn").attr('data-title',languageJson.obs_objectPolicy_onlySelOne_tip);
    $("#downloadbtn,#movebtn,#copybtn").attr('data-title',languageJson.selectFileOrFolder);
    if (global.UCDVersion === "HEC" || global.UCDVersion  === 'HK') {
        $("#recoverBtn").attr('data-title',languageJson.obs_task_restoreObject_restoreOnlyArchive_tip);
    }else {
        $("#recoverBtn").attr('data-title',languageJson.obs_task_restoreObject_restoreOnlyCold_tip);
    }
    if (err) {
        logger.error("list Object UI ERR", err);
        if(!autoRefresh){
            if(errorConfig[err.code]){
                $('.mui-model').showErrorMessage({
                    message: errorConfig[err.code],
                    obsError: obsError(err.code,err.message),
                    ok: function () {
                        if ($("#mui-overlay").size() > 0) {
                            mui.overlay('off');
                        }
                        if(err.code == 'NoSuchBucket'|| err.code ==="AccessDenied") {
                            $("#bread-path-box-bucket").click();
                        }
                        return false;
                    }
                });
                showOverlay();
            }
        }
    } else {
        lastBucket = bucketName;
        var path = getCurrPath();
        var isSearch = $("#isSearch").val();
        if(!isSearch){
            if(data.Name!==$('#curBucketName').html()||data.Prefix!==path){
                return false;
            }
        }
        // 如果当前页没有对象且不是第一页，会返回到上一页
        if(data.Contents.length == 0 && data.CommonPrefixes.length == 0 && pageContext.nowPage > 1){
            $('#objLists-previous').click();
        }
        // 判断分页按钮是否显示隐藏
        if (data.IsTruncated) {
            pageContext["page" + (pageContext.nowPage + 1)] = data.NextMarker;
            $('#objLists-table-section').removeClass('mui-hide');
            if(pageContext.nowPage == 1){ // 有多页且在第一页的情况
                $('#objLists-previous').addClass('mui-disabled');
                $('#objLists-previous').attr('title',languageJson.common_term_previous_tip);
            }else{
                disabledBtn($('#objLists-previous'));
            }
            disabledBtn($('#objLists-next'));
        }else if(pageContext.nowPage == 1){ // 只有一页的情况
            $('#objLists-table-section').addClass('mui-hide');
        }else { // 在最后一页的情况
            disabledBtn($('#objLists-previous'));
            $('#objLists-next').addClass('mui-disabled');
            $('#objLists-next').attr('title',languageJson.common_term_next_tip);
        }
        if(isLoaded) {
            cleanObjectList();
            $("#objLists").css("width",$("#objListsHead").css("width"));
            var object;
            var key = data.Prefix;
            var fileAttr = {};
            var tbody = $("#objLists tbody");
            var flo;
            var isShow;
            var isShare;
            setLocalFolders(data.CommonPrefixes);
            try {
                var folderList = [];
                var isGLACIER = false;
                $("#objHeaderRestoreStatus").hide();
                if (pkg.objectColdline || currBucketStorage == 'Coldline') {
                    isGLACIER = true;
                }
                if(pkg.objectColdline){
                    $("#objHeaderRestoreStatus").show();
                }
                if (global.UCDVersion === "HEC"){
                    isShow = false;
                }else{
                    isShow = true;
                }
               if($('#bucketLists .selected-tr-active .show-span-active').hasClass('mui-icon-extBucket')){//判断被选择的桶是否为外部桶
                   isShow = true;
               }
                var isFileProFolder = global.curFileInterface === "Enabled"; //是否打开文件语义
                for (var i in data.CommonPrefixes) {
                    flo = data.CommonPrefixes[i];
                    fileAttr.name = encoderForHtml(flo.Prefix);
                    var pathName = bucketName+"/"+fileAttr.name;
                    var supportCollectPath = pkg.isSupportCollectPath;
                    var isFavourite = isFavouritePath(pathName, favouritePath, currentUserId);
                    var favouriteTitle = isFavourite ? languageJson.common_term_cancelCollect_button : languageJson.common_term_collect_button;
                    var prefixName = encoderForHtml(indexAction.handlePath(key, flo.Prefix, 1));
                    folderList.push({
                        //处理多个连续空格显示问题
                        showKey: prefixName.replace(new RegExp(' ', 'gm'), '&nbsp;'),
                        fileType: languageJson.folder,
                        storageClass: currBucketStorage,
                        prefixName: prefixName,
                        hidenData: JSON.stringify(fileAttr),
                        aclConfig: languageJson.download,
                        isGLACIER: isGLACIER,
                        isHEC:isShow,
                        isShare:isShare,
                        delete: languageJson.delete,
                        policy:languageJson.obs_objectPolicy_button,
                        coldline : pkg.objectColdline,
                        isFileProFolder : isFileProFolder,
                        isFavouritePath : isFavourite,
                        supportCollectPath : supportCollectPath,
                        favoutite : favouriteTitle
                    })
                }
                tbody.append(renderSync("listObjectsTemplate", folderList));
                if (UCDVersion === "HEC") {
                    if (window.isPartnerCloud) {
                        $(".mui-icon-handel-policy").addClass("mui-hide");
                    } else {
                        $(".mui-icon-handel-policy").removeClass("mui-hide");
                    }
                }

                var contentList = [];
                for (var index in data.Contents) {
                    object = data.Contents[index];
                    fileAttr.name = encoderForHtml(indexAction.handlePath(key, object.Key, 0));
                    fileAttr.size = indexAction.getFileSize(object.Size);
                    fileAttr.dataSize = object.Size;
                    fileAttr.etag = object.Etag;
                    fileAttr.modifyTime = indexAction.gmtDate2LocaleDate(object.LastModified,language);
                    fileAttr.StorageClass = object.StorageClass;
                    if (object.Key[object.Key.length - 1] != '/') {
                        var isRestored = false;
                        if(object.StorageClass == 'GLACIER' || object.StorageClass == 'Coldline'){
                            isRestored = true;
                        }
                        if(pkg.share && !isRestored){
                           isShare = true;
                        }else{
                            isShare = false;
                        }
                        var fileName = indexAction.handlePath(key, object.Key, 0);
                        fileName = fileName.toLowerCase();
                        contentList.push({
                            showKey: indexAction.getFileType(fileName) + " " + fileAttr.name.replace(new RegExp(' ','gm'),'&nbsp;'),
                            size: indexAction.getFileSize(object.Size,"",language),
                            fileType: languageJson.file,
                            storageClass: commonUtils.termStorageClass(object.StorageClass),
                            modifyDate: fileAttr.modifyTime,
                            encodedFileName: fileAttr.name,
                            hidenData: JSON.stringify(fileAttr),
                            property: languageJson.property,
                            aclConfig: languageJson.download,
                            isGLACIER: isGLACIER,
                            isRestored: isRestored,
                            isShare:isShare,
                            delete: languageJson.delete,
                            more: languageJson.more,
                            etag: fileAttr.ETag?fileAttr.ETag:"none",
                            recover: languageJson.obs_term_restore_button,
                            unique: AWS.util.crypto.sha256(object.Key,'hex'),
                            coldline : pkg.objectColdline,
                            share : languageJson.share
                        })
                    }
                }
                tbody.append(renderSync("listObjectsItemTemplate", contentList));
                if(pkg.objectColdline && isGLACIER) {
                    //如果需要更新，则批量查询当前页面中的对象恢复状态，并且更所有缓存
                    if (global.restoreCache.isUpdate(bucketName, path)) {
                        global.logger.info("Start update restore status.", global.restoreCache)
                        async.eachLimit(data.Contents, 5,function(item, callback) {
                            var object = item;
                            var objId = AWS.util.crypto.sha256(object.Key, 'hex');
                            bucketAndObjectAction.headObjectWithMD5(bucketName, object.Key, objId, function (err, data, objKey, unique) {
                                var dataKey = unique + Const("RESTORE_STATUS_SUFFIX");
                                var test = unique + Const("RECOVER_READY");
                                if (err) {
                                    global.logger.error("head object failed. object=" + objKey, err);
                                    $("#" + dataKey).html("--");
                                } else {
                                    var restoreStat = global.restoreCache.putCache(data,dataKey);
                                    var storageJson = JSON.parse($("#" + dataKey).parent().parent().find(".hiddenObjData").text());
                                    var storageType = storageJson.StorageClass;
                                    if(storageType != "GLACIER"){
                                        restoreStat = "--";
                                        global.restoreCache.data[dataKey] = restoreStat;
                                    }
                                    if(restoreStat == languageJson.obs_term_restored_lable){
                                        $("#" + unique + "_property").addClass("mui-hide");
                                        $("#"+ unique + "_download").removeClass("mui-hide");
                                    }
                                    $("#" + dataKey).html(restoreStat);
                                }
                                callback()
                            })
                        }, function(err) {
                            if(err) {
                                global.logger.error('Head object eachSeries error.', err);
                            } else {
                                global.logger.info('Head object eachSeries done.');
                            }
                        })
                    } else {
                        //不需要更新，则去缓存中取出每个对象的恢复状态
                        global.logger.info("Use cache restore status.", global.restoreCache)
                        for (var index in data.Contents) {
                            var object = data.Contents[index];
                            var objId = AWS.util.crypto.sha256(object.Key, 'hex');
                            var loopDataKey = objId + Const("RESTORE_STATUS_SUFFIX");
                            if (!global.restoreCache.data[loopDataKey]) {
                                //如果对象列表中的对象，在缓存中找不到value，则发起head请求去查询，并更新缓存
                                bucketAndObjectAction.headObjectWithMD5(bucketName, object.Key, objId, function (err, data, objKey, unique) {
                                    var dataKey = unique + Const("RESTORE_STATUS_SUFFIX");
                                    if (err) {
                                        global.logger.error("head object failed. object=" + objKey, err);
                                        $("#" + dataKey).html("--");
                                    } else {
                                        var restoreStat = global.restoreCache.putCache(data,dataKey);
                                        var storageType = JSON.parse($("#" + dataKey).parent().parent().find(".hiddenObjData").text()).StorageClass;
                                        if(storageType != "GLACIER"){
                                            restoreStat = "--";
                                            global.restoreCache.data[dataKey] = restoreStat;
                                        }
                                        if(restoreStat == languageJson.obs_term_restored_lable){
                                            $("#" + unique + "_property").addClass("mui-hide");
                                            $("#"+ unique + "_download").removeClass("mui-hide");
                                        }
                                        $("#" + dataKey).html(restoreStat);
                                    }
                                })
                            } else {
                                $("#" + loopDataKey).html(global.restoreCache.data[loopDataKey]);
                                if(global.restoreCache.data[loopDataKey] == languageJson.obs_term_restored_lable){
                                    $("#" + objId + "_property").addClass("mui-hide");
                                    $("#" + objId + "_download").removeClass("mui-hide");
                                }
                            }
                        }
                    }
                }
                //按照时间顺序排序
                var $trs = $('#objLists tbody tr[data-type="file"]');
                $trs.sort(function(a,b){
                    var t1 = $(a).find('td:eq(6)').text();
                    var t2 = $(b).find('td:eq(6)').text();
                    var x = new Date(Date.parse(t1.replace(/-/g, "/")));
                    var y = new Date(Date.parse(t2.replace(/-/g, "/")));
                    if(parseInt(x.getTime()) < parseInt(y.getTime())) return 1;
                    else return -1;
                });
                $trs.detach().appendTo('#objLists tbody');
            } catch(err) {
                global.logger.error("err", err.stack)
            }
            if(data.IsTruncated){
                pageContext.refresh = true;
            }else{
                pageContext.refresh = false;
            }
            if (pageContext.nowPage > 1) {
                setTimeout(function () {
                    pageContext.upRefresh = true;
                },500);
            }else{
                pageContext.upRefresh = false;
            }
            if (document.getElementById("listObjBodyDiv").offsetHeight < document.getElementById("listObjBodyDiv").scrollHeight) {
                $("#lastUpdateTh").css('width', '200px');
            } else {
                $("#lastUpdateTh").css('width', '200px');
            }
            if($("#objLists tbody tr").length===0){
                var showEmpty = languageJson.noData;
                var serachKey = $("#prefixSearch").val();
                if(serachKey && serachKey.length > 0) {
                    showEmpty = global.langData.noRecords
                }
                global.logger.info("serachKey=", serachKey)
                tbody.append('<div class="table-nodata"><span>' + showEmpty + '</span></div>');
            }
        }
    }

}

// 格式化小语种的时间格式，小语种时间格式为m/d/year,排序的时候parse函数无法解析,
function swapDayMonthStr(timeStr) {
    if(timeStr){
        var arr = timeStr.trim().slice(0, timeStr.trim().indexOf(" ")).trim().split("/");
        var newTimeStr = arr[2] + "/" + arr[1] + "/" + arr[0] + timeStr.trim().slice(timeStr.trim().indexOf(" "), timeStr.trim().length);
        return newTimeStr;
    }
    return "";
}

function encoderForHtml(input){
    var div = document.createElement('div');
    $(div).text(input);
    return $(div).html();
}

function encoderForText(input){
    var div = document.createElement('div');
    $(div).html(input);
    return $(div).text();
}

function calculateTime(byteLen, speed) {
    var time = Math.round(byteLen / speed);
    var min = 0;
    var hour = 0;
    var second = time;
    if (time > 59) {
        min = Math.round(time / 60);
        second = time % 60;
    }
    if (min > 59) {
        hour = Math.round(min / 60);
        var min = min % 60
    }
    if (second < 10 < 0) {
        second = '0' + second;
    }
    var spTime = second +languageJson.second;
    if(min>0){
        if (min < 10 < 0) {
            min = '0' + min;
        }
        spTime = min + languageJson.minute +spTime;
    }
    if (hour > 0) {
        if (hour < 10 < 0) {
            hour = '0' + hour;
        }
        spTime = hour + languageJson.hour + spTime;
    }
    return spTime;
}

function getTaskKey(task){
    if (task.action === 'downloadDir'||task.action === 'downloadFile') {
        task.key = task.path+task.prefix;
    }else if (task.action === 'deleteDir'){
        task.key = task.prefix;
    }
    return task;
}


function deleteTaskConsole(action){
    if($.inArray(action.id, taskArr)!==-1){
        $("#"+action.id).remove();
        refreshUI(action);
    }
}


function addToTaskConsole(id,task) {
    var taskBody = '';
    var trHtml = renderTaskConsoleItem(id,task);
    if(task.action==='uploadFile'||task.action==='uploadDir'){
        taskBody = $("#uploadTaskTab tbody");
    }else if(task.action==='downloadFile'||task.action==='downloadDir'){
        taskBody = $("#downloadTaskTab tbody");
    }else if(task.action==='deleteFile'||task.action==='deleteDir'){
        taskBody = $("#deleteTaskTab tbody");
    }
    taskBody.append(trHtml);
}

function taskUpOrDown(type) {
    if(type){
        if (type.trim() === 'uploadDir'||type.trim() === 'uploadFile') {
            type =languageJson.upload;
        } else if (type.trim() === 'downloadDir'||type.trim() === 'downloadFile') {
            type = languageJson.down;
        }else if (type.trim() === 'create'){
            type = languageJson.upload;
        }else if (type.trim() === 'deleteFile'||type.trim() === 'deleteDir'){
            type = languageJson["delete"];
        }
    }
    return type;
}



function refreshUI(task) {
    if (!isLoaded) {
        return false;
    }
    var $curBucketName = $('#curBucketName');
    var parentPath = getCurrPath();
    if (task.type.trim() === "putObj" || task.type.trim() === TaskEnum.TASK_TYPE.copy.value || task.type.trim() === TaskEnum.TASK_TYPE.move.value) {
        var file = task.key;

        if (file.substring(file.length - 1, file.length) === "/") {
            file = file.substring(0, file.length - 1);
            if (file.lastIndexOf("/") === -1) {
                file = "";
            } else {
                file = file.substring(0, file.lastIndexOf("/") + 1);
            }
        } else {
            file = file.substring(0, file.lastIndexOf("/") + 1);
        }
        var bucket = task.bucket;
        //刷新当前目录的对象列表操作
        var currBucket = $curBucketName.html();
        if(bucket === currBucket){
            if (isRefreshUI(task.key)|| parentPath === file) {
                pageContext = {};//重置分页对象
                pageContext.nowPage = 1;

                if ($("#isSearch").val()) {
                    var prefix = $("#prefixSearch").val();
                    prefix = parentPath + prefix;
                    bucketAndObjectAction.listObject(bucket, 'true', prefix, function (err, data) {
                        listObjectUI(err, data, bucket, true);
                    });
                } else {
                    bucketAndObjectAction.listObject(bucket, 'true', parentPath, function (err, data) {
                        listObjectUI(err, data, bucket, true);
                    });
                }
            }
        }
    }
    else if (task.type === "delete") {
        var file = task.key;
        if (file.substring(file.length - 1, file.length) === "/") {
            file = file.substring(0, file.length - 1);
            if (file.lastIndexOf("/") === -1) {
                file = "";
            } else {
                file = file.substring(0, file.lastIndexOf("/") + 1);
            }
        } else {
            file = file.substring(0, file.lastIndexOf("/") + 1);
        }
        var bucket = task.bucket;
        //刷新当前目录的对象列表操作
        var currBucket = $curBucketName.html();
        //判断界面是否还停留在上传对象的桶
        if (bucket === currBucket && parentPath === file) {
            if ($("#isSearch").val()) {
                var prefix = $("#prefixSearch").val();
                prefix = parentPath + prefix;
                bucketAndObjectAction.listObject(bucket, 'true', prefix, function (err, data) {
                    listObjectUI(err, data, bucket, true);
                },pageContext['page'+pageContext.nowPage]);
            } else {
                $("#prefixSearch").val('');
                $("#clearPrefixSearchInput").addClass("mui-hide");
                bucketAndObjectAction.listObject(bucket, 'true', parentPath, function (err, data) {
                    listObjectUI(err, data, bucket, true);
                },pageContext['page'+pageContext.nowPage]);
            }
        }
    }
}

function tabFocus(id) {
    //设置页面焦点事件
    $("#" + id).focus();
}


//获取账户列表信息
function getAccountListInfo(callback,isShowMsg) {
    if (!accountService) {
        return;
    }
    accountService.getAccountList(function (err,lsAccount) {
        if (lsAccount) {
            var htmlStr = "";
            var userStr = "<ul style='max-height: 500px;overflow-y: scroll'>";
            var arr = lsAccount.Accounts.Account;
            var currentId = lsAccount.Accounts.$.current.toString();
            if(arr.length>0){
                $(".btnUserInfo").css("max-width","221px");
            }else{
                $(".btnUserInfo").css("max-width","46px");
            }
            $("#accountTab tr:not(:first)").remove();
            var temp = true;
            for (var i = 0; i < arr.length; i++) {
                var showName = encoderForHtml(arr[i].Name).length>20?encoderForHtml(arr[i].Name).substring(0,20)+"...":encoderForHtml(arr[i].Name);
                if(currentUserId){
                    if(currentUserId===arr[i].ID[0]){
                        var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                        $(".btnUserInfo").html(str);
                        //优先以currentUserId作为判断当前用户的依据
                        temp = false;
                    }else if(temp&&currentId==arr[i].ID[0]){
                        var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                        $(".btnUserInfo").html(str);
                    }
                }else if(currentId==arr[i].ID[0]){
                    var str = '<span title="'+ encoderForHtml(arr[i].Name) +'" class="mui-ellipsis-2" style="color: #ffffff;">'+showName+'</span><i class="btn-account"></i>';
                    $(".btnUserInfo").html(str);
                }
                //账号列表如果都是最宽的字符，大于27则会被hiden
                var accountDomTitle = encoderForHtml(arr[i].Name).length > 27 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                htmlStr =
                    "<tr>" +
                    "<td style='padding-left: 20px;width: 340px'>" +
                    "<span "+accountDomTitle+" class='mui-ellipsis-prototype'>" + encoderForHtml(arr[i].Name) + "</span>" +
                    "</td>" +
                    "<td style='width: 120px;'>" +
                    "<a ng-click='createAccount.cleanInvalidate()' href='#' data-href='createAccount' data-id='" + arr[i].ID + "' class='mui-icon-account-edit'>"+languageJson.edit+"</a>" +
                    "<a href='#' style='margin-left: 20px;' data-href='accountList' data-id='" + arr[i].ID + "' class='mui-icon-account-del'>"+languageJson.delete+"</a>" +
                    "</td>" +
                    "</tr>";
                $("#accountTab tr:last").after(htmlStr);
                //账号列表下拉框如果都是最宽的字符，大于11则会被hiden
                var accountDomTitleDownList = encoderForHtml(arr[i].Name).length > 11 ? "title='" + encoderForHtml(arr[i].Name) +"'" : "";
                userStr +=
                    "<li>" +
                    "<a href='#' class='user mui-ellipsis-prototype' data-id='"+arr[i].ID+"' data-href='"+encoderForHtml(arr[i].Name)+"'>" +
                    "<span "+accountDomTitleDownList+" class='mui-ellipsis-prototype mui-icon-account1'>"+ encoderForHtml(arr[i].Name) +"</span>" +
                    "</a>" +
                    "</li>";
            }
            if(arr.length>0){
                userStr +='</ul>'+
                    '<li class="mui-border-before">' +
                    '<a href="#" id="accountManager" class="manager" style="padding: 4px 8px">' +
                    '<span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span>' +
                    '</a>' +
                    '</li>';
            }else{
                userStr +='</ul>'+
                    '<li>' +
                    '<a href="#" id="accountManager" class="manager" style="padding: 4px 8px">' +
                    '<span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span>' +
                    '</a>' +
                    '</li>';
            }
            $("#userList").html(userStr);
            if (callback) {
                callback(currentId);
            }
        } else {
            if(isShowMsg){
                isShowMsg=false;
                $('.mui-model').showErrorMessage({
                    message: languageJson.getConfigInfoErr,
                    obsError: obsError("getConfigInfoErr")
                });
            }
            var trs = $("#accountTab tbody").find('tr').length;
            if (trs === 1) {
                $("#changeAccount").addClass('mui-disabled');
            }
            $("#objAttr").addClass("mui-hide");//隐藏对象属性栏
            $("#path").html('');
            $("#accountTab tr:not(:first)").remove();
            var str = '<span class="mui-ellipsis-2" style="color: #ffffff;"></span><i class="btn-account"></i>';
            $(".btnUserInfo").html(str);
            $(".btnUserInfo").css("max-width","46px");
            var userStr ='<li><a href="#" id="accountManager" class="manager"><span style="max-width: 145px;" class="mui-ellipsis-tips1 mui-icon-accountmanager">'+languageJson.accountManage+'</span></a></li>';
            $("#userList").html(userStr);
            $("#downloadFileName").val("");
            pageContext = {};//重置分页对象
            pageContext.nowPage = 1;
            $("#isSearch").val("");
            $("#objContainer").html("");
            $("#objLists tbody").find('tr').each(function () {
                $(this).remove();
            });
            $("#lsBuckets").html('');
            if (callback) {
                callback();
            }
        }

    });
}


//切换账户界面变更
function changeUserUI(id){
    $("#pathInputCollect").addClass("mui-hide");
    global.inputPath = "obs://";
    $("#pathInput").val("obs://");
    var bucket = $('#curBucketName').html();
    $("#objAttr").addClass("mui-hide");//隐藏对象属性栏
    $("#path").html('');
    $("#downloadFileName").val("");
    pageContext = {};//重置分页对象
    pageContext.nowPage = 1;
    $("#isSearch").val("");
    $("#prefixSearch").val('');
    $("#bucketSearch").val('');
    $("#clearPrefixSearchInput").addClass("mui-hide");
    $('#curBucketName').html("");
    $('#curBucketName').attr("isExt","false");
    $("#objectNum").html('');
    $("#taskNum").html('0');
    $("#storageSize").html('');
    $("#lsBuckets").html('');//清空桶列表
    $("#lsBucketPaths").html('');//清空收藏路径列表
    $("#objContainer").html('');//清空对象列表
    $("#pauseQueue tbody").html('');//清空任务列表
    $("#objLists tbody").find('tr').each(function () {
        $(this).remove();
    });
    $("#bucketLists tbody").find('tr').each(function () {
        $(this).remove();
    });
    $(".bucket-delete,.mui-icon-property,.mui-icon-aclConfig,.mui-icon-more").addClass('mui-disabled');
    $("#objDiv").addClass('current');
    $("#objPanel").addClass('current');
    $("#taskDiv").removeClass('current');
    $("#taskPanel").removeClass('current');
    $("#taskNumberShowDiv").removeClass('taskNumShow');
    if($("#bucketArea").hasClass('mui-hide')){
        $("#bucketArea").removeClass('mui-hide');//桶列表和对象列表切换
        $("#objectArea").addClass('mui-hide');
        $("#objectBtnDiv").addClass('mui-hide');
        $("#bucketBtnDiv").removeClass('mui-hide');
        $("#all-back-div").addClass('all-back-btn-disabled');//后退按钮样式修改
        $("#all-back-div").removeClass('all-back-btn');
        $("#objectProDiv").addClass('mui-hide');//隐藏对象属性栏
        $("#bucketProDiv").removeClass('mui-hide');//显示桶属性栏
    }
    loaderUser(id);
}



function listMultiparUploadsUI(err,data,bucket){
    if(err){
        logger.error(err);
        if(errorConfig[err.code]){
            $('.mui-model').showErrorMessage({
                message: errorConfig[err.code],
                obsError: obsError(err.code,err.message),
                ok: function(){
                    $(".refreshCtx").click();
                    return false;
                }
            });
        }
    }else{
        var  objs = data.arr;
        pageMultipartContext = data.pageMultipartContext;
        $("#multipartTab").css("width",$("#multipartPageTab").css("width"));
        var htmlBody = "";
        var num = $("#multipartTab tbody tr").length+1;
        for (var index in objs) {
            var obj = objs[index];
            htmlBody += "<tr><td style='width: 40px;'>"+num+"</td>";
            htmlBody += "<td><span class='mui-ellipsis-multipart'>"+encoderForHtml(obj.Key)+"</span></td>";
            htmlBody += "<td style='width: 100px;text-align: right;'><span>--</span></td>";
            htmlBody += "<td style='width: 110px;text-align: right;'><span>--</span></td>";
            htmlBody += "<td style='width: 110px;'><span class='mui-ellipsis-multipart'>"+indexAction.gmtDate2LocaleDate(encoderForHtml(obj.Initiated),language)+"</span></td>";
            htmlBody += "<td style='width: 140px'><span class='mui-ellipsis-multipart'>"+encoderForHtml(obj.UploadId)+"</span></td>";
            htmlBody += "<td style='width: 75px;'><i data-id='"+encoderForHtml(obj.UploadId)+"' data-key='"+encoderForHtml(obj.Key)+"' class='mui-icon-account-clear' title='"+languageJson.delete+"'></i></td></tr> ";
            $("#multipartTab tbody").append(htmlBody);
            num++;
            htmlBody = "";
        }
        multipartNum = num - 1;
        if (document.getElementById("multipartDiv").offsetHeight < document.getElementById("multipartDiv").scrollHeight) {
            $("#operationBtn").css('width', '60px');
        } else {
            $("#operationBtn").css('width', '50px');
        }
        $("#multipartTab tbody").find('tr').each(function () {
            var self = this;
            if($(this).index()<(pageMultipartContext.nowPage-2)*20){
                return;
            }
            var uploadId = $(self).find('td').eq(5).find('span').text();
            var key = $(self).find('td').eq(1).find('span').text();
            bucketAndObjectAction.listParts(bucket,uploadId,key,0,0,0, function (err,data) {
                if(err){

                }else{
                    $(self).find('td').eq(2).find('span').text(data.count===0?1:indexAction.formatNumber(data.count,language,true));
                    $(self).find('td').eq(3).find('span').text(data.size===0?"--":indexAction.getFileSize(data.size,"",language));
                }
            });
        });
        if($("#multipartTab tbody").find('tr').length === 0){
            $("#deleteMultipart").addClass('mui-hide');
            $("#multipartTab tbody").html('<div class="dialog-table-nodata"><span>' + languageJson.noData + '</span></div>');
        }else{
            $("#deleteMultipart").removeClass('mui-hide');
        }
    }
}

function allButtonChange(type) {
    if (type === '1') {
        $("#overlay").removeClass('mui-hide');
        $("#lsBuckets").html('');//清空桶列表
        $("#isSearch").val("");
        $("#prefixSearch").val('');
        $("#clearPrefixSearchInput").addClass("mui-hide");
        $("#objectNum").html('');
        $("#storageSize").html('');
        $('#taskNum').html(0);
        selectedTable.find('tbody').html('');
        $("#objLists tbody").find('tr').each(function () {
            $(this).remove();
        });
    } else {
        $("#overlay").addClass('mui-hide');
    }
}

// 删除用户清空当前用户的桶列表
function clearBucketLists() {
    //主区域桶列表
    $("#bucketLists tbody").find('tr').each(function () {//清空桶列表（列表方式）
        $(this).remove();
    });
    //左侧桶列表
    $("#lsBuckets").html('');
    $("#bucketCreateNum").html('');
    $("#extBucketNum").html('');
    //如果页面在对象列表，则跳转到桶列表
    if($("#bucketArea").hasClass('mui-hide')){
        $("#bucketArea").removeClass('mui-hide');//桶列表和对象列表切换
        $("#objectArea").addClass('mui-hide');
        $("#objectBtnDiv").addClass('mui-hide');
        $("#bucketBtnDiv").removeClass('mui-hide');
        $("#all-back-div").addClass('all-back-btn-disabled');//后退按钮样式修改
        $("#all-back-div").removeClass('all-back-btn');
        $("#objectProDiv").addClass('mui-hide');//隐藏对象属性栏
        $("#bucketProDiv").removeClass('mui-hide');//显示桶属性栏
        $("#prefixSearch").attr('placeholder',languageJson.bucketSearchInfo);
    }
}

function getBucketStorageInfo(bucket){
    //外部桶隐藏桶存量信息
    if($('#lsBuckets .current').hasClass('ext')){
        $("#objectProDiv").addClass('mui-hide');
    }else{
        $("#objectProDiv").removeClass('mui-hide');
    }
    $("#bucketProDiv").addClass('mui-hide');//隐藏桶属性栏
    bucketAttributeAction.getBucketStorageInfo(bucket,function(err,data){
        if(!err){
            if(data && data.ObjectNumber){
                $("#objectNum").html(indexAction.formatNumber(data.ObjectNumber,language,true));
            }else{
                $("#objectNum").html(indexAction.formatNumber(0,language,true));
            }
            if(data && data.Size){
                $("#storageSize").html(indexAction.getFileSize(data.Size,"",language));
            }else{
                $("#storageSize").html(indexAction.getFileSize(0,"",language));
            }
        }
    });
}

function getTaskNum(){
    if(nowstat==='RUNNING'){
        var trs = $("#"+selected+" tbody tr").length;
        $('#taskNum').html(trs);
    }else{
        var query={};
        if("uploadTaskDiv"===selected){
            //加载上传任务
            query={type:"putObj",stat:nowstat};
        }else if("downloadTaskDiv"===selected){
            //加载下载传任务
            query={type:"getObj",stat:nowstat};
        }else if("deleteTaskDiv"===selected){
            //加载删除任务
            query={type:"delete",stat:nowstat};
        }else if("recoverTaskDiv"===selected){
            //加载删除任务
            query={type:"recover",stat:nowstat};
        }
        if(nowstat===""){
            query.stat={"$ne":"SUCCESS"};
        }
        taskManager.countTasks(query,function(err,data){
            if(data){
                $('#taskNum').html(indexAction.formatNumber(data,language,true));
                if(nowstat==="" && $("#uploadAction").parent().hasClass('current')){
                    $("#uploadAction").html(languageJson.upload+" ("+indexAction.formatNumber(data,language,true)+")");
                }else if(nowstat==="" && $("#downloadAction").parent().hasClass('current')){
                    $("#downloadAction").html(languageJson.down+" ("+indexAction.formatNumber(data,language,true)+")");
                }else if(nowstat==="" && $("#delAction").parent().hasClass('current')){
                    $("#delAction").html(languageJson.delete+" ("+indexAction.formatNumber(data,language,true)+")");
                }else if(nowstat==="" && $("#recoverAction").parent().hasClass('current')){
                    $("#recoverAction").html(languageJson.recover+" ("+indexAction.formatNumber(data,language,true)+")");
                }
            }else{
                $('#taskNum').html(0);
            }
        });
    }
}

//=========================================老版本任务控制==============================


var i= 0;

function removeTask(task) {
    if($("#taskPanel").hasClass('mui-active')&&isReloadTask(task.type)) {
        var tr = selectedTable.find("tr[id='" + task.id + "']");
        if (tr.hasClass('task')) {
            tr.remove();
        } else {
            reloadTasks();
        }
        if ("" === nowstat || "WAIT" === nowstat) {
            var showAllSize = selectedTable.find('tr').length;//界面显示任务列表
            var html = "";
            if (showAllSize < 20) {
                reloadTasks();
            }
        }
    }
}

function isReloadTask(type){
    if((type==='putObj'&&selected==='uploadTaskDiv')||(type==='getObj'&&selected==='downloadTaskDiv')
        ||(type==='delete'&&selected==='deleteTaskDiv')||(type==='recover'&&selected==='recoverTaskDiv')){
        return true;
    }else{
        return false;
    }
}

function renderTaskConsoleItemBody(task) {

}

function renderTaskConsoleItem(task,stat) {

}

function isShowRunningTask(type){
    if(selected==='uploadTaskDiv'&& type === 'putObj'){
        return true;
    }else if(selected==='downloadTaskDiv'&& type === 'getObj'){
        return true;
    }else if(selected==='deleteTaskDiv'&& type === 'delete'){
        return true;
    }else if(selected==='recoverTaskDiv'&& type === 'recover'){
        return true;
    }else{
        return false;
    }
}

function addToTask(task) {
    if(selectedTable.find('tr').length<51){
        var tr = selectedTable.find("tr[id='" + task.id + "']");
        if (tr.hasClass('task')) {
            tr.remove();
        }
        selectedTable.css("width",$("#taskTabHead").css("width"));
        var trHtml = renderTaskConsoleItem(task);
        selectedTable.find('tbody').append(trHtml);
    }
}


function refresh(task, evt) {
    var tm = new Date();
    if (!task.tickTime) {
        task.tickTime = tm.getTime();
        task.tickLoaded = evt.loaded;
        task.speeds = [];
        task.tickCount = 0;
    }
    else if ((tm.getTime() - task.tickTime) > 1000) {
        var tickTotal = evt.loaded - task.tickLoaded;
        var send = (tm.getTime() - task.tickTime) / 1000;
        var speed = Math.floor(tickTotal / send);//每秒 向下取整
        //去抖动算法
        task.tickCount++;
        if (task.tickCount > 9) {
            task.tickCount = 0;
        }
        task.speeds[task.tickCount] = speed;
        if (task.speeds.length > 8) {
            var tSp = 0;
            for (var i = 0; i < task.speeds.length; i++) {
                tSp += task.speeds[i];
            }
            //平均速度
            speed = tSp / task.speeds.length;
        }
        var spTime = calculateTime(Math.abs(evt.total - evt.loaded), speed);
        var u = 'byte/s';
        if (speed > 1024) {
            speed = speed / 1024.0;//kb每秒
            u = 'KB/s';
        }
        if (speed > 1024) {
            speed = speed / 1024.0;//mb每秒
            u = 'MB/s';
        }

        speed = Math.round(speed * 100) / 100;

        if (speed > 0) {
            task.speed = indexAction.formatNumber(speed,language) + u;
            task.spTime = spTime;
        }
        task.tickTime = tm.getTime();
        task.tickLoaded = evt.loaded;
    }
    var per = 0;
    if (task.position) {
        var position = task.position;

        var loaded = evt.loaded + position;
        var total = Number(evt.total) + position;

        per = Math.round((loaded / total * 10000)) / 100.00;
    } else {
        per = Math.round((evt.loaded / evt.total * 10000)) / 100.00;
    }
    if(!per || per<0){
        per=0;
    }
    //处理进度异常情况
    per = commonUtils.handlePer(per,task.progress);
    task.progress = per + "%";
}

var lastReload=0;


/**
 *重新加载任务列表
 * @param isCompel bool:是否忽略上次刷新时间，强制刷新
 */
function reloadTasks(isCompel){
    return;  //待删除
}

function taskStatChinese(stat,task) {
    if(stat){
        if (stat.trim() === 'RUNNING') {
            stat = languageJson.running;
        } else if (stat.trim() === 'WAIT') {
            stat =languageJson.wait;
        } else if (stat.trim() === 'PAUSE') {
            stat = languageJson.paused;
        }else if (stat.trim() === 'RESTORING') {
            stat = languageJson.obs_term_restoring_lable;
        }else if (stat.trim() === 'SUCCESS') {
            stat = languageJson.obs_term_success_label;
        }else if (stat.trim() === 'FAILED') {
            if(task && nowstat===''){
                var errmsg = '';
                if(errorConfig[task.errMessage]){
                    errmsg = errorConfig[task.errMessage].lastIndexOf("。")>0||errorConfig[task.errMessage].lastIndexOf(".")>0
                        ? errorConfig[task.errMessage].substring(0,errorConfig[task.errMessage].length-1)
                        : errorConfig[task.errMessage];
                    var obsErrorObj = obsError(task.errMessage,"");
                    errmsg = obsErrorObj ? obsErrorObj.description : errmsg;
                }else if(task.errMessage){
                    errmsg = task.errMessage
                }else{
                    errmsg = languageJson.undefinedError;
                }

                //失败状态后追加失败原因的tips显示图标
                stat = languageJson.failed+"<i class='mui-icon-task-failed' title='"+errmsg+"'></i>";
            }else{
                stat = languageJson.failed;
            }
        }
    }
    return stat;
}

/*
 刷新任务控制台"所有table"列表的状态
 */
function refrchStat(task){
    var trHtml = renderTaskConsoleItemBody(task);
    var tr = selectedTable.find("tr[id='"+task.id+"']");
    if(tr.hasClass("task")) {
        tr.html(trHtml);
    }else{
        addToTask(task);
    }
}

//判断上传子文件夹内对象成功时是否刷新对象列表
function isRefreshUI(key){
    if(!key){
        return false;
    }
    if(pageContext.nowPage != 1){
        return false;
    }

    var path = getCurrPath();
    var newFolder = key;
    if(path.length>0) {
        if(key.indexOf(path) === 0){
            newFolder = key.substr(path.length,key.length);//去头
        }else{
            return false;
        }
    }
    if(newFolder.indexOf("/")===-1){
        return false;//不是文件夹或者不是子目录下的文件
    }
    newFolder = newFolder.substr(0,newFolder.indexOf("/")+1);//去尾


    for(var i in folderList){
        if(newFolder===folderList[i]){
            return false;//已经存在
        }
    }

    if(folderList.length===50){
        //用最后一个比较ascII顺序
        if(comp(folderList[49],newFolder)<0){
            return false;
        }
    }
    return true;
}

/**
 * 保存当前所有目录
 * @param data
 */
function setLocalFolders(data){
    folderList = [];
    var path = getCurrPath();
    if(path==="") {
        for (var i in data) {
            folderList.push(data[i].Prefix);
        }
    }else{
        for (var i in data) {
            folderList.push(data[i].Prefix.substr(path.length,data[i].Prefix.length));
        }
    }
}


/**
 *ascII序比较
 *  a=b 0
 * a<b -1
 * a>b 1
 */
function comp(a,b) {
    if (a === b) {
        return 0;
    } else {
        var length = a.length < b.length ? a.length : b.length;
        for (var i = 0; i < length; i++) {
            if (a[i].charCodeAt() < b[i].charCodeAt()) {
                return -1;
            }
            else if (a[i].charCodeAt() > b[i].charCodeAt()) {
                return 1;
            }
        }
        return a.length < b.length ? -1 : 1;
    }
}

/**
 * 是否有运行的任务
 * @returns {boolean}
 */
function hasRunning(){
    var hasRunning = false;
    if(taskManager && taskManager.runningMap){
        for(var id in taskManager.runningMap){
            if(id){
                hasRunning = true;
                break;
            }
        }
    }
    return hasRunning;
}
function hasMovingTask(callback) {
    if(self.taskManager) {
        self.taskManager.countTasks({type: "move", stat: "RUNNING"}, function (err, data) {
            callback(err, data);
        });
    } else {
        callback("", 0);
    }
}

function isTaskDiv(){
    if($("#taskPanel").hasClass('mui-active')){
        return true;
    }
    return false;
}

function deleteRubbishBucket(bName,stat){
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
    }
    if ($("#mui-overlay").size() > 0) {
        mui.overlay('off');
    }
    var option = {};
    option.timeout = 300000;
    var loading = loadingShow(option);
    bucketAndObjectAction.deleteAllMultipartUploads($('#curBucketName').html(), '', '', '', function (err,data) {
        if(err){
            loading.close();
            if(errorConfig[err.code]){
                var msg = languageJson.deleteAllMultipartErr + errorConfig[err.code];
                $('.mui-model').showErrorMessage({
                    message: languageJson.deleteAllMultipartErr + (obsError(err.code) ? obsError(err.code).description :  errorConfig[err.code]),
                });
            }
        }else{
            bucketAndObjectAction.deleteBucket(
                bName,
                function (err,data) {
                    if(err){
                        if (errorConfig[err.code]) {
                            $('.mui-model').showErrorMessage({
                                message: errorConfig[err.code],
                                obsError: obsError(err.code,err.message)
                            });
                        }
                        loading.close();
                    }else{
                        $('.mui-model').showMessage({
                            message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(bName))),
                            ok: function () {
                                return false;
                            },
                            title: languageJson.info
                        });
                        //刷新桶列表
                        lastBucket = '';
                        $("#curBucketName").html('');
                        $("#objectNum").html('');
                        $("#storageSize").html('');
                        bucketAndObjectAction.listBucket(function (err, data) {
                            $("#path p").children().each(function () {
                                $(this).remove();
                            });
                            listBucketUI(err,data,loading);
                        });
                        loading.close();
                    }
                }
            );
        }
    },'',-1);
}

function deleteBucket(bName,stat){
    if (!$(".mui-model.mui-model-mini").hasClass('shown')) {
        showOverlay();
    }
    $('.mui-model').showMessage(
        {
            type: "warning",
            message: languageJson.isSureDeleteBucket,
            ok: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                if($('#lsBuckets .bucket-item.current').hasClass('ext')){
                    bucketAndObjectAction.deleteExtBucket(bName,ExtBucket,currentUserId, function (data) {
                        indexAction.writeExBucket(data);
                        setTimeout(function () {
                            $('.mui-model').showMessage({
                                message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(bName))),
                                ok: function () {
                                    return false;
                                },
                                title: languageJson.info
                            });
                        },100);
                        //刷新桶列表
                        var loading = loadingShow();
                        lastBucket = '';
                        $("#curBucketName").html('');
                        $("#objectNum").html('');
                        $("#storageSize").html('');
                        bucketAndObjectAction.listBucket(function (err, data) {
                            $("#path p").children().each(function () {
                                $(this).remove();
                            });
                            listBucketUI(err,data,loading);
                        });
                    });
                }else{
                    var loading = loadingShow();
                    bucketAndObjectAction.deleteBucket(
                        bName,
                        function (err,data) {
                            if(err){
                                loading.close();
                                if (errorConfig[err.code]) {
                                    if (err.code === 'BucketNotEmpty' && stat) {
                                        $('.mui-model').showErrorMessage({
                                            message: CommonUtils.format(languageJson.deleteBucketErrMsg, CommonUtils.encodeForHTML(CommonUtils.substr32(bName)))
                                        });
                                    } else {
                                        $('.mui-model').showErrorMessage({
                                            message: errorConfig[err.code],
                                            obsError: obsError(err.code,err.message)
                                        });
                                    }
                                }
                            }else{
                                $('.mui-model').showMessage({
                                    message: CommonUtils.format(languageJson.deleteBucketSuccess, CommonUtils.encodeForHTML(CommonUtils.substr32(bName))),
                                    ok: function () {
                                        return false;
                                    },
                                    title: languageJson.info
                                });
                                //刷新桶列表
                                lastBucket = '';
                                $("#curBucketName").html('');
                                $("#objectNum").html('');
                                $("#storageSize").html('');
                                bucketAndObjectAction.listBucket(function (err, data) {
                                    $("#path p").children().each(function () {
                                        $(this).remove();
                                    });
                                    listBucketUI(err,data,loading);
                                });
                                loading.close();
                            }
                        }
                    );
                }
            },
            cancel: function () {
                if ($("#mui-overlay").size() > 0) {
                    mui.overlay('off');
                }
                return false;
            },
            title: languageJson.deleteBucket
        }
    );
}


function initProxy(){
    var point = false;
    if(proxy&&proxy.isProxy){
        point = 'http://';
        if(proxy.isAuthentication){
            point = point+proxy.proxyUserName+':'+proxy.proxyPwd+'@';
        }
        if(proxy.isProxy){
            if(proxy.proxyPort){
                point = point+proxy.proxyIP+':'+proxy.proxyPort;
            }else{
                point = point+proxy.proxyIP+':8080';
            }
        }
        global.agentOption = point;
    }
}

function updatePwd(callback){
    temp = {};
    async.parallel([
        function(call) {
            accountService.getAccountList(function (err,accObject) {
                if(err){
                    call(err,accObject);
                }else{
                    if(accObject && accObject.Accounts && accObject.Accounts.Account){
                        async.eachSeries(accObject.Accounts.Account, function(item, cb) {
                            global.Tools.decode(item.ID.toString(),item.SecretKey.toString(),function(err,encryptText){
                                if(err){
                                    call(err,accObject);
                                }else{
                                    global.Tools.changePwd('',encryptText,function(err,decodeText,domain){
                                        if(domain){
                                            temp[item.ID.toString()] = domain;
                                        }
                                        item.SecretKey = decodeText;
                                        cb(err);
                                    });
                                }
                            });
                        }, function(err) {
                            call(err,accObject);
                        });
                    }else{
                        call();
                    }
                }
            });
        },
        function(call) {
            indexAction.loadSetting(function (configObj) {
                if(configObj && configObj.proxy && configObj.proxy.proxyPwd){
                    global.Tools.changePwd(temp.proxyPwd,configObj.proxy.proxyPwd,function(err,encryptText,domain){
                        if(domain){
                            temp.proxyPwd = domain;
                        }
                        configObj.proxy.proxyPwd = encryptText;
                        call(err,configObj);
                    });
                }else{
                    call(null,configObj);
                }
            });
        },
        function(call) {
            if(global.newMongoPwd){
                global.Tools.decode('mongoPwd',global.newMongoPwd, function (err,encrypted) {//sk解密
                    if(err){
                        call(err);
                    }else{
                        global.Tools.changePwd(temp.mongoPwd,encrypted,function(err,encryptText,domain){
                            if(domain){
                                temp.mongoPwd = domain;
                            }
                            call(err,encryptText);
                        });
                    }
                });
            }else{
                call(null);
            }
        }
    ], function (err, results) {
        if(err){
            global.logger.info('update the key failed!');
            callback();
        }else{
            var accObject = results[0];
            var sysObject = results[1];
            if(sysObject && results[2]){
                sysObject.mongoAuthPwd = results[2];
            }
            temp.createTime = new Date().getTime();
            try{
                var xml2js = require('./node_modules/xml2js');
                var builder = new xml2js.Builder();
                var xml = builder.buildObject(accObject);//json对象转成xml文件
                fs.writeFileSync(lanpath + 'accounts.xml', xml);
                var b = new Base64();
                var base64Str = b.encode(JSON.stringify(sysObject));
                fs.writeFileSync(lanpath + 'setting', base64Str);
                fs.writeFileSync(lanpath + 'temp', JSON.stringify(self.temp));
                global.logger.debug('update the key success!');
                callback();
            }catch(err){
                callback();
            }
        }
    });
}

//创建本地文件系统文件夹
function createLocalFolder(path,callback){
    var fatherPath=path.substring(0,path.lastIndexOf("/",path.length-2)+1);
    if(fs.existsSync(fatherPath)){
        fs.mkdirSync(path);
    } else {
        logger.info("fatherPath:", fatherPath);
        createLocalFolder(fatherPath);
    }
};

//创建任务时显示动画效果
function showCreateTasksAnimation(){
    var pd = {left: $(window).width()/2, top: $(window).height()/2};//起点位置
    var location = getNodeLocation("btnTaskManage");
    var pb = {left: location.popX, top: location.popY};//终点位置
    $("#taskCreate").css({left: pd.left, top: pd.top});//从起点位置开始
    $("#taskCreate").fadeIn().animate({
        left: pb.left,
        top: pb.top
    }, 500,function(){//1秒内完成动画，可以设置动画速度,完了隐藏
        $("#taskCreate").fadeOut();
        refreshTaskNum();//刷新任务数量
    });
}
$("#hasFailedTasks").hide();
setInterval(function () {
    refreshTaskNum();
},1000);

function refreshTaskNum(){
    var self = this;
    if(!self.taskManager){
        return false;
    }
    async.parallel([
            function (cb) {
                self.taskManager.countTasks({$and:[{stat: {"$ne": "SUCCESS"}},{stat: {"$ne": "MD5SUCCESS"}},{stat: {"$ne": "skip"}}]}, function (err,data) {
                    cb(err,data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({$or:[{stat: "SUCCESS"},{stat: "MD5SUCCESS"},{stat: "skip"}]}, function (err, data) {
                    cb(err, data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({}, function (err, data) {
                    cb(err, data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({stat: "FAILED"}, function (err, data) {
                    cb(err, data);
                });
            },
            function (cb) {
                self.taskManager.countTasks({$or:[{stat:'RUNNING'},{stat:'WAIT'},{stat:'RESTORING'}]}, function (err, data) {
                    cb(err, data);
                });
            }],
        function (err,results) {
            if(err){
                global.logger.error('refreshTaskNum error:',err);
                if(err.message && err.message.indexOf('write ECONNRESET') > -1){
                    $('.mui-model').showErrorMessage({
                        message:languageJson.obs_mongodbAbnormal_msg,
                        ok:function(){
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            gui.App.quit();
                            return false;
                        },
                        cancel:function () {
                            if ($("#mui-overlay").size() > 0) {
                                mui.overlay('off');
                            }
                            return false;
                        }
                    });
                    showOverlay();
                    return false;
                }
            }
            if(results){
                var runningNum = results[0];
                var completeNum = results[1];
                var allTaskNum = results[2];
                var failedTaskNum = results[3];
                var transportTaskNum = results[4];

                $("#runingTaskCount").text(indexAction.formatNumber(encoderForHtml(runningNum),language,true));
                $("#completeTaskCount").text(indexAction.formatNumber(encoderForHtml(completeNum),language,true));
                $("#totalTaskCount").text(indexAction.formatNumber(encoderForHtml(allTaskNum),language,true));
                //runningNum是所有不为SUCCESS的任务，包含failed、runnning、waiting、restoring、suspended

                if(hasRunning() || transportTaskNum > 0){//判断是否有任务正在运行
                    $(".btnTaskManage").addClass('running');
                    isTaskDone = true;
                }else{
                    $(".btnTaskManage").removeClass('running');
                    if(isTaskDone) {
                        $("#all-refresh-div").click();
                    }
                    isTaskDone = false;
                }

                if(failedTaskNum > 0) {
                    $("#hasFailedTasks").show();
                } else {
                    $("#hasFailedTasks").hide();
                }
            }
        }
    )
}

function deletedCheck(data,bucket,cb){
    var arr = data;
    var queryObj = {};
    queryObj["bucket"] = bucket;
    queryObj.stat={$and:[{"$ne":"SUCCESS"},{"$ne":"MD5SUCCESS"}]};
    queryObj.type={"$ne":"recover"};
    global.logger.info("delete target:", arr);
    async.eachSeries(arr, function(item, callback) {
        try{
            item = item.replace(/\$/g,'\\$').replace(/\&/g,'\\&').replace(/\^/g,'\\^').replace(/\+/g,'\\+');
            item = item.replace(/\?/g,'\\?').replace(/\*/g,'\\*').replace(/\%/g,'\\%').replace(/\@/g,'\\@');
            item = item.replace(/\#/g,'\\#').replace(/\!/g,'\\!').replace(/\_/g,'\\_').replace(/\(/g,'\\(').replace(/\)/g,'\\)');
            queryObj["key"] = new RegExp('^'+item);//前缀查询条件
            global.logger.info("delete check query:", queryObj);
            taskManager.deletedCheckQuery(queryObj, function (err,data) {
                if(!err && data){//如果查询出数据，则表示当前文件夹下存在未完成的任务，不能删除
                    callback('return true');
                }else{
                    callback();
                }
            })
        }catch(e){//如果出现异常，则不校验文件夹下是否有任务，判定可以删除。
            callback();
        }
    }, function(err) {
        if(err){
            cb(true);
        }else{
            cb();
        }
    });
}

function showOverlay(){
    mui.overlay('on', {static: true,keyboard:false});
}

function deleteFolder(path) {
    var files = [];
    if(fs.existsSync(path) ) {
        files = fs.readdirSync(path);
        files.forEach(function(file,index){
            var curPath = path + "/" + file;
            if(fs.statSync(curPath).isDirectory()) {
                deleteFolder(curPath);
            } else { // delete file
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
    }
}

function copyFile(sourcePath, desPath) {
    if(fs.existsSync(sourcePath)){
        var readStream1 = fs.createReadStream(sourcePath);
        var writeStream1 = fs.createWriteStream(desPath);
        readStream1.pipe(writeStream1);
        readStream1.on('end',function(){
            return true;
        });
    }
}

function backupAccountInfos() {
    var sourcePath = global.appDataPath;
    var backupPath = global.appDataPath.replace("obs", "obs2");
    if(sourcePath){
        if(!fs.existsSync(backupPath)){
            fs.mkdirSync(backupPath);
        }
        var accountsPath = backupPath+"/accounts.xml";
        var settingPath = backupPath+"/setting";
        var tempPath = backupPath+"/temp";
        async.parallel([
            function(cb1) {
                if (fs.existsSync(sourcePath + "/accounts.xml")) {
                    var readStream1 = fs.createReadStream(sourcePath + "/accounts.xml");
                    var writeStream1 = fs.createWriteStream(accountsPath);
                    readStream1.pipe(writeStream1);
                    readStream1.on('end', function () {
                        cb1(null, true);
                    });
                    readStream1.on('error', function (err) {
                        cb1(err, false);
                    });
                }
            },
            function(cb2) {
                if(fs.existsSync(sourcePath+"/setting")){
                    var readStream2 = fs.createReadStream(sourcePath+"/setting");
                    var writeStream2 = fs.createWriteStream(settingPath);
                    readStream2.pipe(writeStream2);
                    readStream2.on('end',function(){
                        cb2(null, true);
                    });
                }
            },
            function(cb3) {
                if(fs.existsSync(sourcePath+"/temp")){
                    var readStream = fs.createReadStream(sourcePath+"/temp");
                    var writeStream = fs.createWriteStream(tempPath);
                    readStream.pipe(writeStream);
                    readStream.on('end',function(){
                        cb3(null, true);
                    });
                }
            }

        ],function(err, results){
            if(err){
                logger.error('Copy backup files err: ', err);
                return;
            }
            var copyFinished1 = results[0];
            var copyFinished2 = results[1];
            var copyFinished3 = results[2];
            if(copyFinished1 && copyFinished2 && copyFinished3){
                gui.Window.get().close(true);
            }
        });
    }
}

process.on('uncaughtException', function (err) {
    logger.error('Uncaught exception: ', err.stack);
    if(err.stack.indexOf('mongodbUI')>-1){
        var path = global.mongodbPath.replace(/\\/g, "/");
        if((/[\u4e00-\u9fa5]/).test(path)){//路径为中文则弹出修改路径窗口
            $("#dbPath1").val(path);
            $(".mui-page-full.shown").removeClass('shown');
            $("#mongodbPath").removeClass('mui-hide');
            $("#mongodbPath").addClass('shown');
            divDragFunc('mongodbPathDrag','mongodbPath');
        }else{
            $('.mui-model').showMessage({
                type: "warning",
                message: languageJson.obs_mongodbUI,
                isFocus: true,
                ok: function () {
                    // 开始备份账户信息
                    backupAccountInfos();
                },
                cancel: function () {
                    if ($("#mui-overlay").size() > 0) {
                        mui.overlay('off');
                    }
                    return false;
                },
                title: languageJson.warning
            });
        }
        showOverlay();
    }
});

/**
 * 初始化tiny相应的组件
 */
function initTinyCompnents(){
    requirejs(['./tinyui/i18n/de-de/tiny2Language.js',
        './tinyui/i18n/en-us/tiny2Language.js',
        './tinyui/i18n/es-es/tiny2Language.js',
        './tinyui/i18n/fr-fr/tiny2Language.js',
        './tinyui/i18n/pt-br/tiny2Language.js',
        './tinyui/i18n/zh-cn/tiny2Language.js',], function(de_de, en_us, es_es, fr_fr, pt_br, zh_cn){
        switch(language){
            case "en":
                tiny.language = en_us;
                break;
            case "zh":
                tiny.language = zh_cn;
                break;
            case "French":
                tiny.language = fr_fr;
                break;
            case "German":
                tiny.language = de_de;
                break;
            case "Portuguese":
                tiny.language = pt_br;
                break;
            case "Spanish":
                tiny.language = es_es;
                break;
        }
        setTimeout(taskPanelCtrl(), 2000);
    });
    objButtonCtrl();
    CDNChildCtrl();
    createAccountCtrl();
    createBucketCtrl();
    changeStorageCtrl();
    changeObjectStorageCtrl();
    LoggingCtrl();
    PathCtrl();
    createPolicyCtrl();
    DateCtrl();
    recoverObjectCtrl();
    shareObjectCtrl();
    recoverFloderCtrl();
    ctxMenuCtrl();
    createPathCtrl();
    createFloderCtrl();

}

function initDepondLang(){
    $("input[type='number']").each(function(){
        var min = $(this).attr('min');
        var max = $(this).attr('max');
        if(min && max){
            $(this).attr("title", languageJson.obs_term_integerRange_tip.format(min));
        }
    })
    $("input[type='number']").on('mouseenter',function(){
        var min = $(this).attr('min');
        var max = $(this).attr('max');
        if($(this).val() === max){
            $(this).attr("title", languageJson.obs_term_bucketLifecycle_ruleMaxDays_tip.format(max));
            return;
        }
        if(min && max){
            $(this).attr("title", languageJson.obs_term_integerRange_tip.format(min));
        }
    })
}

function checkColdline(coldline){
    if(coldline){
        $("#bucketHeadStorage").removeClass('mui-hide');
    }
}
function checkObjectColdline(coldline){
    if(coldline){
        $("#objHeadStorage").removeClass('mui-hide');
    }
}

global.isPartnerCloudF = function (region) {
    var i;
    for (i in window.partnerClouds) {
        if (region == window.partnerClouds[i]) {
            return true;
        }
    }
    return false;
}